#! /bin/bash

# ---------------------------------------------------
# Download Helpscript
# ---------------------------------------------------
# Created by Karsten Feilke (22.10.2006)
# This script checks if all external packages exist
# in the local cache. If anything is missing, it 
# will be downloaded from the web. 
# ---------------------------------------------------

Check_and_get(){
	if test -f Build_Env_Webcache/$1; then
	   echo "FILE $1 already exists ... (OK)"
	else 
	   echo "Transfering $2 ...."
	   wget -P Build_Env_Webcache/ $2
	   echo "$2 Transfered ....(OK)"
	fi
	}

BUILDROOT_FILE=buildroot-snapshot.tar.bz2
BUILDROOT_URL=http://buildroot.uclibc.org/downloads/snapshots/$BUILDROOT_FILE
Check_and_get $BUILDROOT_FILE $BUILDROOT_URL

# For Version 191
BUILDROOT_FILE=buildroot-20061129.tar.bz2
BUILDROOT_URL=http://buildroot.uclibc.org/downloads/snapshots/$BUILDROOT_FILE
Check_and_get $BUILDROOT_FILE $BUILDROOT_URL

KERNEL24_FILE=linux-2.4.29.tar.gz
KERNEL24_URL=http://ftp.kernel.org/pub/linux/kernel/v2.4/$KERNEL24_FILE
Check_and_get $KERNEL24_FILE $KERNEL24_URL

UCLINUX24_FILE=uClinux-2.4.29-uc0.diff.gz
UCLINUX24_URL=http://www.uclinux.org/pub/uClinux/uClinux-2.4.x/$UCLINUX24_FILE
Check_and_get $UCLINUX24_FILE $UCLINUX24_URL

KERNEL26_FILE=linux-2.6.16.9.tar.bz2
KERNEL26_URL=http://www.kernel.org/pub/linux/kernel/v2.6/$KERNEL26_FILE
Check_and_get $KERNEL26_FILE $KERNEL26_URL

# For Version 191
KERNEL26_FILE=linux-2.6.18.3.tar.bz2
KERNEL26_URL=http://www.kernel.org/pub/linux/kernel/v2.6/$KERNEL26_FILE
Check_and_get $KERNEL26_FILE $KERNEL26_URL

SQUASHFS_FILE=squashfs3.0.tar.gz
SQUASHFS_URL=http://puzzle.dl.sourceforge.net/sourceforge/squashfs/$SQUASHFS_FILE
Check_and_get $SQUASHFS_FILE $SQUASHFS_URL

BUSYBOX10_FILE=busybox-1.00.tar.gz
BUSYBOX10_URL=http://www.busybox.net/downloads/$BUSYBOX_FILE
Check_and_get $BUSYBOX10_FILE $BUSYBOX10_URL

BUSYBOX12_FILE=busybox-1.2.1.tar.bz2
BUSYBOX12_URL=http://www.busybox.net/downloads/$BUSYBOX12_FILE
Check_and_get $BUSYBOX12_FILE $BUSYBOX12_URL

BUSYBOX122_FILE=busybox-1.2.2.tar.bz2
BUSYBOX122_URL=http://www.busybox.net/downloads/$BUSYBOX12_FILE
Check_and_get $BUSYBOX122_FILE $BUSYBOX122_URL

ZLIB123_FILE=zlib-1.2.3.tar.bz2
ZLIB123_URL=http://www.zlib.net/$ZLIB123_FILE
Check_and_get $ZLIB123_FILE $ZLIB123_URL

DROPBEAR048_FILE=dropbear-0.48.1.tar.gz
DROPBEAR048_URL=http://matt.ucc.asn.au/dropbear/releases/$DROPBEAR048_FILE
Check_and_get $DROPBEAR048_FILE $DROPBEAR048_URL

IPROUTE226_FILE=iproute2-2.6.14-051107.tar.gz
IPROUTE226_URL=http://developer.osdl.org/dev/iproute2/download/$IPROUTE226_FILE
Check_and_get $IPROUTE226_FILE $IPROUTE226_URL

# For Version 191
IPROUTE226_FILE=iproute2-2.6.18-061002.tar.gz
IPROUTE226_URL=http://developer.osdl.org/dev/iproute2/download/$IPROUTE226_FILE
Check_and_get $IPROUTE226_FILE $IPROUTE226_URL

IPTABLES135_FILE=iptables-1.3.5.tar.bz2
IPTABLES135_URL=http://ftp.netfilter.org/pub/iptables/$IPTABLES135_FILE
Check_and_get $IPTABLES135_FILE $IPTABLES135_URL

NCURSES55_FILE=ncurses-5.5.tar.gz
NCURSES55_URL=http://ftp.gnu.org/pub/gnu/ncurses/$NCURSES55_FILE
Check_and_get $NCURSES55_FILE $NCURSES55_URL

NTP42_FILE=ntp-4.2.0.tar.gz
NTP42_URL=http://www.eecis.udel.edu/~ntp/ntp_spool/ntp4/ntp-4.2/$NTP42_FILE
Check_and_get $NTP42_FILE $NTP42_URL

OPENSSL097E_FILE=openssl-0.9.7e.tar.gz
OPENSSL097E_URL=http://www.openssl.org/source/$OPENSSL097E_FILE
Check_and_get $OPENSSL097E_FILE $OPENSSL097E_URL

LIBC26_FILE=linux-libc-headers-2.6.12.0.tar.bz2
LIBC26_URL=http://ep09.pld-linux.org/~mmazur/linux-libc-headers/$LIBC26_FILE
Check_and_get $LIBC26_FILE $LIBC26_URL

UCLIBC_FILE=uClibc-0.9.28.tar.bz2
UCLIBC_URL=http://www.uclibc.org/downloads/$UCLIBC_FILE
Check_and_get $UCLIBC_FILE $UCLIBC_URL

BINUTILS216_FILE=binutils-2.16.91.0.7.tar.bz2
BINUTILS216_URL=ftp://ftp.kernel.org/pub/linux/devel/binutils/$BINUTILS216_FILE
Check_and_get $BINUTILS216_FILE $BINUTILS216_URL

GCC346_FILE=gcc-3.4.6.tar.bz2
GCC346_URL=http://ftp.gnu.org/gnu/gcc/gcc-3.4.6/$GCC346_FILE
Check_and_get $GCC346_FILE $GCC346_URL

SAMBA_FILE=samba-3.0.23c.tar.gz
SAMBA_URL=http://de.samba.org/samba/ftp/old-versions/$SAMBA_FILE
Check_and_get $SAMBA_FILE $SAMBA_URL

MPG123_FILE=mpg123-0.59r.tar.gz
MPG123_URL=http://www.mpg123.de/mpg123/$MPG123_FILE
Check_and_get $MPG123_FILE $MPG123_URL

SPEEX_FILE=speex-1.0.5.tar.gz
SPEEX_URL=http://downloads.us.xiph.org/releases/speex/$SPEEX_FILE
Check_and_get $SPEEX_FILE $SPEEX_URL

MTD_FILE=mtd_20050122.orig.tar.gz
MTD_URL=http://ftp.debian.org/debian/pool/main/m/mtd/$MTD_FILE
Check_and_get $MTD_FILE $MTD_URL


ASTPROMPT_FILE=ast_prompts_de_v2_0.tar.gz
ASTPROMPT_URL=http://www.stadt-pforzheim.de/asterisk/dateien/$ASTPROMPT_FILE
Check_and_get $ASTPROMPT_FILE $ASTPROMPT_URL

EXPECT_FILE=expect.tar.gz
EXPECT_URL=http://expect.nist.gov/$EXPECT_FILE
Check_and_get $EXPECT_FILE $EXPECT_URL

OPROFILE_FILE=oprofile-0.9.1.tar.gz
OPROFILE_URL=http://mesh.dl.sourceforge.net/sourceforge/oprofile/$OPROFILE_FILE
Check_and_get $OPROFILE_FILE $OPROFILE_URL

POPT_FILE=popt-1.7.tar.gz
POPT_URL=ftp://ftp.rpm.org/pub/rpm/dist/rpm-4.1.x/$POPT_FILE
Check_and_get $POPT_FILE $POPT_URL

#-----------------------------------------------------------------------------------------
# Only for Asterisk 1.2
#-----------------------------------------------------------------------------------------

ASTERISK12_FILE=asterisk-1.2.9.1.tar.gz
ASTERISK12_URL=http://ftp.digium.com/pub/asterisk/releases/$ASTERISK12_FILE
Check_and_get $ASTERISK12_FILE $ASTERISK12_URL

ZAPTEL12_FILE=zaptel-1.2.6.tar.gz
ZAPTEL12_URL=http://ftp.digium.com/pub/zaptel/releases/$ZAPTEL12_FILE
Check_and_get $ZAPTEL12_FILE $ZAPTEL12_URL

LIBPRI12_FILE=libpri-1.2.3.tar.gz
LIBPRI12_URL=http://ftp.digium.com/pub/libpri/releases/$LIBPRI12_FILE
Check_and_get $LIBPRI12_FILE $LIBPRI12_URL

BRISTUFF03_FILE=bristuff-0.3.0-PRE-1q.tar.gz
BRISTUFF03_URL=http://www.junghanns.net/downloads/$BRISTUFF03_FILE
Check_and_get $BRISTUFF03_FILE $BRISTUFF03_URL

#-----------------------------------------------------------------------------------------
# Only for Asterisk 1.09
#-----------------------------------------------------------------------------------------

ASTERISK10_FILE=asterisk-1.0.9.tar.gz
ASTERISK10_URL=http://ftp.digium.com/pub/asterisk/old-releases/$ASTERISK10_FILE
Check_and_get $ASTERISK10_FILE $ASTERISK10_URL

ZAPTEL10_FILE=zaptel-1.0.9.2.tar.gz
ZAPTEL10_URL=http://ftp.digium.com/pub/zaptel/releases/$ZAPTEL10_FILE
Check_and_get $ZAPTEL10_FILE $ZAPTEL10_URL

LIBPRI10_FILE=libpri-1.0.9.tar.gz
LIBPRI10_URL=http://ftp.digium.com/pub/libpri/releases/$LIBPRI10_FILE
Check_and_get $LIBPRI10_FILE $LIBPRI10_URL

BRISTUFF02_FILE=bristuff-0.2.0-RC8j.tar.gz
BRISTUFF02_URL=http://www.junghanns.net/downloads/$BRISTUFF02_FILE
Check_and_get $BRISTUFF02_FILE $BRISTUFF02_URL

#-----------------------------------------------------------------------------------------



