/*
 * (C) Copyright 2006
 * Sven Kolberg, Maxina GmbH & Co KG, s.kolberg@maxina.de
 * Henry Margies, Maxina GmbH & Co KG, h.margies@maxina.de
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __HEADER_CHANNEL_
#define __HEADER_CHANNEL_

#define STATE_UNUSED		0x0
#define STATE_CONFIGURE		0x1
#define STATE_IN_USE		0x2
#define STATE_FREEME		0x4

#define BUFFER_SIZE	320
#define RING_BUFFERS	64

struct ring_buf {

	unsigned char data[BUFFER_SIZE];
	int idx;
	int size;
	int samples;
	int full;
};

struct buffer {
	
	struct ring_buf buf[RING_BUFFERS];
	int write_idx;
	int read_idx;
};

struct channel {
	
	/* status of channel */
	int state;
	
	/* codec */
	struct codec* codec;
	void* codec_data;

	struct buffer in_buf;
	struct buffer out_buf;

	/* statistics */
	int frames_received;
	int frames_proceeded;
	int frames_sent;
	int frames_in_inbuf;
	int frames_in_outbuf;

};


int assign_channel(unsigned char idx, unsigned char fmt);
int free_channel(unsigned char idx);
void recv_channel(int idx, unsigned char* rx);
void send_channel(int idx, unsigned char* tx);
int channel_ready(int idx);
void process_channels(void);
void show_channels(void);

#endif /* __HEADER_CHANNEL_ */

