/*
 * (C) Copyright 2006
 * Sven Kolberg, Maxina GmbH & Co KG, s.kolberg@maxina.de
 * Henry Margies, Maxina GmbH & Co KG, h.margies@maxina.de
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */


#ifndef __HEADER_CODEC__
#define __HEADER_CODEC__

#include "channel.h"

struct codec {

	/* name of codec */
	const char* name;

	/* format information */
	int srcfmt;
	int dstfmt;
	int fmt;

	/* functions */

	void (*open)(struct channel*);
	void (*close)(struct channel*);
	void (*proceed)(struct channel*, struct ring_buf*, struct ring_buf*);

};


struct codec* find_codec(unsigned char fmt);
void register_codec(struct codec* c);
#endif /* __HEADER_CODEC__ */
