/* aec_test.cpp
 *
 * Copyright (C) DFS Deutsche Flugsicherung (2004). All Rights Reserved.
 *
 * Test stub for Acoustic Echo Cancellation NLMS-pw algorithm
 * Author: Andre Adrian, DFS Deutsche Flugsicherung
 * <Andre.Adrian@dfs.de>
 *
 * compile
c++ -DWIDEB=2 -O2 -o aec_test aec_test.cpp aec.cpp -lm
 *
 * Version 1.3 set/get ambient in dB
 */

//#include <stdio.h>
//#include <stdlib.h>
//#include <math.h>
//#include <string.h>

#include "aec_c.h"

#define TAPS  	(80*WIDEB*8)

typedef signed short MONO;

typedef struct {
  signed short l;
  signed short r;
} STEREO;
#if 0
float dB2q(float dB)
{
  /* Dezibel to Ratio */
  return powf(10.0f, dB / 20.0f);
}

float q2dB(float q)
{
  /* Ratio to Dezibel */
  return 20.0f * log10f(q);
}
#else

#endif

float globalvar;

/* Read a raw audio file (8KHz sample frequency, 16bit PCM, stereo)
 * from stdin, echo cancel it and write it to stdout
 */
int main_s(  STEREO inbuf[TAPS], STEREO outbuf[TAPS], int taps)
{
  extern int update;
  extern fixpoint ratio;
  
//  fprintf(stderr, "usage: aec_test [ambient in dB] <in.raw >out.raw\n");
//  fixpoint_test();


  struct AEC aec;
  AEC_init(&aec);

  //if (argc >= 2) {
	//AEC_setambient(&aec, float_to_fp_fixpoint(fp_to_float_fixpoint(MAXPCM)*dB2q(atof(argv[1]))));    
	//AEC_setambient(&aec, MAXPCM*dB2q(atof(argv[1])));    
  //}

  float ambient;
    int i;
    for (i = 0; i < taps; ++i) {
      int s0 = inbuf[i].l;      /* left channel microphone */
      int s1 = inbuf[i].r;      /* right channel speaker */

      /* and do NLMS */
      s0 = AEC_doAEC(&aec, s0, s1);
      
      /* copy back */
      // globalvar *= (32767.0 / STEPY1);
      // globalvar *= 32.0;  // 30dB amplification
      globalvar *= 16384.0;
      
      outbuf[i].l = (short)(globalvar); /* left channel DTD */
      // outbuf[i].l = update; /* left channel DTD */
      outbuf[i].r = s0;         /* right channel echo cancelled mic */
    }

  //ambient = fp_to_float_fixpoint(AEC_getambient(&aec));
  //float ambientdB = q2dB(ambient / 32767.0f);
  //fprintf(stderr, "Ambient = %2.0f dB\n", ambientdB);

  return 0;
}
