/*
 * (C) Copyright 2006
 * Henry Margies, Maxina GmbH & Co KG, h.margies@maxina.de
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#ifdef USE_DEBUG_EXCEPTION_HANDLER

static int exception_handler(void)
{
	int exc = 0;

	asm("%0 = seqstat" : "=r"(exc));
	printf("---> exception: 0x%x <---\n", exc);
	printf( "Have a closer look to the Blackfin "
		"Processor Hardware Reference at page 202.\n");

	return 0;
}



/**
 * initialize the Interrupt for exception handling
 * \returns zero uppon success, nonzero otherwise
 */
int register_exception_handler(void)
{
	printf("WARNING: Overriding exception isr ...\n");
	printf("WARNING: This is highly unstable and just for testing ...\n");
	printf("WARNING: You have been warned ...\n");

	cli();
	*(unsigned volatile long *) (EVT_EXCEPTION_ADDR) =
		(unsigned volatile long) exception_handler;
	__builtin_bfin_ssync();
	sti();

	return 0;
}

void test_exception_handler(void)
{
	char buffer[128];
	int* pi;

	printf("Pulling exception\n");
	pi = buffer+1;

	*pi = 0x11223344;

	printf("Done\n");
}

#endif

