# Common makefile for bfloader stuff
#
#
OBJS = main.o cfi_flash.o

NAME = bfloader

CC =      bfin-elf-gcc
LD =      bfin-elf-ld
LINKERSCRIPT = bftiny.x

CFLAGS = -I../include -I.
CFLAGS += -Wall
CFLAGS += -D__ADSPLPBLACKFIN__ -D__ADSPBLACKFIN__
#The ADSP is a little endian system
CFLAGS += -D__LITTLE_ENDIAN
CFLAGS += -DBOARD_$(BOARD)
CFLAGS += -g
LDFLAGS =  -Tbftiny.x
LDFLAGS += -B.


all : $(OBJS) crt0.o
	$(CC) $(LDFLAGS) -o $(NAME).dxe $(OBJS)

crt0.o : crt0.asm
	$(CC) -c -x assembler-with-cpp -o $@ $< $(CFLAGS) 

cfi_flash.o: cfi_flash.c
	$(CC) $(CFLAGS) -c -o $@ $<

clean:
	rm -f *.o *.dat


