#!/bin/sh

# Generates a flash loader GDB script for the images below

# (c) 11/2005, Martin Strubel <hackfin@section5.ch>

uboot=/blackfin/u-boot_1.1.3/u-boot.bin
linux=$HOME/uClinux-dist/images/uImage

offset_uboot=0x00000000
offset_linux=0x00100000

uboot_loader=loaduboot.gdb
linux_loader=loadlinux.gdb

echo "# GDB flash loader script" > $uboot_loader
echo "# Automatically generated by 'flashload.sh'" >> $uboot_loader
echo "#    (modifications will be overwritten)" >> $uboot_loader

# Determine size
echo "set \$size =" `du -b $uboot | sed 's/^\([0-9]*\).*/\1/'` >> $uboot_loader
echo "shell cp $uboot /tmp/flash.dat" >> $uboot_loader
echo "writefile $offset_uboot \$size" >> $uboot_loader


echo "# GDB flash loader script" > $linux_loader
echo "# Automatically generated by 'flashload.sh'" >> $linux_loader
echo "#    (modifications will be overwritten)" >> $linux_loader

# Determine size
echo "set \$size =" `du -b $linux | sed 's/^\([0-9]*\).*/\1/'` >> $linux_loader
echo "shell cp $linux /tmp/flash.dat" >> $linux_loader
echo "writefile $offset_linux \$size" >> $linux_loader

bfin-elf-gdb bfloader.dxe
