export Blinky_URL=http://www.section5.ch/dsp/blackfin/blinky.tgz
export Blinky_FILE=$(DL_DIR)/blinky.tgz
export Blinky_DIR=jtag/blinky
export Blinky_PATCH=$(PATCH_DIR)/patch.blinky

export Bfin_include_URL=http://www.section5.ch/dsp/blackfin/include.tgz
export Bfin_include_FILE=$(DL_DIR)/include.tgz
export Bfin_include_DIR=jtag/include


#Download an install the Blackfin include Package, e.g. for the blinky demo
$(Bfin_include_FILE):
	wget -O $(Bfin_include_FILE) $(Bfin_include_URL)

$(Bfin_include_DIR):	$(Bfin_include_FILE)
	cd jtag && tar -xzmf $(Bfin_include_FILE)

#Build a sample Programm to test the JTAG Programm
$(Blinky_FILE):
	wget -O $(Blinky_FILE) $(Blinky_URL)

$(Blinky_DIR):	$(Blinky_FILE)
	cd jtag && tar -xzmf $(Blinky_FILE)
	cd $(Blinky_DIR) && patch -p1 <$(Blinky_PATCH)

blinky_build:	$(Blinky_DIR) $(Bfin_include_DIR) toolchain_build
	$(MAKE) -C $(Blinky_DIR) clean
	$(MAKE) -C $(Blinky_DIR) BOARD=STAMP_BF533 

blinky_distclean:
	rm -Rf $(Bfin_include_DIR)
	rm -Rf $(Blinky_DIR) 
