
ifdef ICEbear_VERSION_1.0
	export ICEbear_JTAG_DRIVER_URL=http://www.section5.ch/dsp/icebear/ICEbear-linux-1.0beta.tgz
	export ICEbear_JTAG_DRIVER_FILE=$(DL_DIR)/ICEbear-linux-1.0beta.tgz
	export ICEbear_JTAG_DRIVER_DIR=jtag/ICEbear-linux-1.0beta
else
	export ICEbear_JTAG_DRIVER_URL=http://www.section5.ch/dsp/icebear/ICEbear-linux-0.3.tar.gz
	export ICEbear_JTAG_DRIVER_FILE=$(DL_DIR)/ICEbear-linux-0.3beta.tgz
	export ICEbear_JTAG_DRIVER_DIR=jtag/ICEbear-linux-0.3
endif

export LIBFTDI_FILE=$(ICEbear_JTAG_DRIVER_DIR)/drivers/libftdi-0.5.tar.gz
export LIBFTDI_DIR=jtag/libftdi-0.5

###############################################
# WARNING
# The gdbproxy is included in the insight debugger
export gdbproxy_URL=http://www.section5.ch/dsp/gdbproxy/gdbproxy-bfin[0.1beta].tgz
export gdbproxy_FILE=$(DL_DIR)/gdbproxy-bfin[0.1beta].tgz
export gdbproxy_DIR=jtag/gdbproxy

###############################################
# WARNING
# This gdb does not work with the ICEbear
export bfin-elf-gdb_URL=http://blackfin.uclinux.org/frs/download.php/324/bfin-elf-gdb.gz
export bfin-elf-gdb_FILE=$(DL_DIR)/bfin-elf-gdb.gz
export bfin-elf-gdb_DIR=jtagbfin-elf-gdb


#Build everything (ICEbear and libftdi, blinky and shell example, bfloader for stamp)
jtag_build:	jtag $(ICEbear_JTAG_DRIVER_DIR) libftdi_install blinky_build shell_build bfloader_build cfi_loader_build

#checkout this directory from CVS
jtag:

#clean the directory
jtag_distclean: icebear_distclean libftdi_distclean blinky_distclean shell_distclean bfloader_distclean cfi_loader_distclean

#Build the GDB
$(bfin-elf-gdb_FILE):	$(DL_DIR)
	wget -O $(bfin-elf-gdb_FILE) $(bfin-elf-gdb_URL)

$(bfin-elf-gdb_DIR):	jtag $(bfin-elf-gdb_FILE)
	cd jtag && tar -xjmf $(bfin-elf-gdb_FILE)

#Build the gdbproxy
$(gdbproxy_FILE):	$(DL_DIR)
	wget -O $(gdbproxy_FILE) $(gdbproxy_URL)

$(gdbproxy_DIR):	jtag $(gdbproxy_FILE)
	cd jtag && tar -xzmf $(gdbproxy_FILE)

gdbproxy_build:	$(gdbproxy_DIR)
	cd $(gdbproxy_DIR) && bash ./configure
	$(MAKE) -C $(gdbproxy_DIR)

gdbproxy_install:	gdbproxy_build
	$(MAKE) -C $(gdbproxy_DIR) install


#JTAG-Device Driver donwload and install
$(ICEbear_JTAG_DRIVER_FILE):
	wget -O $(ICEbear_JTAG_DRIVER_FILE) $(ICEbear_JTAG_DRIVER_URL)
	
$(ICEbear_JTAG_DRIVER_DIR):	jtag $(ICEbear_JTAG_DRIVER_FILE)
	cd jtag && tar -xzmf $(ICEbear_JTAG_DRIVER_FILE)

icebear_distclean:
	rm -Rf $(ICEbear_JTAG_DRIVER_DIR)

$(LIBFTDI_DIR):		jtag $(ICEbear_JTAG_DRIVER_DIR) $(DL_DIR)
	cd jtag && tar -xzmf ../$(LIBFTDI_FILE)

libftdi_distclean:
	rm -Rf $(LIBFTDI_DIR)

libftdi_install: $(LIBFTDI_DIR)
	cd $(LIBFTDI_DIR) && ./configure 
	$(MAKE) -C $(LIBFTDI_DIR)
	$(MAKE) -C $(LIBFTDI_DIR) install
	
libftdi_uninstall: $(LIBFTDI_DIR)
	$(MAKE) -C $(LIBFTDI_DIR) uninstall

