########################################################################
# Warning:
# 
# We will use the Toolchain provided by blackfin.uclinux.org
# Download the rpm and install in using the alien tool
#
#
#
#
#


#export Toolchain_URL=http://blackfin.uclinux.org/frs/download.php/527/bfin-binary.tar.gz
#export Toolchain_FILE=$(DL_DIR)/bfin_binary.tgz
#export Toolchain_DIR=blackfin

export toolchain_DIR=			$(PWD)/toolchain
export debtoolchain = yes

ifdef debtoolchain
export Toolchain_URL=http://blackfin.uclinux.org/frs/download.php/914/blackfin-toolchain-06r1-4.i386.rpm
export Toolchain_FILE=			$(DL_DIR)/blackfin-toolchain-06r1-4.i386.rpm
export PATH:=$(PATH):/opt/uClinux/bfin-uclinux/bin:/opt/uClinux/bfin-elf/bin

$(Toolchain_FILE):
	wget -O $(Toolchain_FILE) $(Toolchain_URL)

toolchain_build:	$(Toolchain_FILE)
	alien -i $(Toolchain_FILE) && mkdir toolchain_build && echo "Toolchain is installed using alien!" > toolchain_build/info.txt


toolchain_distclean:
	rm -Rf toolchain_build

else
export Toolchain_GCC_3.4_FILE=		$(DL_DIR)/bfin-gcc-3.4.tar.bz2
export Toolchain_GCC_4.1_FILE=		$(DL_DIR)/bfin-gcc-4.1.tar.bz2
export Toolchain_BINUTILS_FILE=		$(DL_DIR)/binutils.tar.bz2
export Toolchain_Buildscript_FILE=	$(DL_DIR)/buildscript.tar.bz2
export Toolchain_ELF2FTL_FILE=		$(DL_DIR)/elf2flt.tar.bz2
export Toolchain_GENEXT2FS_FILE=	$(DL_DIR)/genext2fs.tar.bz2
export Toolchain_LIBDSP_FILE=		$(DL_DIR)/libdsp.tar.bz2
export Toolchain_UCLINUX_FILE=		$(DL_DIR)/uClinux-06r1.tar.bz2
export Toolchain_UBOOT_FILE=		$(DL_DIR)/uboot.tar.bz2

export Toolchain_GCC_3.4_DIR=		$(toolchain_DIR)/gcc-3.4
export Toolchain_GCC_4.1_DIR=		$(toolchain_DIR)/gcc-4.1
export Toolchain_BINUTILS_DIR=		$(toolchain_DIR)/binutils
export Toolchain_Buildscript_DIR=	$(toolchain_DIR)/blackfin-toolchain-06r1
export Toolchain_ELF2FTL_DIR=		$(toolchain_DIR)/elf2flt
export Toolchain_GENEXT2FS_DIR=		$(toolchain_DIR)/genext2fs
export Toolchain_LIBDSP_DIR=		$(toolchain_DIR)/libdsp
export Toolchain_UCLINUX_DIR=		$(toolchain_DIR)/uClinux-dist
export Toolchain_UBOOT_DIR=		$(toolchain_DIR)/u-boot_1.1.3

export Toolchain_DIRS=$(Toolchain_GCC_3.4_DIR) \
$(Toolchain_GCC_4.1_DIR) \
$(Toolchain_BINUTILS_DIR) \
$(Toolchain_Buildscript_DIR) \
$(Toolchain_ELF2FTL_DIR) \
$(Toolchain_GENEXT2FS_DIR) \
$(Toolchain_LIBDSP_DIR) \
$(Toolchain_UCLINUX_DIR) \
$(Toolchain_UBOOT_DIR)

toolchain_build:	tc_buildscript

toolchain_distclean:
	rm -Rf $(toolchain_DIR)

tc_buildscript:	$(Toolchain_DIRS)
	cd $(Toolchain_Buildscript_DIR) && ./BuildToolChain -s $(toolchain_DIR) \
	-k $(Toolchain_UCLINUX_DIR) \
	-u $(Toolchain_UBOOT_DIR) \
	-b $(toolchain_DIR)/build/ \
	-o $(toolchain_DIR)/bfin


$(toolchain_DIR):
	mkdir $(toolchain_DIR)
	mkdir $(toolchain_DIR)/build
	mkdir $(toolchain_DIR)/bfin


#Extrakt all the files
$(Toolchain_GCC_3.4_DIR):	$(Toolchain_GCC_3.4_FILE) $(toolchain_DIR)
	cd toolchain && tar -xjmf $(Toolchain_GCC_3.4_FILE)

$(Toolchain_GCC_4.1_DIR):	$(Toolchain_GCC_4.1_FILE) $(toolchain_DIR)
	cd toolchain && tar -xjmf $(Toolchain_GCC_4.1_FILE)

$(Toolchain_BINUTILS_DIR):	$(Toolchain_BINUTILS_FILE) $(toolchain_DIR)
	cd toolchain && tar -xjmf $(Toolchain_BINUTILS_FILE)

$(Toolchain_Buildscript_DIR):	$(Toolchain_Buildscript_FILE) $(toolchain_DIR)
	cd toolchain && tar -xjmf $(Toolchain_Buildscript_FILE)

$(Toolchain_ELF2FTL_DIR):	$(Toolchain_ELF2FTL_FILE) $(toolchain_DIR)
	cd toolchain && tar -xjmf $(Toolchain_ELF2FTL_FILE)
	
$(Toolchain_GENEXT2FS_DIR):	$(Toolchain_GENEXT2FS_FILE) $(toolchain_DIR)
	cd toolchain && tar -xjmf $(Toolchain_GENEXT2FS_FILE)

$(Toolchain_LIBDSP_DIR):	$(Toolchain_LIBDSP_FILE) $(toolchain_DIR)
	cd toolchain && tar -xjmf $(Toolchain_LIBDSP_FILE)

$(Toolchain_UCLINUX_DIR):	$(Toolchain_UCLINUX_FILE) $(toolchain_DIR)
	cd toolchain && tar -xjmf $(Toolchain_UCLINUX_FILE)

$(Toolchain_UBOOT_DIR):		$(Toolchain_UBOOT_FILE)	 $(toolchain_DIR)
	cd toolchain && tar -xjmf $(Toolchain_UBOOT_FILE)
endif

	







#$(Toolchain_DIR):	$(Toolchain_FILE)
#	tar -xzmf $(Toolchain_FILE)
#
#toolchain_distclean:
#	rm -Rf $(Toolchain_DIR)
