
#http://blackfin.uclinux.org/frs/download.php/551/u-boot_1.1.3.tar.bz2
export U-Boot_URL=http://blackfin.uclinux.org/frs/download.php/826/u-boot_1.1.3.tar.bz2
export U-Boot_FILE=$(DL_DIR)/u_boot_1_1_3_tar.bz2
export U-Boot_DIR=u-boot_1.1.3
export U-Boot_PATCH=$(PATCH_DIR)/patch.u-boot_1.1.3_horstbox
export U-Boot_REFERENCE=$(REFERENCE_DIR)/u-boot_1.1.3

export U-Boot_Target=horstbox_config

#U-Boot download, extract, patch and build
u-boot: $(U-Boot_DIR) 

u-boot_build:	$(U-Boot_DIR)/u-boot.bin

$(U-Boot_DIR)/u-boot.bin:	$(U-Boot_DIR) toolchain_build u-boot_clean
	$(MAKE) -C $(U-Boot_DIR) clean
	$(MAKE) -C $(U-Boot_DIR) mrproper
	$(MAKE) -C $(U-Boot_DIR) $(U-Boot_Target)
	$(MAKE) -C $(U-Boot_DIR)

u-boot_clean:	$(U-Boot_DIR)
	$(MAKE) -C $(U-Boot_DIR) clean
	$(MAKE) -C $(U-Boot_DIR) mrproper

u-boot_distclean:
	rm -Rf $(U-Boot_DIR)
	
$(U-Boot_FILE):
	wget -O $(U-Boot_FILE) $(U-Boot_URL)

$(U-Boot_DIR):	$(U-Boot_FILE)
	tar -xjmf $(U-Boot_FILE)
	cd $(U-Boot_DIR) && patch -p1 <$(U-Boot_PATCH)

$(U-Boot_REFERENCE):	$(REFERENCE_DIR)
	tar -xjmf $(U-Boot_FILE) -C $(REFERENCE_DIR)
	make -C $(U-Boot_REFERENCE) clean

u-boot_diff:	$(U-Boot_REFERENCE) u-boot_clean
	-diff -BurN $(U-Boot_REFERENCE) $(U-Boot_DIR) > $(U-Boot_PATCH)

