
#http://blackfin.uclinux.org/frs/download.php/551/uClinux_1.1.3.tar.bz2
export uClinux_URL=http://blackfin.uclinux.org/frs/download.php/932/uClinux-dist-R06R1-RC2.tar.bz2
export uClinux_FILE=$(DL_DIR)/uClinux-dist-R06R1-RC2.tar.bz2
export uClinux_DIR=uClinux-dist
export uClinux_PATCH=$(PATCH_DIR)/uClinux.horstbox.patch
export uClinux_VENDOR_TAR=$(PATCH_DIR)/uClinux.vendor.tar
export uClinux_REFERENCE=$(REFERENCE_DIR)/uClinux-dist

#uClinux download, extract, patch and build
uClinux: $(uClinux_DIR) 

uClinux_build:	$(uClinux_DIR) toolchain_build
	make -C $(uClinux_DIR)

uClinux_clean:	$(uClinux_DIR)
	$(MAKE) -C $(uClinux_DIR) clean

uClinux_distclean:
	rm -Rf $(uClinux_DIR)

$(uClinux_REFERENCE):	$(REFERENCE_DIR)
	tar -xjmf $(uClinux_FILE) -C $(REFERENCE_DIR)
	
uClinux_diff:	$(uClinux_REFERENCE) uClinux_clean
	cd $(uClinux_DIR) && tar -cvf $(uClinux_VENDOR_TAR) vendors/AnalogDevices/BF533-HORSTBOX/
	-diff -BurN $(uClinux_REFERENCE)/linux-2.6.x/arch/blackfin $(uClinux_DIR)/linux-2.6.x/arch/blackfin > $(uClinux_PATCH)
	@echo 
	@echo "Patch and tar created, it is copied to the archive dir"
	@echo

uClinux_config: $(uClinux_DIR)
	make -C $(uClinux_DIR) menuconfig

$(uClinux_FILE):
	wget -O $(uClinux_FILE) $(uClinux_URL)

$(uClinux_DIR):	$(uClinux_FILE)
	tar -xjmf $(uClinux_FILE)
	cd $(uClinux_DIR) && tar -xmf $(uClinux_VENDOR_TAR)
	cd $(uClinux_DIR) && patch -p1 < $(uClinux_PATCH)

uClinux_ctags: $(uClinux_DIR)
	ctags-exuberant -R $(uClinux_DIR)
