#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: susi                                                          #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

ip=
if [ "$(nvram net.debugEnable)" = "true" ]; then
  ip=$(nvram net.debugIp)
  case $ip in 0*)ip=; esac
fi

# ---------------------------------------------------------------------------
# chain ..
# ---------------------------------------------------------------------------

nvram_local_admin () {

  ports=$(nvram net.blocked_ports.bpack)
  bcast=$(nvram net.bcast)

  cat <<!
#! /bin/sh
# $(date)
iptables -t filter -F admin
!

  test $ip &&
    echo iptables -t filter -A admin -p tcp -m multiport -s $ip --dports $ports -j ACCEPT

  cat <<!
iptables -t filter -A admin -p tcp -m multiport --dports $ports -j REJECT --reject-with tcp-reset
iptables -t filter -A OUTPUT -p udp --dport 137:138 -d $bcast -j DROP 
!
}

nvram_iptable_admin () {

  ports=$(nvram net.blocked_ports.dsl)
  bcast=$(nvram net.bcast)

  cat <<!
#! /bin/sh
# $(date)
iptables -t filter -F admin
!

  test $ip &&
    echo iptables -t filter -A admin -p tcp -m multiport -s $ip --dports $ports -j ACCEPT

  cat <<!
iptables -t filter -A admin -p tcp -m multiport --dports $ports -j REJECT --reject-with tcp-reset
iptables -t filter -A OUTPUT -p udp --dport 137:138 -d $bcast -j DROP 
!
}

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

## set -x

[ $# -gt 0 ] && {
  while [ $# -gt 0 ]
  do
    case $1 in
    -V|--view)
	nvram_iptable_admin ; shift ;;
    -L|--local-view)
	nvram_local_admin ; shift ;;
    *)	echo "Usage: $(basename $0) [-V|--view] [-L|--local-view]" >&2
	exit 2
    esac
  done
  exit
}


logger "Configure Admin/Debug Access ..."


nvram_local_admin | /bin/sh -

rcmd -s template debug-rules "\
cat - >/var/tmp/nvram_iptable_admin <<EOF"

nvram_iptable_admin |
while read line
do
  rcmd -s +template debug-rules "$line"
done

rcmd -s +template debug-rules "\
EOF
echo OK"

rcmd -sw contest

rcmd -s      run debug-rules
rcmd -s template debug-rules "" # clean up
rcmd -s /bin/sh /var/tmp/nvram_iptable_admin

# ---------------------------------------------------------------------------
# End
# ---------------------------------------------------------------------------
