#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: Henry Margies <h.margies@maxina.de> - Maxina GmbH, Neu-       #
#   Isenburg, Germany							  #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

nv_pfx=lan_dhcp.

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

logger "Configure DHCP ..."

## set -x

# get ip/mac assignments
assign=0x0
N=0
for id in $(nvram ${nv_pfx}list 2>/dev/null)
do
   N=$(expr $N + 1)
   if [ $N -gt 5 -o $id -gt 15 ]
   then
      nvram -p $$ -d ${nv_pfx}ipAddress.$id
      nvram -p $$ -d ${nv_pfx}macAddress.$id
      D=$(expr $D + 1)
   else
     assign=$assign$(printf '%x' $id)
   fi
done

rcmd -sw contest

wpost -x -p dhcp -i $assign

#wpost -p reboot

# ---------------------------------------------------------------------------
# end
# ---------------------------------------------------------------------------
