/*
 * Copyright (C) 2003-2005 Maxina GmbH - Henry Margies
 *
 * $Id: lan_common.h 3309 2006-10-17 08:47:06Z roman $
 *
 * $Log$
 * Revision 1.1  2006/10/17 08:47:06  roman
 * - added samba support
 *
 *
 */

#ifndef __PHONE_COMMON_H
#define __PHONE_COMMON_H

#include <stdio.h>

#include <nvram/nvram-lib.h>
#include <nvtools/hlst.h>



struct info_t {
	FILE* output;
	HLST* list;
	NVCL* nvram;

	char** l1;

	char* p1;
	char* p2;
	char* p3;
	char* p4;

	int i1;
	int i2;
	int i3;
	int i4;
	int i5;
};

#ifdef NO_SYSLOG
# define log_msg(type, fmt, args...) 	printf(fmt"\n", ##args)
#else
# include <syslog.h>
# define log_msg(type, fmt, args...)	syslog(type, fmt, ##args)
#endif

void nvram_avp_destroy(void *state, void *item, char *key, unsigned klen);
HLST* create_from_nvram(NVCL* nvram);
void update_from_nvram(NVCL* nvram, HLST* avp, const char* varname);
void update_to_nvram(NVCL* nvram, HLST* avp, const char* var, const char* val);

#ifdef SET_LINKS_AND_TRIGGER
void nvram_link_indexed(NVCL* nvram, const char* name, const char* id, const char* mode, const char* target);
void nvram_unlink(NVCL* nvram, const char* name);
void nvram_link(NVCL* nvram, const char* name, const char* mode, const char* target);
void nvram_trigger(NVCL* nvram, const char* name, const char* mode, const char* target);
#else
#define nvram_link_indexed(nvram, name, id, mode, target)
#define nvram_unlink(nvram, name)
#define nvram_link(nvram, name, mode, target)
#define nvram_trigger(nvram, name, mode, target)
#endif

typedef void (*cb_t)(void*, char*);
void for_each(HLST* avp, const char* prefix, cb_t cb, void* data);
//void for_seq(HLST* avp, const char* prefix, cb_t cb, void* data);
char* get_indexed_value(HLST* avp, const char* name, const char* index);
char* get_list_value(HLST* avp, const char* name);
int id_is_in(const char* s, const char* id);
int is_true(HLST* avp, const char* name);

char* replace_char(const char* string, char find, char replace);
#endif

