/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Henry Margies <h.margies@maxina.de> - Maxina GmbH, Neu-       *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "lan_common.h"
#include "lan_cfg_samba.h"


int main(int argc, char** argv)
{
	NVCL *nvram;
	HLST *avp;
	char *samba_enabled;
//	sleep(1);
	
#ifndef NO_SYSLOG
	openlog("lan_config", 0, LOG_DAEMON);
#endif

	/* connect to nvram */
	nvram = nvcl_open(0,0,0,0);
	if (!nvram) {
		/* report error */
#ifndef NO_SYSLOG
		closelog();
#endif
		return -1;
	}

	avp = create_from_nvram(nvram);
	if (!avp) {
		/* report error */
		nvcl_close(nvram);
#ifndef NO_SYSLOG
		closelog();
#endif
		return -2;
	}

	samba_enabled = get_list_value(avp, "lan_samba_conf.hasShare");

	if(!strcmp(samba_enabled, "true")){ 
		/* create smb.conf */
		create_samba_conf(avp);

		/* restart/reload samba */
		system("/etc.ro/init.d/samba restart");
	}
	else{
		system("/etc.ro/init.d/samba stop");
	}

	nvcl_close(nvram);
	destroy_hlst(avp);

#ifndef NO_SYSLOG
	closelog();
#endif

	return 0;
}
