#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

# rate in kbit
DOWNLINK=2000
# rate in kbit
UPLINK=2000
DEV=ixp0


disable_policy(){
	# clean up existing qdiscs
	tc qdisc del dev $DEV root > /dev/null 2>&1 
	tc qdisc del dev $DEV ingress > /dev/null 2>&1
}

enable_policy(){

	# setup the UPLINK policy
	tc qdisc add dev $DEV root handle 1: cbq bandwidth 100Mbit avpkt 1000

	tc class add dev $DEV parent 1: classid 1:10 cbq \
	   bandwidth 100Mbit rate ${UPLINK}kbit allot 1514  \
	   prio 5 cell 8 maxburst 20 avpkt 1000 bounded 
	
	tc filter add dev $DEV parent 1:0 protocol ip prio 5 \
	   u32 match ip sport 139 0xffff \
	   flowid 1:10

	tc filter add dev $DEV parent 1:0 protocol ip prio 5 \
	   u32 match ip sport 445 0xffff \
	   flowid 1:10

	# setup the DOWNLINK policy
	tc qdisc add dev $DEV handle ffff: ingress
	
	tc filter add dev $DEV parent ffff: protocol ip prio 5 \
	   u32 match ip dport 139 0xffff \
	   police rate ${DOWNLINK}kbit buffer 50k drop \
	   flowid :1

	tc filter add dev $DEV parent ffff: protocol ip prio 5 \
	   u32 match ip dport 445 0xffff \
	   police rate ${DOWNLINK}kbit buffer 50k drop \
	   flowid :1
}


state=$(nvram "phone_active_channel.state")

if [ "$state" == "true" ]; then
	enable_policy
else
	disable_policy
fi

exit 0
