#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

log="disabled"

mesg() {
	if [ $log = "enabled" ]; then
		logger -t $0 "$*"
	fi
}


set_share_phystate(){
        mntpoint=$1
        state=$2

        if [ $(nvram lan_samba_conf.shares.totalElements) -gt 0 ]; then
                for id in $(nvram lan_samba_conf.shares.list)
                do
                        if [ $(nvram lan_samba_conf.shares.mntpoint.$id) = $mntpoint ]; then
                                nvram lan_samba_conf.shares.isphyactive.$id $state
                                return
                        fi
                done
        fi
}


set_share_inactive(){
        set_share_phystate $1 "false"
}


# unmount and remove all partitions of the device
remove_dev(){

        DEVICE=$1
        MINOR=$2

        mesg "begin remove_dev"
        dev="/dev/usb/$DEVICE"
        tmp=$(cat /proc/self/mounts)
        echo "$tmp" | while read subdev path rest
        do
                echo "$subdev" | grep -q ^$dev[[:digit:]]\\+$ || continue
                # Unmount it
                [ -d "$path" ] || exit 1
                mesg "Unmounting: $path"
                umount -lf "$path"
                rm -rf $path
                rm -rf $subdev

        done

        # remove all nvram variables that belong to partitions of the current device
        partitions=$(nvram lan_usb_storage.dev.childs.$MINOR)
        for minor_id in $partitions
        do
                set_share_inactive $(nvram lan_usb_storage.partition.mntpoint.$minor_id)
                nvram -d lan_usb_storage.partition.id.$minor_id
                nvram -d lan_usb_storage.partition.mntpoint.$minor_id
                nvram -d lan_usb_storage.partition.parent.$minor_id
                nvram -d lan_usb_storage.partition.userlabel.$minor_id

        done
        # remove all nvram variables that belong to the current device
        nvram -d lan_usb_storage.dev.id.$MINOR
        nvram -d lan_usb_storage.dev.model.$MINOR
        nvram -d lan_usb_storage.dev.vendor.$MINOR
        nvram -d lan_usb_storage.dev.childs.$MINOR
 	nvram -d lan_usb_storage.dev.userlabel.$MINOR
        nvram -d lan_usb_storage.dev.umount.$MINOR
        nvram -d lan_usb_storage.dev.device.$MINOR
	nvram -d lan_usb_storage.dev.size.$MINOR
	nvram -d lan_usb_storage.dev.mounterror.$MINOR
}



nvram -l |
grep ^"lan_usb_storage.dev.id" |	
while IFS== read var val
do
        MINOR=$val
        mesg "nvram lan_usb_storage.dev.umount.$MINOR"
        umount=$(nvram lan_usb_storage.dev.umount.$MINOR)

        if [ "$umount" = "true" ]; then
        
		
		mesg "call remove_dev for device: $MINOR"
                remove_dev $(nvram lan_usb_storage.dev.device.$MINOR) $MINOR
        fi
done

mesg "finished"

exit 0



