#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: susi                                                          #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

# ---------------------------------------------------------------------------
# chain ..
# ---------------------------------------------------------------------------

nvram_iptable_bpack () {
  local ip0=$(nvram net.ipAddr)
  local ip1=$(nvram net.dsl_board)
  local ip2=$(nvram lan_ip.ipAddress)
  local ip9=

  case $(nvram net.debugEnable) in
  t*|T*) ip9=$(nvram net.debugIp)
  esac

  cat <<!
#! /bin/sh
# $(date)

iptables -t nat -F lan
[ -z \${ip9} ] || iptables -t nat -A lan -s $ip9 -d $ip0 -j MASQUERADE
iptables -t nat -A lan -p udp --sport 10000:12000 -s $ip0 -j SNAT --to-source $ip2
iptables -t nat -A lan -j ACCEPT

iptables -t nat -F bpack-tapi
iptables -t nat -A bpack-tapi -p tcp --dport 5038 -j DNAT --to-destination $ip0

iptables -t nat -F bpack-printserv
iptables -t nat -A bpack-printserv -p tcp --dport 9100 -j DNAT --to-destination $ip0

iptables -t nat -F bpack-nmbd
iptables -t nat -A bpack-nmbd -p udp --dport 137:138 -j DNAT --to-destination $ip0

iptables -t nat -F bpack-smbd
iptables -t nat -A bpack-smbd -p tcp --dport 139 -j DNAT --to-destination $ip0
iptables -t nat -A bpack-smbd -p tcp --dport 445 -j DNAT --to-destination $ip0			

iptables -t nat -F bpack-ssh
iptables -t nat -A bpack-ssh -p tcp --dport 222 -j DNAT --to-destination $ip0:22

iptables -t nat -F bpack-admin
iptables -t nat -A bpack-admin -p tcp --dport $(nvram sys_admin.port) -j DNAT --to-destination $ip0

iptables -t nat -F bpack-voice
iptables -t nat -A bpack-voice -p udp --dport 5060        -j DNAT --to-destination $ip0
iptables -t nat -A bpack-voice -p udp --dport 10000:12000 -j DNAT --to-destination $ip0

iptables -t nat -F bpack-horst
iptables -t nat -A bpack-horst -p udp -j bpack-voice
iptables -t nat -A bpack-horst -p tcp -j bpack-admin
iptables -t nat -A bpack-horst -p tcp -j bpack-ssh
iptables -t nat -A bpack-horst -p tcp -j bpack-smbd
iptables -t nat -A bpack-horst -p udp -j bpack-nmbd	
iptables -t nat -A bpack-horst -p tcp -j bpack-printserv	
iptables -t nat -A bpack-horst -p tcp -j bpack-tapi	

iptables -t nat -F bpack
iptables -t nat -A bpack -d $ip0 -j bpack-horst
iptables -t nat -A bpack -d $ip1 -j bpack-horst
iptables -t nat -A bpack -d $ip2 -j bpack-horst
!
}

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

case $1 in
-V|--view) nvram_iptable_bpack ; exit ;;
?*)        echo "Usage: $(basename $0) [-V|--view]" >&2 ; exit 2
esac

logger "Configure Net Neighbours ..."

rcmd -s template neighbour-rules "\
cat - >/var/tmp/nvram_iptable_bpack <<EOF"

nvram_iptable_bpack |
while read line
do
  rcmd -s +template neighbour-rules "$line"
done

rcmd -s +template neighbour-rules "\
EOF
echo OK"

rcmd -sw contest

rcmd -s      run neighbour-rules
rcmd -s template neighbour-rules "" # clean up
rcmd -s /bin/sh /var/tmp/nvram_iptable_bpack

/etc/init.d/network stop
/etc/init.d/network start

# ---------------------------------------------------------------------------
# End
# ---------------------------------------------------------------------------
