#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

PRINTSERV_PID="/var/run/printserv.pid"
PRINTSERV_BIN="/sbin/printserv"

mesg() {
	logger -t $0 "$*"
}

start_printserv(){
	
	device=$1
	port=$2
	

	if [ -z $device ] || [ -z $port]; then
		mesg "err: port or device not found"
		exit 0;
	fi
	BIN_ARGS="-d $device -p $port"

	/bin/start -r -p $PRINTSERV_PID -b $PRINTSERV_BIN -- $BIN_ARGS
}

stop_printserv(){
	# stop the printserv daemon
	if [ -r $PRINTSERV_PID ]; then
		kill $(cat $PRINTSERV_PID)
		rm $PRINTSERV_PID
	fi
}


stop_printserv

userlabel=$(nvram lan_printer_conf.userlabel)
[ "false" = "$userlabel" ] && exit 0

nvram -l | grep ^"lan_usb_printer.id" |
while IFS== read var val
do
	s_label=$(nvram lan_usb_printer.userlabel.$val)
		
	if [ "$userlabel" = "$s_label" ]; then
		device=$(nvram lan_usb_printer.dev.$val)
		port=$(nvram lan_usb_printer.port.$val)
			
		start_printserv $device $port
		exit 0	
	fi
done

exit 0
