#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          #
#   Isenburg, Germany							  #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

# ---------------------------------------------------------------------------
# chain ..
# ---------------------------------------------------------------------------

nvram_policy_route () {
  cat <<!
#! /bin/sh
# $(date)

ip r f t 42 2>/dev/null 
ip ru | grep 'lookup 42' |
while read x f a t i r
do
   echo \$x\$i|{
      ifs="\$IFS";IFS=:
      read x i
      ip ru d pref \$x to \$i table 42
      IFS="\$ifs"
   }
done

!

  local p=100
  for id in $(nvram lan_routing.list 2>/dev/null)
  do
      local trg=$(nvram lan_routing.destination.$id)
      local msk=$($(dirname $0)/netm2len $(nvram lan_routing.netmask.$id))

      echo ip ru a pref $p to $trg/$msk table 42;
      p=$(expr $p + 1)

      case $(nvram lan_routing.routing.$id) in
      pvc)
         pvc="$(nvram lan_routing.pvc.$id)"
         file="/var/run/ppp-nas$(expr $pvc - 1).pid"
	 echo "dev=\"\$(grep ppp $file)\""
         echo "ip r a $trg/$msk dev \$dev t 42" ;;
      device)
         echo ip r a $trg/$msk dev $(nvram lan_routing.device.$id) t 42 ;;
      gateway)
         echo ip r a $trg/$msk via $(nvram lan_routing.gateway.$id) t 42
      esac
  done
}

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

case $1 in
-V|--view) nvram_policy_route ; exit ;;
?*)        echo "Usage: $(basename $0) [-V|--view]" >&2 ; exit 2
esac

logger "Configure Routes ..."

rcmd -s template route-rules "\
cat - >/var/tmp/nvram_policy_route <<\EOF"

nvram_policy_route |
while read line
do
  line=`echo "$line"|sed 's/\\\\/\\\\\\\\/g;s/'\''/\\\\'\''/g;s/"/\\\\"/g;s/\\$/\\\\\\\\$/g;'`
  rcmd -s +template route-rules "$line"
done

rcmd -s +template route-rules "\
EOF
echo OK"

rcmd -sw contest

rcmd -s      run route-rules
rcmd -s template route-rules "" # clean up
rcmd -s /bin/sh /var/tmp/nvram_policy_route

# ---------------------------------------------------------------------------
# End
# ---------------------------------------------------------------------------
