#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

mesg() {
	logger -t $0 "$*"
}

PASSWD="/etc/passwd"
PASSWD_ORIG="/etc.ro/passwd"


if [ ! -r $PASSWD_ORIG ]; then
	mesg "could not read $PASSWD_ORIG"
	exit 1
fi;

# restore the original passwd file
cp $PASSWD_ORIG $PASSWD

if [ $? -ne 0 ]; then
	mesg "copy $PASSWD_ORIG to $PASSWD failed"
	exit 1
fi

# clean up the smbpasswd file
if [ -w "/etc/smbpasswd" ]; then
	echo -n > "/etc/smbpasswd"
fi

# test if account_policy.tdb exists
if [ ! -e "/var/lock/account_policy.tdb" ]; then
	mv "/etc/account_policy.tdb" "/var/lock/account_policy.tdb"
fi

users=$(nvram lan_samba_user.list)

userid=1000

echo "Creating users for smbpasswd"

for id in $users
do
	name=$(nvram lan_samba_user.name.$id)
	password=$(nvram lan_samba_user.password.$id)
	
	# add the user to the passwd file
	echo "$name:*:$userid:$userid::/nonexistent:/bin/false" >> $PASSWD  
	
	# create a smb user entry with smbpasswd
	(echo $password; echo $password) | smbpasswd -c /etc/smb.conf -s -a $name

	userid=$((userid + 1))
done

exit 0
