#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          #
#   Isenburg, Germany							  #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

#
# syntax: <cmd> [load]
#

com_pfx=lan_snmp_community.
trp_pfx=lan_snmp_traps.

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

logger "Configure SNMP ..."

## set -x

# 2 entries, only
set -- x $(nvram ${com_pfx}list) ; shift
[ $# -gt 2 ] && {
  nvram -p $$ ${com_pfx}list "$1 $2"
  nvram -p $$ ${com_pfx}totalElements 2
  shift 
  shift
  for id
  do
     nvram -p $$ -d ${com_pfx}communityName.$id
     nvram -p $$ -d ${com_pfx}accessRights.$id
  done
}

# 3 entries, only
set -- x $(nvram ${trp_pfx}list) ; shift
[ $# -gt 3 ] && {
  nvram -p $$ ${trp_pfx}list "$1 $2 $3"
  nvram -p $$ ${trp_pfx}totalElements 3
  shift
  shift
  shift
  for id
  do
     nvram -p $$ -d ${trp_pfx}destinationIp.$id
     nvram -p $$ -d ${trp_pfx}trapCommunityId.$id
     nvram -p $$ -d ${trp_pfx}trapVersion.$id
  done
}

rcmd -sw contest

wpost -x -p snmp
wpost -p reboot

# ---------------------------------------------------------------------------
# end
# ---------------------------------------------------------------------------
