#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          #
#   Isenburg, Germany							  #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

# ---------------------------------------------------------------------------
# chain ..
# ---------------------------------------------------------------------------

# set -x

nvram_iptable_wlanacl () {

  cat <<!
#! /bin/sh
# $(date)
# iptables -t mangle -F macacl
brctl flushfilter br0
!

  [ true = "$(nvram lan_mgmt_access.hasAccessList)" ] || return

  local id allow= deny=
  for id in $(nvram lan_mgmt_access.list 2>/dev/null)
  do
     local mac=$(nvram lan_mgmt_access.macAddress.$id) TRG
     case $(nvram lan_mgmt_access.mode.$id) in
     allow)
	allow=ok
        # TRG=ACCEPT
        TRG=1
	;;
     *) deny=ok
        # TRG=DROP
        TRG=0
     esac
     # echo iptables -t mangle -A macacl -m mac --mac-source $mac -j $TRG
     Mac=$(echo $mac | sed 's/:/-/g')
     echo brctl addfilter br0 0 0 $Mac 00-00-00-00-00-00 0x0000 $TRG
  done
  echo brctl setfilter br0 1

  [ -z "$allow" ] || return
  # echo iptables -t mangle -A macacl -j DROP
  # echo brctl addfilter br0 eth0 wlan0 00-00-00-00-00-00 00-00-00-00-00-00 0x0 0
}

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

case $1 in
-V|--view) nvram_iptable_wlanacl ; exit ;;
?*)        echo "Usage: $(basename $0) [-V|--view]" >&2 ; exit 2
esac

logger "Configure Wlan Acls ..."

rcmd -s template wlanacl-rules "\
cat - >/var/tmp/nvram_iptable_wlanacl <<EOF"

nvram_iptable_wlanacl |
while read line
do
  rcmd -s +template wlanacl-rules "$line"
done

rcmd -s +template wlanacl-rules "\
EOF
echo OK"

rcmd -sw contest

rcmd -s      run wlanacl-rules
rcmd -s template wlanacl-rules "" # clean up
rcmd -s /bin/sh /var/tmp/nvram_iptable_wlanacl

# ---------------------------------------------------------------------------
# End
# ---------------------------------------------------------------------------
