#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: Henning Holtschneider <henning@loca.net>                      #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

nv_pfx=lan_wlan.

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

logger "Configure Wlan ..."

## set -x

rcmd -sw contest

wpost -x -p wlan
sleep 10
wpost -x -p wlan

sleep 4
security=`nvram ${nv_pfx}security`

[ none != "$security" ] &&
     nvram -p $$ lan_mgmt_multiple.hasMultiSsids false

if [ "$(nvram lan_wlan.nightservice.active)" = "true" ] ; then
    if [ "$(nvram lan_wlan.nightservice.offHour)" = "$(date +%H)" ] ; then
	if [ "$(nvram lan_wlan.nightservice.offMinute)" = "$(date +%M)" ] ; then
	    logger "Turning on WLAN nightservice"
	    wpost -x -p aprestart
	    exit 0
	fi
    fi
    if [ "$(nvram lan_wlan.nightservice.onHour)" = "$(date +%H)" ] ; then
	if [ "$(nvram lan_wlan.nightservice.onMinute)" = "$(date +%M)" ] ; then
	    logger "Turning off WLAN nightservice"
	    wpost -x -p aprestart
	    exit 0
	fi
    fi
fi


if [ "$(nvram sys_system.do_not_reboot)" = "true" ] ; then
    exit 0
fi

wpost -x -p reboot

# reboot board
/etc/init.d/watchdog stop
nvram -s
sleep 1
reboot

# ---------------------------------------------------------------------------
# end
# ---------------------------------------------------------------------------
