#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: Henry Margies <h.margies@maxina.de> - Maxina GmbH, Neu-       #
#   Isenburg, Germany							  #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

nv_pfx=lan_mgmt_multiple.

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

logger "Configure Wlan/Multiple SSIDs ..."

## set -x

setwlan=

rcmd -sw contest

for ssid in $(rcmd -s run wlan-ssid-show)
do
   wpost -x -p -ssid -i "$ssid"
   setwlan=ok
done

for id in $(nvram ${nv_pfx}list)
do
   wpost -x -p +ssid -i $id
   setwlan=ok
done

if [ "$setwlan" ]
then
   # texts may have been normalised
   set -- x $(rcmd -s run wlan-ssid-show)
   for id in $(nvram ${nv_pfx}list)
   do
      shift
      nvram -p $$ ${nv_pfx}ssid.$id "$1"
   done
else
   wpost -x -p +ssid 
fi

wpost -p aprestart

# ---------------------------------------------------------------------------
# end
# ---------------------------------------------------------------------------
