/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Roman Schmidt                                                 *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "phone_common.h"
#include "phone_cfg_tapi.h"


int main(int argc, char** argv)
{
	NVCL *nvram;
	HLST* avp;

	
#ifndef NO_SYSLOG
	openlog("phone_config", 0, LOG_DAEMON);
#endif

	/* connect to nvram */
	nvram = nvcl_open(0,0,0,0);
	if (!nvram) {
		/* report error */
#ifndef NO_SYSLOG
		closelog();
#endif
		return -1;
	}

	avp = create_from_nvram(nvram);
	if (!avp) {
		/* report error */
		nvcl_close(nvram);
#ifndef NO_SYSLOG
		closelog();
#endif
		return -2;
	}

	/* create tapi.conf */
	create_tapi_conf(avp);


	/* asterisk is restarted by the start daemon, after killall */
	system("killall asterisk");


	nvcl_close(nvram);
	destroy_hlst(avp);

#ifndef NO_SYSLOG
	closelog();
#endif

	return 0;
}
