#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: Henry Margies <h.margies@maxina.de> - Maxina GmbH, Neu-       #
#   Isenburg, Germany							  #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

create_call_file()
{
	cat - <<EOF
Channel: $1
CallerID: "HorstBox" <0>
MaxRetries: 0
RetryTime: 60
WaitTime: 60
Context: debug
Extension: 97 
Priority: 1
EOF
}

make_test_call()
{
	create_call_file $1 > /tmp/call
	chown asterisk /tmp/call
	mv /tmp/call /var/spool/asterisk/outgoing/
}

check_language()
{
	lang="$(nvram global.lang)"
	case `grep language /etc/asterisk/zapata.conf` in
	  language=$lang)
	    # language correct
	    return
	    ;;
	esac

	# restart asterisk
	nvram asterisk.config_trigger 1
	nvram asterisk.config_trigger 0
	sleep 1
}


check_language

number="$(nvram phone_devices.test)"

case "$number" in
	notest)
		exit 0
		;;

	21)
		make_test_call "Zap/8"
		;;

	22)
		make_test_call "Zap/7"
		;;

	3*)
		make_test_call " Zap/g2/${number}"
		;;

	4*)
		make_test_call " SIP/${number}"
		;;
		
	*)
		logger "Unknown device to test"
		;;
esac

# we will change the value back to notest in 5 seconds
# with this it is not possible to call the same number
# within these 5 seconds
(
	sleep 5
	if [ "$(nvram phone_devices.test)" = "$number" ]; then
		nvram phone_devices.test notest
	fi
)&
exit 0
		
