#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: Henry Margies <h.margies@maxina.de> - Maxina GmbH, Neu-       #
#   Isenburg, Germany							  #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

error()
{
	nvram UPDATE.ERROR_CODE "$1"
	exit 1
}

# download config file

wget -O /tmp/config.txt $(nvram UPDATE.CONFIG_URL) || error 1

# simulate slow internet
sleep 5

# transfer config to nvram
grep -v -e "^#" -e "^[ \t]*$" /tmp/config.txt | while read line
do
	nvram $line
done

nvram -d UPDATE.ERROR_CODE
