#! /bin/bash
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   Author: Sven Kolberg <s.kolberg@maxina.de> - Maxina GmbH, Neu-        #
#   Isenburg, Germany							  #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

[ "$(nvram sys_hardware.serial.write)" != "true" ] && exit 2

nvram sys_hardware.serial.write false
nvram -s

logger "Writing new serial number..."

sleep 1

SERIAL=`nvram sys_hardware.serial.number`

if dump_redconfig | grep "Name: serial_nr";
then
	dump_redconfig | sed "Ns/^Name: serial_nr.*\nValue:.*/Name: serial_nr\nValue: ${SERIAL}/" > /tmp/redboot.dump
else
	dump_redconfig | grep -v Checksum > /tmp/redboot.dump
	echo "Header.Type: 3" >> /tmp/redboot.dump
	echo "Header.NameLength: 10" >> /tmp/redboot.dump
	echo "Header.Sense: 1" >> /tmp/redboot.dump
	echo "Header.DependencyLength: 0" >> /tmp/redboot.dump
	echo "Name: serial_nr" >> /tmp/redboot.dump
	echo "Value: ${SERIAL}" >> /tmp/redboot.dump
fi;

dump_redconfig | grep Checksum >> /tmp/redboot.dump	
write_redconfig -w < /tmp/redboot.dump

nvram sys_firmware.cur_serialnr "$(read_redconfig serial_nr)"

