#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

#
# syntax: <cmd> [load]
#

nv_pfx=sys_upnp.

# ---------------------------------------------------------------------------
# command line arguments
# ---------------------------------------------------------------------------

case "$1" in load) loadok=1 ;; *) unset loadok ; esac

# ---------------------------------------------------------------------------
# helpers
# ---------------------------------------------------------------------------

nvupnp () {
  case $1 in
      1) nvram -d $$ ${nv_pfx}hasUpnp true
	 ;;
     '') case $(nvram ${nv_pfx}hasUpnp) in
         true) echo "1 1" ;;
            *) echo 0 ;;
         esac
	 ;;
      *) nvram -d $$ ${nv_pfx}hasUpnp false
  esac
}

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

logger "Configure Upnp ..."

# set -x

if [ "$loadok" ]
then
   rcmd -s run upnp-show
else
   rcmd -s run upnp-setup $(nvupnp)
fi

# ---------------------------------------------------------------------------
# end
# ---------------------------------------------------------------------------
