#! /bin/sh
#-------------------------------------------------------------------------#
#   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                         #
#-------------------------------------------------------------------------#

# ---------------------------------------------------------------------------
# chain ..
# ---------------------------------------------------------------------------

nvram_iptable_vserver () {
  cat <<!
#! /bin/sh
# $(date)
iptables -t nat -F vserver
!
  # special rules
  # remote https
  if [ "$(nvram sys_admin.hasRemoteHttpMgmt)" = "true" ]; then
    local   src_ip=$(nvram sys_admin.httpIp)
    local src_mask=$(nvram sys_admin.httpNetmask)
    local     port=$(nvram sys_admin.port)
    local       ip=$(nvram net.ipAddr)
    echo iptables -t nat -A vserver -p tcp -s $src_ip/$src_mask --dport $port -j DNAT --to $ip
  fi

  local id
  for id in $(nvram "$@" wan_virtual_rule.list 2>/dev/null)
  do
     local ip=$(nvram wan_virtual_rule.ip.$id 2>/dev/null)
     case $ip in '')continue; esac

     local proto=$(nvram wan_virtual_rule.protocol.$id)
     local  from=$(nvram wan_virtual_rule.startport.$id)
     local    to=$(nvram wan_virtual_rule.endport.$id)
     local   map=$(nvram wan_virtual_rule.portmap.$id)

     case $to  in $from|0|'');; *)from=$from:$to; esac
     case $map in $from|0|'');; *)  ip=$ip:$map ; esac

     case $proto in *udp*)
       echo iptables -t nat -A vserver -p udp --dport $from -j DNAT --to $ip
     esac
     case $proto in *tcp*)
       echo iptables -t nat -A vserver -p tcp --dport $from -j DNAT --to $ip
     esac
  done
}

# ---------------------------------------------------------------------------
# MAIN
# ---------------------------------------------------------------------------

case $1 in
-V|--view) nvram_iptable_vserver ; exit ;;
?*)        echo "Usage: $(basename $0) [-V|--view]" >&2 ; exit 2
esac

logger "Configuring Virtual Hosts ..."

rcmd -s template virtual-rules "\
cat - >/var/tmp/nvram_iptable_vserver <<EOF"

nvram_iptable_vserver |
while read line
do
  rcmd -s +template virtual-rules "$line"
done

rcmd -s +template virtual-rules "\
EOF
echo OK"

rcmd -sw contest

rcmd -s      run virtual-rules
rcmd -s template virtual-rules "" # clean up
rcmd -s /bin/sh /var/tmp/nvram_iptable_vserver

# ---------------------------------------------------------------------------
# End
# ---------------------------------------------------------------------------
