/*
 * BiST: A telefonie hardware testing application
 *
 * Written by  Sven Kolberg <s.kolberg@maxina.de>
 *
 * Copyright (C) 2001, Linux Support Services, Inc.
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */

#ifndef __Analog_Func__
#define __Analog_Func__

typedef struct sanalog_chan{
	int fd; /* The Filedescriptor of the Channel*/
	int channelnum; /* The number of the channel */
	struct timeval lastring; /* The time the channel did ring the last time*/
	int numberofrings; /*number of rings in a row*/

	char description[256]; /*short string explaning what this is*/
	
	/* Callback routines */
	int (* call_answered) (struct sanalog_chan *achan); //Callbackroutine, will be called when a call is answered
	int (* call_hangup) (struct sanalog_chan *achan); //Callbackroutine, will be called if a call is hungup
	int (* number_recieved) (struct sanalog_chan *achan, char digit); //Callbackroutine, if a digit was recieved
	int (* ringing) (struct sanalog_chan *achan, int num); //Callbackroutine, will be called during ringing, num is the number or rings allready recieved
} Analog_chan;

//Debuging Functions
void dump_ZT_PARAMS(FILE* fd, char *m,ZT_PARAMS *p);
void dump_ZT_BUFFERINFO(FILE* fd, char * m, ZT_BUFFERINFO *p);
void dump_ZT_GAINS(FILE* fd, char *m, ZT_GAINS *p);
void dump_ZT_SPANINFO(FILE* fd, char *m, ZT_SPANINFO *p);
void dump_ZT_CONFINFO(FILE* fd, char *m, ZT_CONFINFO *p);
int  myioctl (int __fd, unsigned long int __request, void *p, char *func, char *file, int line);
int myopen(const char *pathname, int flags, char *func, char *file, int line);
int myopenmode(const char *pathname, int flags, mode_t mode, char *func, char *file, int line);
int myclose(int fd, char *func, char *file, int line);

int zaptel_check_event(int fd); 
int zaptel_wait_event(int fd);
int zaptel_open(int channel);

//#define ioctl(__fd, __request, __p ) myioctl(__fd, __request, __p, __FUNCTION__, __FILE__, __LINE__)
//#define open(__pathname, __flags) myopen(__pathname, __flags, __FUNCTION__, __FILE__, __LINE__)
//#define open(__pathname, __flags, __mode) myopenmode(__pathname, __flags, __mode, __FUNCTION__, __FILE__, __LINE__)
//#define close(__fd) myclose(__fd, __FUNCTION__, __FILE__, __LINE__)


#endif /* __Analog_Func__ */
