/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Henry Margies <h.margies@maxina.de> - Maxina GmbH, Neu-       *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>

#define TEST_FILE	"/tmp/test_file"

char test_data[] = "abcdefghijklmnopqrstuvwxyz";

static int create_file(const char* filename)
{
	int fd;
	int ret;

	fd = open(filename, O_WRONLY | O_CREAT, 0600);
	if (-1 == fd) {
		perror("Could not create file: ");
		return -1;
	}

	ret = write(fd, test_data, sizeof(test_data));
	if (ret != sizeof(test_data)) {
		perror("Could not write to file: ");
		return -1;
	}

	close(fd);
		
	return 0;
}


static int read_file(const char* filename)
{
	int fd;
	int ret;
	int ind = 0;
	char buf[128] = "";

	fd = open(filename, O_RDONLY);
	if (-1 == fd) {
		perror("Could not open file: ");
		return -1;
	}

	while(1) {
		memset(buf, 0, sizeof(buf));
		ret = read(fd, buf, 3);
	
		if (ret == 0)
			break;

		if (ret == -1) {
			perror("Error while reading: ");
			break;
		}

		printf(": %s\n", buf);
	}

	
	close(fd);
		
	return 0;
}


void do_align_test()
{
	if (create_file(TEST_FILE))
		return;


	read_file(TEST_FILE);

	unlink(TEST_FILE);
}
