/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Henry Margies <h.margies@maxina.de> - Maxina GmbH, Neu-       *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>


#ifdef USE_ZAPTEL

#include "zaptel.h"

void do_ring_test()
{
	char* devices[] = { "/dev/zap/7", NULL };
	int fd;
	int res;
	int i,x;
	
	for (i=0; devices[i]; i++) {

		fd = open(devices[i], O_RDWR);

		if (fd < 0) {
	 		printf("Unable to open %s\n", devices[i]);
			continue;
		}
                
		printf("Start ringing on %s\n ", devices[i]);
		fflush(stdout);
                
		x = ZT_START;
		res = ioctl(fd, ZT_HOOK, &x);
		if (res) {
			fprintf(stderr, "\nUnable to start ringing...\n");
			close(fd);
			continue;
		}

		printf("Press Enter to stop ringing\n");
		getc(stdin);

		x = ZT_ONHOOK;
		res = ioctl(fd, ZT_HOOK, &x);
		if (res) {
			fprintf(stderr, "\nUnable to stop ringing...\n");
			close(fd);
			continue;
		}

		close(fd);
	}
}

#else

void do_ring_test()
{
	printf("Zaptel was not configured;\n");
}

#endif
