#
# Asterisk
#
#


$(DL_DIR)/$(ASTERISK_FILE):
	$(WGET) -P $(DL_DIR) $(ASTERISK_URL)


$(ASTERISK_DIR): $(DL_DIR)/$(ASTERISK_FILE) $(BRISTUFF_DIR)
	tar xfzm $(DL_DIR)/$(ASTERISK_FILE)
	cd $(ASTERISK_DIR) && patch -p1 <$(BRISTUFF_DIR)/patches/asterisk.patch
	cd $(ASTERISK_DIR) && patch -p1 <$(ARCHIVE)/$(ASTERISK_PATCH)

asterisk_build:	$(ASTERISK_DIR) bristuff_build zaptel_build libpri_build speex_build
	CROSS_COMPILE=$(CROSS_COMPILE) 		\
	CROSS_ARCH=Linux			\
	CROSS_PROC=armv5t			\
	CROSS_REV=2.6				\
	CROSS_COMPILE_TARGET=$(PWD)/toolchain	\
	$(MAKE) -C $(ASTERISK_DIR)


asterisk_install: bristuff_install zaptel_install libpri_install speex_install
	CROSS_COMPILE=$(CROSS_COMPILE) 		\
	CROSS_ARCH=Linux			\
	CROSS_PROC=armv5t			\
	CROSS_REV=2.6				\
	CROSS_COMPILE_TARGET=$(PWD)/toolchain	\
	DESTDIR=$(ROOTFS)	 		\
	$(MAKE) -C $(ASTERISK_DIR) install
	$(RM) -fr $(ROOTFS)/usr/include
	$(RM) -fr $(ROOTFS)/usr/share/man
	$(MAKE) sounds_install music_install
	

asterisk_clean:	bristuff_clean zaptel_clean libpri_clean speex_clean
	$(MAKE) -C $(ASTERISK_DIR) clean

asterisk_distclean: bristuff_distclean zaptel_distclean libpri_distclean speex_distclean sounds_distclean
	$(RM) -r $(ASTERISK_DIR)
