ARCH		= arm

CROSS_COMPILE	= $(PWD)/toolchain/bin/armeb-linux-
ARCHIVE		= $(PWD)/archive
DL_DIR		= $(PWD)/archive/dl

WGET		= wget --passive-ftp
CVS_CO		= svn checkout
CVS_URL		= file:///home/dlink/SVN-ROOT/Source-4.1

ROOTFS		= $(PWD)/image/rootfs
UROOTFS		= $(PWD)/image/update_rootfs
OPTFS		= $(PWD)/image/optfs
MNTFS		= $(PWD)/image/mntfs

UPDATE_IMAGE	= update-fs
MAIN_IMAGE	= main-fs
OPT_IMAGE	= opt-fs
MNT_IMAGE	= mnt-fs

TFTP_PATH	= tftp
BDI_IP		= 192.168.0.208

TOOLCHAIN_URL	= http://buildroot.uclibc.org/downloads/snapshots/$(TOOLCHAIN_FILE)
TOOLCHAIN_FILE	= buildroot-20061009.tar.bz2
TOOLCHAIN_DIR	= $(PWD)/buildroot

TOOLCHAIN_CONFIG= $(PWD)/configs/toolchain_config26
UCLIBC_CONFIG	= $(PWD)/configs/uclibc.config26

KERNEL_URL	= http://www.kernel.org/pub/linux/kernel/v2.6/$(KERNEL_FILE)
KERNEL_FILE	= linux-2.6.16.9.tar.bz2
KERNEL_DIR	= $(PWD)/linux-2.6.16.9
KERNEL_CONFIG	= $(PWD)/configs/kernel26_config
KERNEL_SRC	= $(KERNEL_DIR)
KERNEL_PATCH	= patch.kernel-2.6
KERNEL_MTD_PATCH= patch.mtd-kernel-2.6

SQUASHFS_URL	= http://puzzle.dl.sourceforge.net/sourceforge/squashfs/$(SQUASHFS_FILE)
SQUASHFS_FILE	= squashfs3.0.tar.gz

INTEL_DIR	= $(PWD)/IntelAccessLibrary26
INTEL_FILE	= BSD_ixp400AccessLibrary-2_3.zip
INTEL_NPE	= IPL_ixp400NpeLibrary-2_3.zip
INTEL_SRC	= $(INTEL_DIR)/ixp400_xscale_sw/
INTEL_PATCH	= patch.AccessLib_2.3
INTEL_ETH_FILE  = GPL_ixp400LinuxEthernetDriverPatch-1_6.zip

MKSQUASHFS	= mksquashfs
MKJFFS2		= mkfs.jffs2

BUSYBOX_URL	= http://www.busybox.net/downloads/$(BUSYBOX_FILE)
BUSYBOX_FILE	= busybox-1.00.tar.gz
BUSYBOX_DIR	= $(PWD)/buildroot/build_armeb_nofpu/busybox-1.2.1
BUSYBOX_CONFIG	= $(PWD)/configs/busybox
BUSYBOX_SRC	= $(BUSYBOX_DIR)

ASTERISK_URL	= http://ftp.digium.com/pub/asterisk/releases/$(ASTERISK_FILE)
ASTERISK_FILE	= asterisk-1.2.9.1.tar.gz
ASTERISK_DIR	= $(PWD)/asterisk-1.2.9.1
ASTERISK_PATCH	= patch.asterisk-1.2.9

ZAPTEL_URL	= http://ftp.digium.com/pub/zaptel/releases/$(ZAPTEL_FILE)
ZAPTEL_FILE	= zaptel-1.2.6.tar.gz
ZAPTEL_DIR	= $(PWD)/zaptel-1.2.6
ZAPTEL_PATCH	= patch.zaptel-1.2.6

LIBPRI_URL	= http://ftp.digium.com/pub/libpri/releases/$(LIBPRI_FILE)
LIBPRI_FILE	= libpri-1.2.3.tar.gz
LIBPRI_DIR	= $(PWD)/libpri-1.2.3
LIBPRI_PATCH	= patch.libpri-1.2.3

BRISTUFF_URL	= http://www.junghanns.net/downloads/$(BRISTUFF_FILE)
BRISTUFF_FILE	= bristuff-0.3.0-PRE-1q.tar.gz
BRISTUFF_DIR	= $(PWD)/bristuff-0.3.0-PRE-1q

SAMBA_URL	= http://de.samba.org/samba/ftp/old-versions/$(SAMBA_FILE)
SAMBA_FILE	= samba-3.0.23c.tar.gz
SAMBA_DIR	= $(PWD)/samba-3.0.23c
SAMBA_SRC	= $(SAMBA_DIR)/source
SAMBA_PATCH	= patch.samba

LPR_URL		= http://ftp.debian.org/debian/pool/main/l/lpr/$(LPR_FILE)
LPR_FILE	= lpr_2006.08.03.tar.gz
LPR_DIR		= $(PWD)/lpr-2006.08.03
LPR_PATCH	= patch.lpr

MPG123_URL	= http://www.mpg123.de/mpg123/$(MPG123_FILE)
MPG123_FILE	= mpg123-0.59r.tar.gz
MPG123_DIR	= $(PWD)/mpg123-0.59r
MPG123_PATCH	= patch.mpg123-0.59r

SPEEX_URL	= http://downloads.us.xiph.org/releases/speex/$(SPEEX_FILE)
SPEEX_FILE	= speex-1.0.5.tar.gz
SPEEX_DIR	= $(PWD)/speex-1.0.5

MHTTPD_DIR	= mhttpd
MHTTPD_SRC	= $(PWD)/$(MHTTPD_DIR)/src
MHTTPD_CVS	= $(CVS_URL)/mhttpd

PCRE_URL	= ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/pcre-7.0.tar.bz2
PCRE_FILE	= pcre-7.0.tar.bz2
PCRE_DIR	= pcre-7.0

HTDOCS_DIR	= html
HTDOCS_CVS	= $(CVS_URL)/html

SOUNDS_DIR	= sound_samples
SOUNDS_CVS	= $(CVS_URL)/sound_samples

EXT_SND_URL	= http://www.stadt-pforzheim.de/asterisk/dateien/$(EXT_SND_FILE)
EXT_SND_FILE	= ast_prompts_de_v2_0.tar.gz
EXT_SND_DIR	= $(PWD)/ast_prompts_de_v2_0

NVRAM_DIR	= nvram
NVRAM_SRC	= $(PWD)/$(NVRAM_DIR)/src
NVRAM_CVS	= $(CVS_URL)/nvram

SMALL_NVRAM_DIR	= small_nvram
SMALL_NVRAM_SRC	= $(PWD)/$(SMALL_NVRAM_DIR)/src

WPOST_DIR	= wpost
WPOST_SRC	= $(PWD)/$(WPOST_DIR)/src
WPOST_CVS	= $(CVS_URL)/wpost

RCMD_DIR	= rcmd
RCMD_SRC	= $(PWD)/$(RCMD_DIR)/src
RCMD_CVS	= $(CVS_URL)/rcmd

REDCONFIG_DIR	= redconfig
REDCONFIG_SRC	= $(PWD)/$(REDCONFIG_DIR)/src
REDCONFIG_CVS	= $(CVS_URL)/redconfig

SERVICE_DIR	= run-service
SERVICE_SRC	= $(PWD)/$(SERVICE_DIR)
SERVICE_CVS	= $(CVS_URL)/run-service

PRINT_DIR	= printserv
PRINT_SRC	= $(PWD)/$(PRINT_DIR)
PRINT_CVS	= $(CVS_URL)/printserv

CHANMON_DIR	= chanmon
CHANMON_SRC	= $(PWD)/$(CHANMON_DIR)
CHANMON_CVS	= $(CVS_URL)/chanmon

SI3210_DIR	= si3210
SI3210_SRC	= $(PWD)/$(SI3210_DIR)
SI3210_CVS	= $(CVS_URL)/si3210

ZAPHFC_DIR	= zaphfc
ZAPHFC_SRC	= $(PWD)/$(ZAPHFC_DIR)
ZAPHFC_CVS	= $(CVS_URL)/zaphfc

SMALL_BUSYBOX_DIR=$(PWD)/busybox-small
SMALL_BUSYBOX_CONFIG=$(PWD)/configs/small_busybox

BOARD_RESET_DIR	= board_reset
BOARD_RESET_SRC	= $(PWD)/$(BOARD_RESET_DIR)
BOARD_RESET_CVS	= $(CVS_URL)/board_reset

LEDMAN_DIR	= ixp425-ledman
LEDMAN_SRC	= $(PWD)/$(LEDMAN_DIR)
LEDMAN_CVS	= $(CVS_URL)/ixp425-ledman

LEDCFG_DIR	= ledcfg
LEDCFG_SRC	= $(PWD)/$(LEDCFG_DIR)
LEDCFG_CVS	= $(CVS_URL)/ledcfg

STUNC_DIR	= stunc
STUNC_SRC	= $(PWD)/$(STUNC_DIR)/src
STUNC_CVS	= $(CVS_URL)/stunc

BOARD_CFG_DIR	= board_config
BOARD_CFG_CVS	= $(CVS_URL)/board_config

EXPECT_DIR	= expect-5.43
EXPECT_SRC	= $(PWD)/$(EXPECT_DIR)
EXPECT_FILE	= expect.tar.gz
EXPECT_URL	= http://expect.nist.gov/$(EXPECT_FILE)

ZAPATA_SRC	= $(PWD)/zapata
ZAPATA_DIR	= $(PWD)/zapata
ZAPATA_FILE	= zapata.tar.gz
ZAPATA_URL	= http://localhost/$(ZAPATA_FILE)

BiST_DIR	= $(PWD)/BiST
BiST_SRC	= $(PWD)/$(BIST_DIR)/
BiST_CVS	= $(CVS_URL)/build_env

OPROFILE_DIR	= oprofile-0.9.1
OPROFILE_SRC	= $(PWD)/$(OPROFILE_DIR)
OPROFILE_FILE	= oprofile-0.9.1.tar.gz
OPROFILE_URL	= http://mesh.dl.sourceforge.net/sourceforge/oprofile/$(OPROFILE_FILE)

POPT_DIR	= popt-1.7
POPT_SRC	= $(PWD)/$(POPT_DIR)
POPT_FILE	= popt-1.7.tar.gz
POPT_URL	= ftp://ftp.rpm.org/pub/rpm/dist/rpm-4.1.x/$(POPT_FILE)

BINUTILS_FILE	= binutils-2.16.91.0.7.tar.bz2
BINUTILS_DIR	= binutils-2.16.91.0.7
BINUTILS_SRC	= binutils-2.16.91.0.7/binutils

BFD_DIR		= $(BINUTILS_DIR)/bfd
LIBIBERTY_DIR	= $(BINUTILS_DIR)/libiberty
OPCODES_DIR	= $(BINUTILS_DIR)/opcodes

UPDATE_DIR	= horst_update
UPDATE_CVS	= $(CVS_URL)/horst_update

WININST_DIR	= win_installer
WININST_CVS	= $(CVS_URL)/win_installer

IMAGECRTOR_DIR	= image_creator
IMAGECRTOR_CVS	= $(CVS_URL)/image_creator

