#
# Intel
#
#


$(DL_DIR)/$(INTEL_FILE):
	@echo
	@echo "                           !!! Problem !!!"
	@echo
	@echo "The Intel AccessLibrary 2.3 was not found. Please visit "
	@echo "http://www.intel.com/design/network/products/npfamily/ixp425swr1.htm"
	@echo "and download the necessary file to"
	@echo "$@"
	@echo "and start make again."
	@echo
	exit 1


$(DL_DIR)/$(INTEL_NPE):
	@echo
	@echo "                           !!! Problem !!!"
	@echo
	@echo "The Intel IXP400 Software NPE microcode was not found. Please visit "
	@echo "http://www.intel.com/design/network/products/npfamily/ixp425swr1.htm"
	@echo "and download the necessary file to"
	@echo "$@"
	@echo "and start make again."
	@echo
	exit 1

$(DL_DIR)/$(INTEL_UPDATE):
	@echo
	@echo "                           !!! Problem !!!"
	@echo
	@echo "The Intel AccessLibrary 2.1.1 patch was not found. Please visit "
	@echo "http://www.intel.com/design/network/products/npfamily/ixp425swr1.htm"
	@echo "and download the necessary file to"
	@echo "$@"
	@echo "and start make again."
	@echo
	exit 1


$(DL_DIR)/$(INTEL_ETH_FILE):
	@echo
	@echo "                           !!! Problem !!!"
	@echo
	@echo "The Intel IXP400 Software Linux Ethernet Device Driver v1.6 was not found."
	@echo "Please visit http://www.intel.com/design/network/products/npfamily/ixp425swr1.htm"
	@echo "and download the necessary file to"
	@echo "$@"
	@echo "and start make again."
	@echo
	exit 1


mk_intel_dir:
	mkdir $(INTEL_DIR)
	cd $(INTEL_DIR) && unzip $(DL_DIR)/$(INTEL_FILE)
	cd $(INTEL_DIR) && unzip $(DL_DIR)/$(INTEL_NPE)
#	cd $(INTEL_DIR) && unzip $(DL_DIR)/$(INTEL_UPDATE)
#	cd $(INTEL_DIR) && patch -p0 < BSD_ixp400AccessLibrary-2_1_1.patch
	cd $(INTEL_DIR) && patch -p0 < $(ARCHIVE)/$(INTEL_PATCH)


$(INTEL_DIR):	$(DL_DIR)/$(INTEL_FILE) $(DL_DIR)/$(INTEL_NPE) $(DL_DIR)/$(INTEL_UPDATE)
	[ -d $(INTEL_DIR) ] || $(MAKE) mk_intel_dir


intel_build:	$(INTEL_DIR) $(KERNEL_DIR)
	linuxbe_KERNEL_DIR=$(KERNEL_DIR)		\
	IX_XSCALE_SW=$(INTEL_SRC)			\
	IX_DEVICE=ixp42X				\
	IX_PLATFORM=ixdp42x				\
	IX_TARGET=linuxbe				\
	IX_LINUXVER=2.6					\
	ARCH=arm					\
	COMPONENTS="qmgr npeMh npeDl ethAcc ethDB ethMii hssAcc featureCtrl ossl osServices" \
	CROSS_COMPILE=$(CROSS_COMPILE)			\
	$(MAKE) -C $(INTEL_SRC) modules

intel_clean:
	linuxbe_KERNEL_DIR=$(KERNEL_DIR)		\
	IX_XSCALE_SW=$(INTEL_SRC)			\
	IX_DEVICE=ixp42X				\
	IX_PLATFORM=ixdp42x				\
	IX_TARGET=linuxbe				\
	IX_LINUXVER=2.6					\
	ARCH=arm					\
	CROSS_COMPILE=$(CROSS_COMPILE)			\
	$(MAKE) -C $(INTEL_SRC) clean

intel_install: intel_build
	mkdir -p $(ROOTFS)/lib/modules
	cp $(INTEL_SRC)/lib/linuxbe/ixp400.ko $(ROOTFS)/lib/modules/
	cp $(INTEL_SRC)/lib/linuxbe/*.dat $(ROOTFS)/lib/modules/


intel_distclean:
	$(RM) -r $(INTEL_DIR)
