#
# Kernel
#
#

$(DL_DIR)/$(KERNEL_FILE):
	$(WGET) -P $(DL_DIR) $(KERNEL_URL)

$(DL_DIR)/$(SQUASHFS_FILE):
	$(WGET) -P $(DL_DIR) $(SQUASHFS_URL)

$(KERNEL_DIR):	$(DL_DIR)/$(KERNEL_FILE) $(DL_DIR)/$(INTEL_ETH_FILE) $(DL_DIR)/$(SQUASHFS_FILE)
	tar xfjm $(DL_DIR)/$(KERNEL_FILE)
	cd $(KERNEL_DIR)/drivers/net/ && unzip $(DL_DIR)/$(INTEL_ETH_FILE) ixp400_eth.c
	cd $(KERNEL_DIR) &&  unzip -p $(DL_DIR)/$(INTEL_ETH_FILE) *.patch | patch -p1
	cd $(KERNEL_DIR) &&  tar Oxfz $(DL_DIR)/$(SQUASHFS_FILE) squashfs3.0/linux-2.6.15/squashfs3.0-patch | patch -p1
	cd $(KERNEL_DIR) &&  patch -p1 < $(ARCHIVE)/$(KERNEL_PATCH)
	cp $(KERNEL_CONFIG) $(KERNEL_DIR)/.config

kernel_config:	$(KERNEL_DIR) $(KERNEL_DIR)/drivers/net/ixp400_eth.c
	ARCH=$(ARCH) CROSS_COMPILE=$(CROSS_COMPILE) 	\
	$(MAKE) -C $(KERNEL_SRC) menuconfig

kernel_clean:	$(KERNEL_DIR)
	IX_XSCALE_SW=$(INTEL_SRC)			\
	OSAL_DIR=$(INTEL_DIR)/ixp_osal			\
	ARCH=$(ARCH) CROSS_COMPILE=$(CROSS_COMPILE)	\
	$(MAKE) -C $(KERNEL_SRC) clean
	cp $(KERNEL_CONFIG) $(KERNEL_DIR)/.config

kernel_build: $(KERNEL_DIR) $(INTEL_DIR)
	IX_XSCALE_SW=$(INTEL_SRC)			\
	OSAL_DIR=$(INTEL_DIR)/ixp_osal			\
	ARCH=$(ARCH) CROSS_COMPILE=$(CROSS_COMPILE)	\
	$(MAKE) -C $(KERNEL_SRC)

kernel_install:	$(KERNEL_DIR)
	cp $(KERNEL_SRC)/arch/arm/boot/zImage image/
	chmod 644 image/zImage
	find $(KERNEL_DIR) -name "*.ko" -exec cp -v {} $(ROOTFS)/lib/modules/ \;
	fs=$$(stat -c %s image/zImage);	\
	is=$$(expr 1048576 - $$fs);	\
	dd if=/dev/zero bs=$$is count=1 | cat image/zImage - > image/kernel-image

kernel_distclean:
	$(RM) -r $(KERNEL_DIR)
