#
# nvram tool
#
#

$(NVRAM_DIR):
	$(CVS_CO) $(NVRAM_CVS) $(NVRAM_DIR)
	chmod 755 $(NVRAM_SRC)/autostuff.sh
	chmod 755 $(NVRAM_SRC)/libnvram/autostuff.sh
	chmod 755 $(NVRAM_SRC)/libnvtools/autostuff.sh

$(NVRAM_SRC)/Makefile:
	cd $(NVRAM_SRC) && ./autostuff.sh
	cd $(NVRAM_SRC) && ./configure --host=armeb-linux --enable-flash --prefix=$(ROOTFS) --enable-runtime-only --enable-preload-data=$(TARGET_SYSTEM)

nvram_distclean:
	$(RM) -r $(NVRAM_DIR)

nvram_%:	$(NVRAM_DIR) $(NVRAM_SRC)/Makefile
	$(MAKE) -C $(NVRAM_SRC) $(subst build,all,$(subst nvram_,,$@))


$(SMALL_NVRAM_DIR):
	$(CVS_CO) $(NVRAM_CVS) $(SMALL_NVRAM_DIR)
	chmod 755 $(SMALL_NVRAM_SRC)/autostuff.sh
	chmod 755 $(SMALL_NVRAM_SRC)/libnvram/autostuff.sh
	chmod 755 $(SMALL_NVRAM_SRC)/libnvtools/autostuff.sh

$(SMALL_NVRAM_SRC)/Makefile:
	cd $(SMALL_NVRAM_SRC) && ./autostuff.sh
	cd $(SMALL_NVRAM_SRC) && ./configure --host=armeb-linux --enable-flash --prefix=$(UROOTFS) --enable-runtime-only --without-ssl --enable-squeeze --enable-preload-data=$(TARGET_SYSTEM) --disable-http 


$(SMALL_NVRAM_SRC)/crypt/dsa0key.h:
	touch $@

$(SMALL_NVRAM_SRC)/crypt/dsa1key.h:
	touch $@

$(SMALL_NVRAM_SRC)/crypt/dsaparam.h:
	touch $@

small_nvram_distclean:
	$(RM) -r $(SMALL_NVRAM_DIR)

small_nvram_%:	$(SMALL_NVRAM_DIR) $(SMALL_NVRAM_SRC)/Makefile $(SMALL_NVRAM_SRC)/crypt/dsa0key.h $(SMALL_NVRAM_SRC)/crypt/dsa1key.h $(SMALL_NVRAM_SRC)/crypt/dsaparam.h
	$(MAKE) -C $(SMALL_NVRAM_SRC) $(subst build,all,$(subst small_nvram_,,$@))
