#
# Samba
#
#

$(DL_DIR)/$(SAMBA_FILE):
	$(WGET) -P $(DL_DIR) $(SAMBA_URL)

$(SAMBA_SRC)/Makefile:
	cd $(SAMBA_SRC) && ./autogen.sh
	export samba_cv_HAVE_GETTIMEOFDAY_TZ=yes; 	\
	export samba_cv_USE_SETRESUID=yes;		\
	export CFLAGS="-Os";				\
	cd $(SAMBA_SRC) && ./configure --host=armeb-linux --prefix=$(ROOTFS) --without-cups --disable-cups --without-swat --without-krb5 --without-ldap --without-ads --disable-pie --without-winbind --with-privatedir=/etc --with-lockdir=/var/lock --with-piddir=/var/run --with-logilfebase=/var/log/samba --with-configdir=/etc 

$(SAMBA_DIR): $(DL_DIR)/$(SAMBA_FILE)
	tar xfzm $(DL_DIR)/$(SAMBA_FILE)
	cd $(SAMBA_DIR) && patch -p1 < $(ARCHIVE)/$(SAMBA_PATCH)

samba_clean:
	$(MAKE) -C $(SAMBA_SRC) clean

samba_realdistclean:
	$(MAKE) -C $(SAMBA_SRC) realdistclean

samba_distclean:
	$(RM) -r $(SAMBA_DIR)

samba_build: $(SAMBA_DIR) $(SAMBA_SRC)/Makefile
	$(MAKE) -C $(SAMBA_SRC)

samba_install:
	cp $(SAMBA_SRC)/bin/nmbd	$(ROOTFS)/sbin/
	cp $(SAMBA_SRC)/bin/smbd	$(ROOTFS)/sbin/
	cp $(SAMBA_SRC)/bin/smbpasswd 	$(ROOTFS)/sbin/
