#
# Toolchain
#
#

$(DL_DIR)/$(TOOLCHAIN_FILE):
	$(WGET) -P $(DL_DIR) $(TOOLCHAIN_URL)


$(TOOLCHAIN_DIR): $(DL_DIR)/$(TOOLCHAIN_FILE)
	tar xfjm $(DL_DIR)/$(TOOLCHAIN_FILE)
	cp $(TOOLCHAIN_CONFIG) $(TOOLCHAIN_DIR)/.config
	cp $(UCLIBC_CONFIG) $(TOOLCHAIN_DIR)/toolchain/uClibc/uClibc.config
	cp $(ARCHIVE)/patch.dropbear $(TOOLCHAIN_DIR)/package/dropbear/dropbear.patch
	cp $(ARCHIVE)/patch.tcl $(TOOLCHAIN_DIR)/package/tcl/tcl.patch
#	cd $(TOOLCHAIN_DIR)/toolchain/gdb && patch -p1 <  $(ARCHIVE)/patch.gdb
	$(MAKE) -C $(TOOLCHAIN_DIR) oldconfig


toolchain_config: $(TOOLCHAIN_DIR)
	$(MAKE) -C $(TOOLCHAIN_DIR) menuconfig


toolchain_build: $(TOOLCHAIN_DIR)
	$(MAKE) -C $(TOOLCHAIN_DIR)
	rm -f toolchain/bin/openssl
	rm -f toolchain/include/mtd
	rm -f toolchain/usr/local
	rm -f toolchain/usr/include
	ln -s $(KERNEL_SRC)/include/mtd toolchain/include/
	ln -s ../ toolchain/usr/local
	ln -s ../include toolchain/usr/include


toolchain_install: $(ROOTFS)
	cp -a buildroot/build_armeb_nofpu/root/* $(ROOTFS)/
	rm -rf	$(ROOTFS)/home		\
		$(ROOTFS)/opt 		\
		$(ROOTFS)/root		\
		$(ROOTFS)/var/pcmcia 	\
		$(ROOTFS)/var/spool	\
		$(ROOTFS)/var/lock	\
		$(ROOTFS)/var/log	\
		$(ROOTFS)/var/run
	cp -a toolchain/lib/libgcc_s* $(ROOTFS)/lib/

toolchain_distclean:
	$(RM) -rf toolchain $(TOOLCHAIN_DIR)

