#
# Update Image
#
#

UPDATE_DEPS=toolchain_build intel_build small_busybox_build redconfig_build small_nvram_build

INTEL_MODULES= 	$(LEDMAN_DIR)/ixp425-ledman.ko			\
		$(INTEL_SRC)/lib/linuxbe/ixp400.ko		\
		$(INTEL_SRC)/lib/linuxbe/IxNpeMicrocode.dat	\
		$(KERNEL_SRC)/drivers/net/ixp400_eth.ko

$(SMALL_BUSYBOX_DIR): $(DL_DIR)/$(BUSYBOX_FILE)
	mkdir $(SMALL_BUSYBOX_DIR)
	tar xzf $(DL_DIR)/$(BUSYBOX_FILE) -C $(SMALL_BUSYBOX_DIR)
	mv $(SMALL_BUSYBOX_DIR)/busybox*/* $(SMALL_BUSYBOX_DIR)
	cp $(SMALL_BUSYBOX_CONFIG) $(SMALL_BUSYBOX_DIR)/.config
	LIBRARIES=-mbig-endian $(MAKE) -C $(SMALL_BUSYBOX_DIR) oldconfig


small_busybox_config:
	LIBRARIES=-mbig-endian $(MAKE) -C $(SMALL_BUSYBOX_DIR) menuconfig


small_busybox_clean:
	LIBRARIES=-mbig-endian $(MAKE) -C $(SMALL_BUSYBOX_DIR) clean

small_busybox_distclean:
	$(RM) -r $(SMALL_BUSYBOX_DIR)

small_busybox_build: $(SMALL_BUSYBOX_DIR)
	LIBRARIES=-mbig-endian $(MAKE) -C $(SMALL_BUSYBOX_DIR)

small_busybox_install:
	$(MAKE) PREFIX=$(UROOTFS) -C $(SMALL_BUSYBOX_DIR) install

update_image: $(UPDATE_DEPS)
	rm -fr $(UROOTFS)
	mkdir -p $(UROOTFS)/dev		\
		 $(UROOTFS)/tmp		\
		 $(UROOTFS)/proc	\
		 $(UROOTFS)/lib/modules	\
		 $(UROOTFS)/var		\
		 $(UROOTFS)/bin		\
		 $(UROOTFS)/sbin
	ln -s 	/tmp $(UROOTFS)/var/run
	ln -s 	/tmp $(UROOTFS)/var/log
	ln -s 	/tmp $(UROOTFS)/var/lock
	$(MAKE) small_busybox_install
	$(MAKE) small_nvram_install
	cp 	$(INTEL_MODULES) $(UROOTFS)/lib/modules/
	cp 	toolchain/lib/libc.so.0				\
		toolchain/lib/libgcc_s.so.1			\
		toolchain/lib/ld-uClibc.so.0			\
		toolchain/lib/libdl.so.0			\
		$(UROOTFS)/lib/
	cp	./buildroot/build_armeb_nofpu/mtd*/util/flashcp		\
		./buildroot/build_armeb_nofpu/mtd*/util/flash_lock	\
		./buildroot/build_armeb_nofpu/mtd*/util/flash_unlock	\
		$(REDCONFIG_SRC)/write_redconfig		\
		$(REDCONFIG_SRC)/dump_redconfig			\
		$(LEDCFG_SRC)/ledcfg				\
		$(UROOTFS)/sbin/
	cp -a	configs/skel.update-fs/* $(UROOTFS)/
	-find $(UROOTFS) -name "lib*.a" | xargs rm
	-find $(UROOTFS) -name "lib*.la" | xargs rm
	-find $(UROOTFS) -type f -name "*.so.*" | xargs $(CROSS_COMPILE)strip
	-find $(UROOTFS) -type f -perm -100 | xargs $(CROSS_COMPILE)strip
	-find $(UROOTFS) -name CVS -type d | xargs rm -r
	-find $(UROOTFS) -name include -type d | xargs rm -r
	PATH=/sbin:/usr/sbin:$(PATH) fakeroot sh -c \
	"chown -R root: $(UROOTFS) && sh scripts/mk.dev_nodes $(UROOTFS)/dev/ && $(MKSQUASHFS) $(UROOTFS)/* image/$(UPDATE_IMAGE) -be -noappend"
	chmod 644 image/$(UPDATE_IMAGE)*
	ls -l 	image/$(UPDATE_IMAGE)*
