#
# zapata library
#
#

$(DL_DIR)/$(ZAPATA_FILE):
	$(WGET) -P $(DL_DIR) $(ZAPATA_URL)


$(ZAPATA_DIR):	$(DL_DIR)/$(ZAPATA_FILE)
	tar xzfm $(DL_DIR)/$(ZAPATA_FILE)


$(ZAPATA_SRC)/Makefile:
	cd $(ZAPATA_SRC) && PATH=$(PWD)/toolchain/bin:$$PATH ./configure --host=armeb-linux --target=armeb-linux --enable-flash --prefix=$(ROOTFS) --with-tcl=$(PWD)/buildroot/build_armeb_nofpu/tcl8.4.9/unix
	cp $(ZAPATA_SRC)/pty_termios.c $(ZAPATA_SRC)/pty_.c
	echo "#define HAVE_TERMIO 1" >> $(ZAPATA_SRC)/expect_cf.h

zapata_distclean:
	$(RM) -r $(ZAPATA_DIR)

zapata_install:	$(ZAPATA_DIR) $(ZAPATA_SRC)/Makefile zapata_build
	cp $(ZAPATA_SRC)/expect $(ROOTFS)/bin/

zapata_%:	$(ZAPATA_DIR) $(ZAPATA_SRC)/Makefile
	PATH=$(PWD)/toolchain/bin:$$PATH	\
	ZAPTEL_DIR=$(ZAPTEL_DIR)		\
	CC="$(CROSS_COMPILE)gcc -mcpu=xscale"		\
	$(MAKE) -C $(ZAPATA_SRC) $(subst build,all,$(subst zapata_,,$@))


