#
# Zaptel
#
#

ZAPTEL_HEADER=zaptel.h zconfig.h ecdis.h fasthdlc.h mec2.h biquad.h arith.h mec2_const.h kb1ec.h kb1ec_const.h

ZAPTEL_TARGET += linux26 ztcfg libtonezone.so ztmonitor

$(DL_DIR)/$(ZAPTEL_FILE):
	$(WGET) -P $(DL_DIR) $(ZAPTEL_URL)

$(ZAPTEL_DIR): $(DL_DIR)/$(ZAPTEL_FILE) $(BRISTUFF_DIR)
	tar xzf $(DL_DIR)/$(ZAPTEL_FILE)
	cd $(ZAPTEL_DIR) && patch -p1 < $(BRISTUFF_DIR)/patches/zaptel.patch
	cd $(ZAPTEL_DIR) && patch -p1 < $(ARCHIVE)/$(ZAPTEL_PATCH)


zaptel_build: $(ZAPTEL_DIR)
	KVERS=2.6 KSRC=$(KERNEL_SRC)			\
	ARCH=$(ARCH) CROSS_COMPILE=$(CROSS_COMPILE) 	\
	CC="$(CROSS_COMPILE)gcc -mcpu=xscale"		\
	$(MAKE) -C $(ZAPTEL_DIR) $(ZAPTEL_TARGET)
	cd $(KERNEL_SRC)/include/linux/ && rm -f $(ZAPTEL_HEADER)
	cd toolchain/include/linux/ && rm -f $(ZAPTEL_HEADER)
	cd $(ZAPTEL_DIR) && cp $(ZAPTEL_HEADER) $(KERNEL_SRC)/include/linux/
	cd $(ZAPTEL_DIR) && cp $(ZAPTEL_HEADER) $(PWD)/toolchain/include/linux/
	rm -f toolchain/include/tonezone.h
	rm -f toolchain/lib/libtonezone.so
	ln -s $(ZAPTEL_DIR)/tonezone.h toolchain/include/
	ln -s $(ZAPTEL_DIR)/libtonezone.so toolchain/lib/libtonezone.so


zaptel_install: zaptel_build
	cp $(ZAPTEL_DIR)/zaptel.ko $(ROOTFS)/lib/modules/
	cp $(ZAPTEL_DIR)/ztcfg $(ROOTFS)/bin/
	cp $(ZAPTEL_DIR)/ztmonitor $(ROOTFS)/bin/
	cp $(ZAPTEL_DIR)/libtonezone.so $(ROOTFS)/lib/
	rm -f $(ROOTFS)/lib/libtonezone.so.1.0
	rm -f $(ROOTFS)/lib/libtonezone.so.1
	ln -s libtonezone.so $(ROOTFS)/lib/libtonezone.so.1.0
	ln -s libtonezone.so $(ROOTFS)/lib/libtonezone.so.1

zaptel_distclean:
	$(RM) -r $(ZAPTEL_DIR)
	

zaptel_clean:
	$(MAKE) -C $(ZAPTEL_DIR) clean

