

#ifndef _chanmon_h
#define _chanmon_h

#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <errno.h>
#include <sys/signal.h>
#include <nvram/nvram-lib.h>

/* --------------------------------------------------------------- 
 * defaults for the asterisk manager interface 
 * ---------------------------------------------------------------*/
#define _tcp_port 	5038		/* server port */
#define _serv_addr	"127.0.0.1"	/* server ip */
#define DEFAULT_USER    "chanmon"       /* default username */
#define DEFAULT_SECRET  "chanmon"       /* default password */

#define MAX_LENGTH	100		/* max buffer length */
#define MAX_CMD		30		/* max name-value pairs 
					   of one command block */

typedef enum { 	NEWCHANNEL, 
		HANGUP,
		SHUTDOWN,
		OTHER 
	     } 	EVENT;

typedef enum { 	FALSE = 0, 
		TRUE = 1 
	     }	BOOL;

struct nvpair_t {
	char *name;
	char *value;
};

typedef struct {
	int cmd_count;
	int read;
	struct nvpair_t command[MAX_CMD];
} MESG;

typedef struct elem_t {
	char *id;
	struct elem_t *next;
} ELEM;

#endif
