#!/bin/sh


# this tests looks for the presents of all values in all files
check_missing_values()
{
	files=$*
	number=$#

	echo "Check for missing values in $files:"
	cat $files | sed 's/^[ \t]*//' | grep  '^\$' | cut -d ':' -f 1 | sed 's/^\${//' | sort | uniq -c | while read occ val
	do
	  [ "$number" -le "$occ" ] && continue

	  echo -n "    $val is not present in ($occ) "

	  for f in $files; do
	    grep -F $val $f>/dev/null && continue
  	    echo -n "$f "
	  done

	  echo

	done

}


echo "Check for double variables in de/texts.tmpl:"
cat de/texts.tmpl | sed 's/^[ \t]*//' | grep  '^\$' | cut -d ':' -f 1 | sort | uniq -d -c

echo "Check for double variables in en/texts.tmpl:"
cat en/texts.tmpl | sed 's/^[ \t]*//' | grep  '^\$' | cut -d ':' -f 1 | sort | uniq -d -c

echo "Check for double variables in de/wiz.tmpl:"
cat de/wiz.tmpl | sed 's/^[ \t]*//' | grep '^\$' | cut -d ':' -f 1 | sort | uniq -d -c

echo "Check for double variables in en/wiz.tmpl:"
cat en/wiz.tmpl | sed 's/^[ \t]*//' | grep '^\$' | cut -d ':' -f 1 | sort | uniq -d -c

check_missing_values de/texts.tmpl en/texts.tmpl

check_missing_values de/wiz.tmpl en/wiz.tmpl

