/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#ifndef __COMMHANDLER_H
#define __COMMHANDLER_H

#include "ctrl.h"
#include "list.h"
#include "util.h"
#include "http.h"

/* communication through the control socket */
typedef struct _comm {
#   ifdef __COMHANDLER_PRIVATE
    time_t    started ;
    unsigned  timeout ;
    CTRL        *ctrl ;
    LIST        *list ;
    HTTP        *http ;
#   else
    char          any ;
#   endif
} COMM;


extern COMM *comm_init   (LIST*,HTTP*);
extern COMM *comm_update (COMM*,CTRL*);

/* unix domain socket commands */
extern void comm_close    (COMM*);
extern void comm_info     (void*,int,const char**);
extern void comm_list     (void*,int,const char**);
extern void comm_set      (void*,int,const char**);
extern void comm_del      (void*,int,const char**);
extern void comm_restart  (void*,int,const char**);

#endif /* __COMMHANDLER_H */
