/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#ifndef __HTTP_DL_H
#define __HTTP_DL_H

#include "nvram-lib.h"

#ifdef __HTTP_DL_PRIVATE
struct _rply_rec ;
#endif

typedef
struct _dll_cache {
#   ifdef __HTTP_DL_PRIVATE
    struct {
        void       *handle  ;
        time_t      touched ;
        const char *lookup  ;
    } so ;
    struct {
        void *handle ;
        void (*htrun)     (void*,struct _rply_rec*,int,const char**) ;
        void (*htcleanup) (void*) ;
        
    } fn ;
#   else
    char                any ;
#   endif
} DLL_CACHE ;

/* public interface */
extern unsigned dllopen_handler (void);
extern void    dllclose_handler (void);
extern void    dllflush_handler (DLL_CACHE*,size_t);
extern DLL_CACHE  *call_handler (DLL_CACHE*,size_t,
                                 const char*,const char*,const char*,NVCL*);
#endif /* __HTTP_DL_H */
