/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#ifndef __HTTP_PLUGIN_H
#define __HTTP_PLUGIN_H

#include "http.h"

/* plugin interface */
extern void        header_printf (RPLY_REC*, const char*, ...);
extern void        body_printf   (RPLY_REC*, const char*, ...);
extern void        body_append   (RPLY_REC*, const char*, size_t);
extern void        body_app_file (RPLY_REC*, int, size_t);
extern void        rplyerror     (RPLY_REC*, const char*);
extern const char *rplycode      (RPLY_REC*, unsigned);
extern const char *urlmethod     (RPLY_REC*);
extern MIMETYPE    mimetype      (RPLY_REC*,MIMETYPE);
extern unsigned    nextavpair    (RPLY_REC*,
                                  const char**,const char**,size_t*);
extern unsigned    getavalue     (RPLY_REC*,
                                  const char*, const char**,size_t*);
extern const char *dlpool_p      (RPLY_REC*, const char*);
extern const char *htdocs_p      (RPLY_REC*, const char*);
extern ip4addr_t   http_client   (RPLY_REC*);
extern uint16_t    http_clport   (RPLY_REC*);
extern const char *http_request  (RPLY_REC*);
extern unsigned    http_fallback (RPLY_REC*);
extern HLST       *http_args     (RPLY_REC*);
extern char 	  *getNextIndex  (HLST *nvram_avp, const char *listLabel, const char *total_elements_label);

/* prefix the path argument by dir unless absoulte */
extern const char *make_path (const char *dir, IOBUF*, const char *path);

#endif /* __HTTP_PLUGIN_H */
