/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany                                                     *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/


    /***********************/
    /* MISC-Settings */
    /***********************/

#ifndef __MHTTPD_MISC_SETTINGS_H
#define __MHTTPD_MISC_SETTINGS_H

/* binary plugins */
#define _htpng(s, pa) _htdef ("/" s, pa, _BINARY_SO, _IMAGE_PNG,  s) 
#define _htgif(s, pa) _htdef ("/" s, pa, _BINARY_SO, _IMAGE_GIF,  s) 
#define _htjpg(s, pa) _htdef ("/" s, pa, _BINARY_SO, _IMAGE_JPEG, s)
#define _htext(s, pa) _htdef ("/" s, pa, _BINARY_SO, _TEXT_PLAIN, s)
#define _htcss(s, pa) _htdef ("/" s, pa, _BINARY_SO, _TEXT_CSS,   s)

#define __b(p) "behaviour/" p
_htext (__b ("prototype-1.3.1.js"),                   _display ())
_htext (__b ("gui.js"),                               _display ())
_htext (__b ("behaviour.js"),                         _display ())
_htext (__b ("moo.fx.js"),                            _display ())
_htext (__b ("moo.fx.pack.js"),                       _display ())
_htext (__b ("scriptaculous-js-1.0/src/effects.js"),  _display ())
_htext (__b ("scriptaculous-js-1.0/src/controls.js"), _display ())
#undef  __b

#define __d(p) "design/" p
_htcss (__d ("screen.css"),             _display ())
_htcss (__d ("basic.css"),              _display ())
_htcss (__d ("extended.css"),           _display ())
_htcss (__d ("screen-ie5.css"),         _display ())
_htcss (__d ("screen-ie6.css"),         _display ())
_htjpg (__d ("body-bg.jpg"),            _display ())
_htjpg (__d ("head-bg.jpg"),            _display ())
_htpng (__d ("content-bg.png"),         _display ())
_htpng (__d ("footer-bg.png"),          _display ())
_htpng (__d ("welcome-options-bg.png"), _display ())
_htpng (__d ("welcome-item-bg.png"),    _display ())
_htpng (__d ("mainmenu-bg-corner.png"), _display ())
_htpng (__d ("mainmenu-bg-slide.png"),  _display ())
_htpng (__d ("product-name.png"),       _display ())
_htpng (__d ("submenu-bg.png"),         _display ())
_htpng (__d ("bt-add-bg.png"),          _display ())
_htpng (__d ("bt-assign-apply-bg.png"), _display ())
_htpng (__d ("bt-delete-bg.png"),       _display ())
_htpng (__d ("bt-edit-bg.png"),         _display ())
_htpng (__d ("bt-abort-bg.png"),        _display ())
_htpng (__d ("bt-back-bg.png"),         _display ())
_htpng (__d ("bt-forward-bg.png"),      _display ())
_htpng (__d ("bt-skip-bg.png"),         _display ())
_htpng (__d ("bt-test-bg.png"),         _display ())
_htpng (__d ("bt-blank-130x30.png"),    _display ())
_htpng (__d ("bt-edit-130x30.png"),     _display ())
_htpng (__d ("bt-delete-130x30.png"),   _display ())
_htpng (__d ("bt-abort-130x30.png"),    _display ())
_htpng (__d ("bt-back-130x30.png"),     _display ())
_htpng (__d ("bt-forward-130x30.png"),  _display ())
_htpng (__d ("bt-skip-130x30.png"),     _display ())
_htpng (__d ("bt-save-130x30.png"),     _display ())
_htpng (__d ("bt-save-45x22.png"),      _display ())
_htpng (__d ("bt-reset-130x30.png"),    _display ())
_htpng (__d ("icon-completed.png"),     _display ())
_htpng (__d ("icon-skipped.png"),       _display ())
_htpng (__d ("submenu-item-bg.png"),    _display ())
#undef  __d
   
#define __i(a) "content/icons/" a
_htpng (__i ("device-blue.png"),        _display ())
_htpng (__i ("device-green.png"),       _display ())
_htpng (__i ("device-pink.png"),        _display ())
_htpng (__i ("device-white.png"),       _display ())
_htpng (__i ("diversion-blue.png"),     _display ())
_htpng (__i ("diversion-green.png"),    _display ())
_htpng (__i ("diversion-pink.png"),     _display ())
_htpng (__i ("diversion-white.png"),    _display ())
_htpng (__i ("fax-blue.png"),           _display ())
_htpng (__i ("fax-green.png"),          _display ())
_htpng (__i ("fax-pink.png"),           _display ())
_htpng (__i ("fax-white.png"),          _display ())
_htpng (__i ("hand-blue.png"),          _display ())
_htpng (__i ("hand-green.png"),         _display ())
_htpng (__i ("hand-pink.png"),          _display ())
_htpng (__i ("hand-white.png"),         _display ())
_htpng (__i ("phone-blue.png"),         _display ())
_htpng (__i ("phone-green.png"),        _display ())
_htpng (__i ("phone-pink.png"),         _display ())
_htpng (__i ("phone-white.png"),        _display ())
#undef __i
   
#define __c(a) "content/" a
_htpng (__c ("d-link-logo.png"),        _display ())
_htjpg (__c ("wiz_wan.jpg"),            _display ())
_htjpg (__c ("wiz_lan.jpg"),            _display ())
_htjpg (__c ("wiz_phone1.jpg"),         _display ())
_htjpg (__c ("wiz_phone2.jpg"),         _display ())
_htjpg (__c ("wiz_phone3.jpg"),         _display ())
_htjpg (__c ("wiz_phone4.jpg"),         _display ())
_htpng (__c ("status.png"),             _display ())
_htgif (__c ("status.gif"),             _display ())
_htjpg (__c ("d-link-product.jpg"),     _display ())
_htpng (__c ("phone_cdr_out.png"),      _display ())
_htpng (__c ("phone_cdr_in.png"),       _display ())
#undef  __c

#undef _htpng
#undef _htjpg
#undef _htext
#undef _htcss
#endif /* __MHTTPD_MISC_SETTINGS_H */
