/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <strings.h>
#include <ctype.h>

#define  __MIME_TYPES_PRIVATE
#include "mime-types.h"

/* ----------------------------------------------------------------------- *
 * Private
 * ----------------------------------------------------------------------- */
#define DIM(x)        (sizeof (x) / (sizeof (x [0])))
#define _lookup_(x,y) {x, y, sizeof (y)-1},

static
const struct {

    MIMETYPE    type;
    const char *name;
    size_t    length;

} mimer [] = {

    SUPPORTED_MIME_TYPES (_lookup_)

};

#undef _lookup_

/* ----------------------------------------------------------------------- *
 * Public
 * ----------------------------------------------------------------------- */

MIMETYPE mimetype_code (const char *name) {
    int n = DIM (mimer) ;

    while (-- n >= 0)
        if (strncasecmp (name, mimer [n].name, mimer [n].length)  == 0 &&
            isalnum     (name                 [mimer [n].length]) == 0)
            return mimer [n].type ;

    return mime_none ;
}


const char *mimetype_name (MIMETYPE type) {
    int n = DIM (mimer) ;

    while (-- n >= 0)
        if (type == mimer [n].type)
            return mimer [n].name ;

    return 0 ;
}


/* ----------------------------------------------------------------------- *
 * End
 * ----------------------------------------------------------------------- */
