/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#ifndef __MIME_TYPES_H
#define __MIME_TYPES_H

typedef enum _mimetype {

    mime_none = 0,
	mime_any,

    /* application - 100 */
    application_activemessage = 100,
    application_andrew_inset,
    application_applefile,
    application_atomicmail,
    application_batch_SMTP,
    application_beep_xml,
    application_cals_1840,
    application_commonground,
    application_cu_seeme,
    application_cybercash,
    application_dca_rft,
    application_dec_dx,
    application_docbook_xml,
    application_dsptyp,
    application_dvcs,
    application_edi_consent,
    application_edifact,
    application_edi_x12,
    application_eshop,
    application_font_tdpfr,
    application_futuresplash,
    application_ghostview,
    application_hta,
    application_http,
    application_hyperstudio,
    application_iges,
    application_iotp,
    application_ipp,
    application_isup,
    application_mac_compactpro,
    application_marc,
    application_mac_binhex40,
    application_macwriteii,
    application_mathematica,
    application_mathematica_old,
    application_msaccess,
    application_msword,
    application_news_message_id,
    application_news_transmission,
    application_octet_stream,
    application_ocsp_request,
    application_ocsp_response,
    application_oda,
    application_ogg,
    application_parityfec,
    application_pics_rules,
    application_pgp_encrypted,
    application_pgp_keys,
    application_pdf,
    application_pgp_signature,
    application_pkcs10,
    application_pkcs7_mime,
    application_pkcs7_signature,
    application_pkix_cert,
    application_pkixcmp,
    application_pkix_crl,
    application_postscript,
    application_qsig,
    application_rar,
    application_rdf_xml,
    application_remote_printing,
    application_riscos,
    application_rss_xml,
    application_rtf,
    application_sdp,
    application_set_payment,
    application_set_payment_initiation,
    application_set_registration,
    application_set_registration_initiation,
    application_sgml,
    application_sgml_open_catalog,
    application_sieve,
    application_slate,
    application_smil,
    application_timestamp_query,
    application_timestamp_reply,
    application_vemmi,
    application_whoispp_query,
    application_whoispp_response,
    application_wita,
    application_wordperfect5_1,
    application_x400_bp,
    application_xhtml_xml,
    application_xml,
    application_xml_dtd,
    application_xml_external_parsed_entity,
    application_zip,

    /* application/prs - 600 */
    application_prs_alvestrand_titrax_sheet = 600,
    application_prs_cww,
    application_prs_nprend,

    /* application/index - 700 */
    application_index = 700,
    application_index_cmd,
    application_index_obj,
    application_index_response,
    application_index_vnd,

    /* application/vnd - 800 */
    application_vnd_3M_Post_it_Notes = 800,
    application_vnd_accpac_simply_aso,
    application_vnd_accpac_simply_imp,
    application_vnd_acucobol,
    application_vnd_aether_imp,
    application_vnd_anser_web_certificate_issue_initiation,
    application_vnd_anser_web_funds_transfer_initiation,
    application_vnd_audiograph,
    application_vnd_bmi,
    application_vnd_businessobjects,
    application_vnd_canon_cpdl,
    application_vnd_canon_lips,
    application_vnd_cinderella,
    application_vnd_claymore,
    application_vnd_commerce_battelle,
    application_vnd_commonspace,
    application_vnd_comsocaller,
    application_vnd_contact_cmsg,
    application_vnd_cosmocaller,
    application_vnd_ctc_posml,
    application_vnd_cups_postscript,
    application_vnd_cups_raster,
    application_vnd_cups_raw,
    application_vnd_cybank,
    application_vnd_dna,
    application_vnd_dpgraph,
    application_vnd_dxr,
    application_vnd_ecdis_update,
    application_vnd_ecowin_chart,
    application_vnd_ecowin_filerequest,
    application_vnd_ecowin_fileupdate,
    application_vnd_ecowin_series,
    application_vnd_ecowin_seriesrequest,
    application_vnd_ecowin_seriesupdate,
    application_vnd_enliven,
    application_vnd_epson_esf,
    application_vnd_epson_msf,
    application_vnd_epson_quickanime,
    application_vnd_epson_salt,
    application_vnd_epson_ssf,
    application_vnd_ericsson_quickcall,
    application_vnd_eudora_data,
    application_vnd_fdf,
    application_vnd_ffsns,
    application_vnd_flographit,
    application_vnd_framemaker,
    application_vnd_fsc_weblaunch,
    application_vnd_fujitsu_oasys,
    application_vnd_fujitsu_oasys2,
    application_vnd_fujitsu_oasys3,
    application_vnd_fujitsu_oasysgp,
    application_vnd_fujitsu_oasysprs,
    application_vnd_fujixerox_ddd,
    application_vnd_fujixerox_docuworks,
    application_vnd_fujixerox_docuworks_binder,
    application_vnd_fut_misnet,
    application_vnd_grafeq,
    application_vnd_groove_account,
    application_vnd_groove_identity_message,
    application_vnd_groove_injector,
    application_vnd_groove_tool_message,
    application_vnd_groove_tool_template,
    application_vnd_groove_vcard,
    application_vnd_hhe_lesson_player,
    application_vnd_hp_HPGL,
    application_vnd_hp_PCL,
    application_vnd_hp_PCLXL,
    application_vnd_hp_hpid,
    application_vnd_hp_hps,
    application_vnd_httphone,
    application_vnd_hzn_3d_crossword,
    application_vnd_ibm_MiniPay,
    application_vnd_ibm_afplinedata,
    application_vnd_ibm_modcap,
    application_vnd_informix_visionary,
    application_vnd_intercon_formnet,
    application_vnd_intertrust_digibox,
    application_vnd_intertrust_nncp,
    application_vnd_intu_qbo,
    application_vnd_intu_qfx,
    application_vnd_irepository_package_xml,
    application_vnd_is_xpr,
    application_vnd_japannet_directory_service,
    application_vnd_japannet_jpnstore_wakeup,
    application_vnd_japannet_payment_wakeup,
    application_vnd_japannet_registration,
    application_vnd_japannet_registration_wakeup,
    application_vnd_japannet_setstore_wakeup,
    application_vnd_japannet_verification,
    application_vnd_japannet_verification_wakeup,
    application_vnd_koan,
    application_vnd_lotus_1_2_3,
    application_vnd_lotus_approach,
    application_vnd_lotus_freelance,
    application_vnd_lotus_notes,
    application_vnd_lotus_organizer,
    application_vnd_lotus_screencam,
    application_vnd_lotus_wordpro,
    application_vnd_mcd,
    application_vnd_mediastation_cdkey,
    application_vnd_meridian_slingshot,
    application_vnd_mif,
    application_vnd_minisoft_hp3000_save,
    application_vnd_mitsubishi_misty_guard_trustweb,
    application_vnd_mobius_daf,
    application_vnd_mobius_dis,
    application_vnd_mobius_msl,
    application_vnd_mobius_plc,
    application_vnd_mobius_txf,
    application_vnd_motorola_flexsuite,
    application_vnd_motorola_flexsuite_adsi,
    application_vnd_motorola_flexsuite_fis,
    application_vnd_motorola_flexsuite_gotap,
    application_vnd_motorola_flexsuite_kmr,
    application_vnd_motorola_flexsuite_ttc,
    application_vnd_motorola_flexsuite_wem,
    application_vnd_mozilla_xul_xml,
    application_vnd_ms_artgalry,
    application_vnd_ms_asf,
    application_vnd_ms_excel,
    application_vnd_ms_lrm,
    application_vnd_ms_pki_seccat,
    application_vnd_ms_pki_stl,
    application_vnd_ms_powerpoint,
    application_vnd_ms_project,
    application_vnd_ms_tnef,
    application_vnd_ms_works,
    application_vnd_mseq,
    application_vnd_msign,
    application_vnd_music_niff,
    application_vnd_musician,
    application_vnd_netfpx,
    application_vnd_noblenet_directory,
    application_vnd_noblenet_sealer,
    application_vnd_noblenet_web,
    application_vnd_novadigm_EDM,
    application_vnd_novadigm_EDX,
    application_vnd_novadigm_EXT,
    application_vnd_osa_netdeploy,
    application_vnd_palm,
    application_vnd_pg_format,
    application_vnd_pg_osasli,
    application_vnd_powerbuilder6,
    application_vnd_powerbuilder6_s,
    application_vnd_powerbuilder7,
    application_vnd_powerbuilder7_s,
    application_vnd_powerbuilder75,
    application_vnd_powerbuilder75_s,
    application_vnd_previewsystems_box,
    application_vnd_publishare_delta_tree,
    application_vnd_pvi_ptid1,
    application_vnd_pwg_xhtml_print_xml,
    application_vnd_rapid,
    application_vnd_s3sms,
    application_vnd_seemail,
    application_vnd_shana_informed_formdata,
    application_vnd_shana_informed_formtemplate,
    application_vnd_shana_informed_interchange,
    application_vnd_shana_informed_package,
    application_vnd_smaf,
    application_vnd_sss_cod,
    application_vnd_sss_dtf,
    application_vnd_sss_ntf,
    application_vnd_stardivision_calc,
    application_vnd_stardivision_draw,
    application_vnd_stardivision_impress,
    application_vnd_stardivision_math,
    application_vnd_stardivision_writer,
    application_vnd_stardivision_writer_global,
    application_vnd_street_stream,
    application_vnd_sun_xml_calc,
    application_vnd_sun_xml_calc_template,
    application_vnd_sun_xml_draw,
    application_vnd_sun_xml_draw_template,
    application_vnd_sun_xml_impress,
    application_vnd_sun_xml_impress_template,
    application_vnd_sun_xml_math,
    application_vnd_sun_xml_writer,
    application_vnd_sun_xml_writer_global,
    application_vnd_sun_xml_writer_template,
    application_vnd_svd,
    application_vnd_swiftview_ics,
    application_vnd_symbian_install,
    application_vnd_triscape_mxs,
    application_vnd_trueapp,
    application_vnd_truedoc,
    application_vnd_tve_trigger,
    application_vnd_ufdl,
    application_vnd_uplanet_alert,
    application_vnd_uplanet_alert_wbxml,
    application_vnd_uplanet_bearer_choice,
    application_vnd_uplanet_bearer_choice_wbxml,
    application_vnd_uplanet_cacheop,
    application_vnd_uplanet_cacheop_wbxml,
    application_vnd_uplanet_channel,
    application_vnd_uplanet_channel_wbxml,
    application_vnd_uplanet_list,
    application_vnd_uplanet_list_wbxml,
    application_vnd_uplanet_listcmd,
    application_vnd_uplanet_listcmd_wbxml,
    application_vnd_uplanet_signal,
    application_vnd_vcx,
    application_vnd_vectorworks,
    application_vnd_vidsoft_vidconference,
    application_vnd_visio,
    application_vnd_vividence_scriptfile,
    application_vnd_wap_sic,
    application_vnd_wap_slc,
    application_vnd_wap_wbxml,
    application_vnd_wap_wmlc,
    application_vnd_wap_wmlscriptc,
    application_vnd_webturbo,
    application_vnd_wrq_hp3000_labelled,
    application_vnd_wt_stf,
    application_vnd_xara,
    application_vnd_xfdl,
    application_vnd_yellowriver_custom_menu,

    /* application/x 2200 */
    application_x_123 = 2200,
    application_x_apple_diskimage,
    application_x_bcpio,
    application_x_bittorrent,
    application_x_cdf,
    application_x_cdlink,
    application_x_chess_pgn,
    application_x_chm,
    application_x_core,
    application_x_cpio,
    application_x_csh,
    application_x_debian_package,
    application_x_director,
    application_x_doom,
    application_x_dms,
    application_x_dvi,
    application_x_executable,
    application_x_flac,
    application_x_font,
    application_x_futuresplash,
    application_x_gnumeric,
    application_x_go_sgf,
    application_x_graphing_calculator,
    application_x_gtar,
    application_x_hdf,
    application_x_httpd_php,
    application_x_httpd_php_source,
    application_x_httpd_php3,
    application_x_httpd_php3_preprocessed,
    application_x_httpd_php4,
    application_x_ica,
    application_x_internet_signup,
    application_x_iphone,
    application_x_java_applet,
    application_x_java_archive,
    application_x_java_bean,
    application_x_java_jnlp_file,
    application_x_java_serialized_object,
    application_x_java_vm,
    application_x_javascript,
    application_x_kdelnk,
    application_x_kchart,
    application_x_killustrator,
    application_x_kpresenter,
    application_x_koan,
    application_x_kspread,
    application_x_kword,
    application_x_latex,
    application_x_lha,
    application_x_lzh,
    application_x_lzx,
    application_x_maker,
    application_x_mif,
    application_x_ms_wmz,
    application_x_ms_wmd,
    application_x_msdos_program,
    application_x_msi,
    application_x_netcdf,
    application_x_ns_proxy_autoconfig,
    application_x_nwc,
    application_x_object,
    application_x_oz_application,
    application_x_pkcs7_certreqresp,
    application_x_pkcs7_crl,
    application_x_python_code,
    application_x_quicktimeplayer,
    application_x_redhat_package_manager,
    application_x_rx,
    application_x_sh,
    application_x_shar,
    application_x_shellscript,
    application_x_shockwave_flash,
    application_x_stuffit,
    application_x_sv4cpio,
    application_x_sv4crc,
    application_x_tar,
    application_x_tcl,
    application_x_tex_gf,
    application_x_tex_pk,
    application_x_texinfo,
    application_x_trash,
    application_x_troff,
    application_x_troff_man,
    application_x_troff_me,
    application_x_troff_ms,
    application_x_ustar,
    application_x_videolan,
    application_x_wais_source,
    application_x_wingz,
    application_x_x509_ca_cert,
    application_x_xcf,
    application_x_xfig,
    
    /* audio - 2600 */
    audio_32kadpcm = 2600,
    audio_basic,
    audio_g_722_1,
    audio_l16,
    audio_midi,
    audio_mp4a_latm,
    audio_mpa_robust,
    audio_mpeg,
    audio_mpegurl,
    audio_parityfec,
    audio_prs_sid,
    audio_telephone_event,
    audio_tone,

    /* audio/vnd - 2700 */
    audio_vnd_cisco_nse = 2700,
    audio_vnd_cns_anp1,
    audio_vnd_cns_inf1,
    audio_vnd_digital_winds,
    audio_vnd_everad_plj,
    audio_vnd_lucent_voice,
    audio_vnd_nortel_vbk,
    audio_vnd_nuera_ecelp4800,
    audio_vnd_nuera_ecelp7470,
    audio_vnd_nuera_ecelp9600,
    audio_vnd_octel_sbc,
    audio_vnd_qcelp,
    audio_vnd_rhetorex_32kadpcm,
    audio_vnd_vmx_cvsd,

    /* audio/x - 2800 */
    audio_x_aiff = 2800,
    audio_x_gsm,
    audio_x_mpegurl,
    audio_x_ms_wma,
    audio_x_ms_wax,
    audio_x_pn_realaudio_plugin,
    audio_x_pn_realaudio,
    audio_x_realaudio,
    audio_x_scpls,
    audio_x_sd2,
    audio_x_wav,

    /* chemical - 2900 */
    chemical_x_pdb = 2900,
    chemical_x_xyz,

    /* image - 3000 */
    image_cgm = 3000,
    image_g3fax,
    image_gif,
    image_ief,
    image_jpeg,
    image_naplps,
    image_pcx,
    image_png,
    image_prs_btif,
    image_prs_pti,
    image_svg_xml,
    image_tiff,
    
    /* image/vnd - 3100 */
    image_vnd_cns_inf2 = 3100,
    image_vnd_djvu,
    image_vnd_dwg,
    image_vnd_dxf,
    image_vnd_fastbidsheet,
    image_vnd_fpx,
    image_vnd_fst,
    image_vnd_fujixerox_edmics_mmr,
    image_vnd_fujixerox_edmics_rlc,
    image_vnd_mix,
    image_vnd_net_fpx,
    image_vnd_svf,
    image_vnd_wap_wbmp,
    image_vnd_xiff,

    /* image/x - 3200 */
    image_x_cmu_raster = 3200,
    image_x_coreldraw,
    image_x_coreldrawpattern,
    image_x_coreldrawtemplate,
    image_x_corelphotopaint,
    image_x_icon,
    image_x_jg,
    image_x_jng,
    image_x_ms_bmp,
    image_x_photoshop,
    image_x_portable_anymap,
    image_x_portable_bitmap,
    image_x_portable_graymap,
    image_x_portable_pixmap,
    image_x_rgb,
    image_x_xbitmap,
    image_x_xpixmap,
    image_x_xwindowdump,

    /* inode - 3300 */
    inode_chardevice = 3300,
    inode_blockdevice,
    inode_directory_locked,
    inode_directory,
    inode_fifo,
    inode_socket,

    /* message - 3400 */
    message_delivery_status = 3400,
    message_disposition_notification,
    message_external_body,
    message_http,
    message_s_http,
    message_news,
    message_partial,
    message_rfc822,

    /* model - 3500 */
    model_iges = 3500,
    model_mesh,
    model_vnd_dwf,
    model_vnd_flatland_3dml,
    model_vnd_gdl,
    model_vnd_gs_gdl,
    model_vnd_gtw,
    model_vnd_mts,
    model_vnd_vtu,
    model_vrml,

    /* multipart - 3600 */
    multipart_alternative = 3600,
    multipart_appledouble,
    multipart_byteranges,
    multipart_digest,
    multipart_encrypted,
    multipart_form_data,
    multipart_header_set,
    multipart_mixed,
    multipart_parallel,
    multipart_related,
    multipart_report,
    multipart_signed,
    multipart_voice_message,


    /* text - 3700 */
    text_calendar = 3700,
    text_comma_separated_values,
    text_css,
    text_directory,
    text_english,
    text_enriched,
    text_h323,
    text_html,
    text_iuls,
    text_mathml,
    text_parityfec,
    text_plain,
    text_prs_lines_tag,
    text_rfc822_headers,
    text_richtext,
    text_rtf,
    text_scriptlet,
    text_t140,
    text_texmacs,
    text_tab_separated_values,
    text_uri_list,

    /* text/vnd - 3800 */
    text_vnd_abc = 3800,
    text_vnd_curl,
    text_vnd_DMClientScript,
    text_vnd_flatland_3dml,
    text_vnd_fly,
    text_vnd_fmi_flexstor,
    text_vnd_in3d_3dml,
    text_vnd_in3d_spot,
    text_vnd_IPTC_NewsML,
    text_vnd_IPTC_NITF,
    text_vnd_latex_z,
    text_vnd_motorola_reflex,
    text_vnd_ms_mediapackage,
    text_vnd_sun_j2me_app_descriptor,
    text_vnd_wap_si,
    text_vnd_wap_sl,
    text_vnd_wap_wml,
    text_vnd_wap_wmlscript,

    /* text/x - 3900 */
    text_x_c__hdr = 3900,
    text_x_c__src,
    text_x_chdr,
    text_x_crontab,
    text_x_csh,
    text_x_csrc,
    text_x_java,
    text_x_makefile,
    text_x_moc,
    text_x_pascal,
    text_x_pcs_gcd,
    text_x_perl,
    text_x_python,
    text_x_server_parsed_html,
    text_x_setext,
    text_x_sh,
    text_x_tcl,
    text_x_tex,
    text_x_vcalendar,
    text_x_vcard,

    /* text/x - 4000 */
    video_dl = 4000,
    video_fli,
    video_gl,
    video_mpeg,
    video_mp4,
    video_quicktime,
    video_mp4v_es,
    video_parityfec,
    video_pointer,

    /* text/vnd - 4100 */
    video_vnd_fvt = 4100,
    video_vnd_motorola_video,
    video_vnd_motorola_videop,
    video_vnd_mpegurl,
    video_vnd_mts,
    video_vnd_nokia_interleaved_multimedia,
    video_vnd_vivo,
    video_x_dv,
    video_x_la_asf,
    video_x_mng,
    video_x_ms_asf,
    video_x_ms_wm,
    video_x_ms_wmv,
    video_x_ms_wmx,
    video_x_ms_wvx,
    video_x_msvideo,
    video_x_sgi_movie,

    /* x - 4200 */
    x_conference_x_cooltalk = 4200,
    x_world_x_vrml,

} MIMETYPE;

#ifdef __MIME_TYPES_PRIVATE

#define SUPPORTED_MIME_TYPES(x)  \
    x (text_css,   "text/css")   \
    x (text_html,  "text/html")  \
    x (text_plain, "text/plain") \
    x (image_gif,  "image/gif")  \
    x (image_jpeg, "image/jpeg") \
    x (image_png,  "image/png")  \
	x (mime_any,   "*/*")

#endif /* __MIME_TYPES_PRIVATE */

extern MIMETYPE    mimetype_code (const char*);
extern const char *mimetype_name (MIMETYPE);

#endif /* __MIME_TYPES_H */

