/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>

#define __MIME_TYPES_PRIVATE
#include "mime-types.h"

#define __str(x)              # x
#define str(x)                __str (x)

char *progname;


char *upcase (char *s) {
    static char *buf;
    int n, len = strlen (s);
    if (buf)
        free (buf) ;
    if ((buf = malloc (len + 1)) == 0) {
        fprintf (stderr, "%s: malloc (%u) returned NULL (%s)!\n",
                 progname, n, strerror (errno));
        exit (2) ;
    }
    for (n = 0; n < len; n++)
        buf [n] = toupper (s [n]);
    buf [n] = '\0' ;
    return buf ;
}

static int code_count ;
char *code_str (void) {
    static char buf [10] ;
    sprintf (buf, "\\x%02x", ++ code_count) ;
    return buf;
}

int main (int argc, char **argv) {
    if ((progname = strrchr (argv [0], '/')) == 0)
        progname = argv [0] ;
    else
        ++ progname ;

    printf ("\n");

    printf ("/* typedef enum _mimetype */\n");
    code_count = 0;
#   define __mmdefs(m,n) printf ("#define _%s \"%s\" /* %s */\n", \
                                  upcase (str (m)), code_str (), n);
    SUPPORTED_MIME_TYPES(__mmdefs)
#   undef                __mmdefs

    printf ("\n");

    printf ("/* SUPPORTED_MIME_TYPES () */\n");
    code_count = 0;
    printf ("#define ENCODED_MIME_TYPES(x) \\\n");
#   define __mmdefs(m,n) printf ("     x (%s, _%s, %d) \\\n", \
                                 str (m), upcase (str (m)), ++ code_count);
    SUPPORTED_MIME_TYPES(__mmdefs)
    printf ("\n");
#   undef                __mmdefs

    exit (0);
}
