/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: n/n (D-Link)			                          *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/


#include "phone_common.h"


int publishDevId(STATE  *s, HLST *avp, int func, error_cb err_cb)
{
	HSRCH 		*lookup;
	int 		error 			= NO_ERROR;
	char 		*timeslot_label		= "phone_accounts.timeslot";
	HLST 		*nvram_avp 		= NULL;
	HLST 		*tmp_avp 		= NULL;		/* to have a list which contains only the values we wanna store */ 
	char		**dev_id		= NULL;
	char		*var 			= NULL;
	const char	**Val			= NULL;
	char 		*_newTimeslot		= NULL;
     
        
	if(dev_id = (char**)find_hlst(avp,"success", 0))	/* Just to make sure */
	{
		/* load nvram variables for search */
		tmp_avp = create_hlst(100, nvram_avp_destroy, NULL);
		nvram_avp = create_hlst(300, nvram_avp_destroy, NULL);
		load_from_nvram(s->nvram , nvram_avp, NULL);

		/* we are adding a new device, so add the id to the current timeslot-list of the phone_accounts */
		lookup = open_hlst_search (nvram_avp);
		while ((Val = (const char**) next_hlst_search (lookup)) != 0) 
		{
			/* get the associated variable */
			var = query_key_hlst((void **)Val) ;

			
			if(strncmp(timeslot_label, var, strlen(timeslot_label)) == 0)
			{
				/* we found a timeslot variable, lets add the device id */

				/* if the index is already in the list, remove it first and then add it again */
				_newTimeslot = removeIndex(nvram_avp,var,*dev_id);

				if( func == ADD_DEV_INDEX )
				{
					/* add changed timeslot list to nvram_avp */
					if(_newTimeslot)
						forceAddToList(nvram_avp,var,_newTimeslot);
					/* now add new Index to timeslot */
					_newTimeslot = addNewIndex(nvram_avp,var,*dev_id);
				}
                               
				if(_newTimeslot)
				{
					if(*_newTimeslot == '\0')
						forceAddToList(tmp_avp,var," ");
					else
						forceAddToList(tmp_avp,var,_newTimeslot);

					free(_newTimeslot);
					_newTimeslot = NULL;
				}
			}
			
            
			/* that was not what we're looking for */
			var = NULL;
		}
		close_hlst_search (lookup) ;
   

		store_into_nvram(s->nvram,tmp_avp);
		destroy_hlst(nvram_avp);
		destroy_hlst(tmp_avp);
	}


	if(error != NO_ERROR)
		err_cb(tmp_avp, error);
    

	return error;
}

