/*
 * nvramd - active data base server and flash memory cache
 *
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, 5th Floor, Boston, MA 02110-1301 USA
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * generated: 2006-07-28 22:27:21
 * $Id: dsa1key.h 2968 2006-07-29 19:58:03Z jordan $
 */

#ifndef __DSAKEY7bQ9UCV2Nc_H
#define __DSAKEY7bQ9UCV2Nc_H

#if defined (__DSA_PUBLIC_KEY) || defined (__DSA_PRIVATE_KEY) || defined (__DSA_IMPORT_KEY)
#include <openssl/blowfish.h>
#include <openssl/dsa.h>
#include <openssl/x509.h>

#ifdef __DSA_IMPORT_KEY
#define DSA_87bQ9UCV2Nc ( /* 442 bytes payload */\
	"nZ6yNMoN3qI5v5wg5dz0AJJ2DDvR8FxR+J4Sodc0dM4EhRxKhlmwLksm9Bf3" \
	"/tVQpDCrLTXaPYg+3KOSOuCo2awve72uXvGZ5TOyLs6SghMBB5pkqRJ3S02i" \
	"1cZqZkjrli5cy3qfknNArAmAk8oidV7Z5E5egWPM7NabimYmmcUWQZX6PsSp" \
	"jAEIfGJ7NBn6jq8wONJ37chyTmbTt4yo0d9p2eboo8/kUzrZAGmbRs+NtFKN" \
	"rUOeUvDtO6/wpNJqWlAsBzM7TAlY5mHQ3C/gRrdFbFU/pGNE8eBaOO8S7jl6" \
	"yGWEeO3cR8n1cv6MmgdS4+aneDxbYvea6kaUAsLZ+lvqDV29GewhUNVjcfjr" \
	"Qe8gKPu0dSWOgQSrDtVH79fn+AuSwe7qty5Qj7Hhgbi721rjtOsMPW3vasVz" \
	"bkbJaUPK5nS0ZjyhQ6XzSzmvY52Be9+a4Y/lRLIGSQl0mv3uKUsfTGVoM9jm" \
	"obJeRjJo6rdCr1w1u4ZgDcmyMYZ0RI63IevRN69cakwCl0JVWYi7Zt4oOb58" \
	"+8BfH2FmSi4gRXGsZL5zSu7DTmyyPdyyurf58ms0rHVjUaef5zpzRNrUeQ==")
#endif /* __DSA_IMPORT_KEY */

#define dsa_87bQ9UCV2Nc { /* 442 bytes payload */\
	0x9d, 0x9e, 0xb2, 0x34, 0xca, 0x0d, 0xde, 0xa2, 0x39, 0xbf, 0x9c, 0x20, \
	0xe5, 0xdc, 0xf4, 0x00, 0x92, 0x76, 0x0c, 0x3b, 0xd1, 0xf0, 0x5c, 0x51, \
	0xf8, 0x9e, 0x12, 0xa1, 0xd7, 0x34, 0x74, 0xce, 0x04, 0x85, 0x1c, 0x4a, \
	0x86, 0x59, 0xb0, 0x2e, 0x4b, 0x26, 0xf4, 0x17, 0xf7, 0xfe, 0xd5, 0x50, \
	0xa4, 0x30, 0xab, 0x2d, 0x35, 0xda, 0x3d, 0x88, 0x3e, 0xdc, 0xa3, 0x92, \
	0x3a, 0xe0, 0xa8, 0xd9, 0xac, 0x2f, 0x7b, 0xbd, 0xae, 0x5e, 0xf1, 0x99, \
	0xe5, 0x33, 0xb2, 0x2e, 0xce, 0x92, 0x82, 0x13, 0x01, 0x07, 0x9a, 0x64, \
	0xa9, 0x12, 0x77, 0x4b, 0x4d, 0xa2, 0xd5, 0xc6, 0x6a, 0x66, 0x48, 0xeb, \
	0x96, 0x2e, 0x5c, 0xcb, 0x7a, 0x9f, 0x92, 0x73, 0x40, 0xac, 0x09, 0x80, \
	0x93, 0xca, 0x22, 0x75, 0x5e, 0xd9, 0xe4, 0x4e, 0x5e, 0x81, 0x63, 0xcc, \
	0xec, 0xd6, 0x9b, 0x8a, 0x66, 0x26, 0x99, 0xc5, 0x16, 0x41, 0x95, 0xfa, \
	0x3e, 0xc4, 0xa9, 0x8c, 0x01, 0x08, 0x7c, 0x62, 0x7b, 0x34, 0x19, 0xfa, \
	0x8e, 0xaf, 0x30, 0x38, 0xd2, 0x77, 0xed, 0xc8, 0x72, 0x4e, 0x66, 0xd3, \
	0xb7, 0x8c, 0xa8, 0xd1, 0xdf, 0x69, 0xd9, 0xe6, 0xe8, 0xa3, 0xcf, 0xe4, \
	0x53, 0x3a, 0xd9, 0x00, 0x69, 0x9b, 0x46, 0xcf, 0x8d, 0xb4, 0x52, 0x8d, \
	0xad, 0x43, 0x9e, 0x52, 0xf0, 0xed, 0x3b, 0xaf, 0xf0, 0xa4, 0xd2, 0x6a, \
	0x5a, 0x50, 0x2c, 0x07, 0x33, 0x3b, 0x4c, 0x09, 0x58, 0xe6, 0x61, 0xd0, \
	0xdc, 0x2f, 0xe0, 0x46, 0xb7, 0x45, 0x6c, 0x55, 0x3f, 0xa4, 0x63, 0x44, \
	0xf1, 0xe0, 0x5a, 0x38, 0xef, 0x12, 0xee, 0x39, 0x7a, 0xc8, 0x65, 0x84, \
	0x78, 0xed, 0xdc, 0x47, 0xc9, 0xf5, 0x72, 0xfe, 0x8c, 0x9a, 0x07, 0x52, \
	0xe3, 0xe6, 0xa7, 0x78, 0x3c, 0x5b, 0x62, 0xf7, 0x9a, 0xea, 0x46, 0x94, \
	0x02, 0xc2, 0xd9, 0xfa, 0x5b, 0xea, 0x0d, 0x5d, 0xbd, 0x19, 0xec, 0x21, \
	0x50, 0xd5, 0x63, 0x71, 0xf8, 0xeb, 0x41, 0xef, 0x20, 0x28, 0xfb, 0xb4, \
	0x75, 0x25, 0x8e, 0x81, 0x04, 0xab, 0x0e, 0xd5, 0x47, 0xef, 0xd7, 0xe7, \
	0xf8, 0x0b, 0x92, 0xc1, 0xee, 0xea, 0xb7, 0x2e, 0x50, 0x8f, 0xb1, 0xe1, \
	0x81, 0xb8, 0xbb, 0xdb, 0x5a, 0xe3, 0xb4, 0xeb, 0x0c, 0x3d, 0x6d, 0xef, \
	0x6a, 0xc5, 0x73, 0x6e, 0x46, 0xc9, 0x69, 0x43, 0xca, 0xe6, 0x74, 0xb4, \
	0x66, 0x3c, 0xa1, 0x43, 0xa5, 0xf3, 0x4b, 0x39, 0xaf, 0x63, 0x9d, 0x81, \
	0x7b, 0xdf, 0x9a, 0xe1, 0x8f, 0xe5, 0x44, 0xb2, 0x06, 0x49, 0x09, 0x74, \
	0x9a, 0xfd, 0xee, 0x29, 0x4b, 0x1f, 0x4c, 0x65, 0x68, 0x33, 0xd8, 0xe6, \
	0xa1, 0xb2, 0x5e, 0x46, 0x32, 0x68, 0xea, 0xb7, 0x42, 0xaf, 0x5c, 0x35, \
	0xbb, 0x86, 0x60, 0x0d, 0xc9, 0xb2, 0x31, 0x86, 0x74, 0x44, 0x8e, 0xb7, \
	0x21, 0xeb, 0xd1, 0x37, 0xaf, 0x5c, 0x6a, 0x4c, 0x02, 0x97, 0x42, 0x55, \
	0x59, 0x88, 0xbb, 0x66, 0xde, 0x28, 0x39, 0xbe, 0x7c, 0xfb, 0xc0, 0x5f, \
	0x1f, 0x61, 0x66, 0x4a, 0x2e, 0x20, 0x45, 0x71, 0xac, 0x64, 0xbe, 0x73, \
	0x4a, 0xee, 0xc3, 0x4e, 0x6c, 0xb2, 0x3d, 0xdc, 0xb2, 0xba, 0xb7, 0xf9, \
	0xf2, 0x6b, 0x34, 0xac, 0x75, 0x63, 0x51, 0xa7, 0x9f, 0xe7, 0x3a, 0x73, \
	0x44, 0xda, 0xd4, 0x79}

#ifdef __DSA_IMPORT_KEY
#define DSA_97bQ9UCV2Nc ( /* 446 bytes payload */\
	"8Q3RfE3NcaFkfnKV+wFpgpodPiNo8R+jOVoSJ5fOQx7HLHUFQs5OullyvxI7" \
	"xiUh2TUzMBhA3ms4nPasPd3ojYMMYHqZrJwcSQ8XVESYuNEp9m7M/O3qvMiY" \
	"yAVGpQQR+Dh6iKjctjKoxRSnPRt+UH8RSwxB3flBniJvDwqUdaUY/aXDeIkF" \
	"ML5uDbLlYlM1QLu/tAJ95OAP6/ZyjhfvGHeBsrOZnUTKdTI7gNdwPrgCzkFH" \
	"8Rq7kp9/O5JxlhveatD/LxL9O2raxNbp6ffAVerVpcRgmOfSFDRxeFwJWWqt" \
	"VfkQj9yrP/Cjqdyyj8tALMgZXUC6SwjgaaxXnYcxmwvhEA7RI8RErnxLRqqu" \
	"K/o8sLgNlOzpR+PRgAclBo2XGcU3GrQmRGjVp7yBB+6CE2iHyc8bom17ePhC" \
	"5PJyzYs7KUyU07GeV0o1Yo2Uh5Ib4S2N2SpBtMbdGSdOEsbQi+Ja8bX3yitk" \
	"nTU/PgsGOxEX7Qa4/mbcmZy4hGa/AxIzecgtIEupvWa/ISth48/wfWKTxYAV" \
	"JSWgdLhN5OwxShZaUL6paKNmnfMSaE8bwhcDj0+LyFXMQ9+VDm8AtPs6ew==")
#endif /* __DSA_IMPORT_KEY */

#define dsa_97bQ9UCV2Nc { /* 446 bytes payload */\
	0xf1, 0x0d, 0xd1, 0x7c, 0x4d, 0xcd, 0x71, 0xa1, 0x64, 0x7e, 0x72, 0x95, \
	0xfb, 0x01, 0x69, 0x82, 0x9a, 0x1d, 0x3e, 0x23, 0x68, 0xf1, 0x1f, 0xa3, \
	0x39, 0x5a, 0x12, 0x27, 0x97, 0xce, 0x43, 0x1e, 0xc7, 0x2c, 0x75, 0x05, \
	0x42, 0xce, 0x4e, 0xba, 0x59, 0x72, 0xbf, 0x12, 0x3b, 0xc6, 0x25, 0x21, \
	0xd9, 0x35, 0x33, 0x30, 0x18, 0x40, 0xde, 0x6b, 0x38, 0x9c, 0xf6, 0xac, \
	0x3d, 0xdd, 0xe8, 0x8d, 0x83, 0x0c, 0x60, 0x7a, 0x99, 0xac, 0x9c, 0x1c, \
	0x49, 0x0f, 0x17, 0x54, 0x44, 0x98, 0xb8, 0xd1, 0x29, 0xf6, 0x6e, 0xcc, \
	0xfc, 0xed, 0xea, 0xbc, 0xc8, 0x98, 0xc8, 0x05, 0x46, 0xa5, 0x04, 0x11, \
	0xf8, 0x38, 0x7a, 0x88, 0xa8, 0xdc, 0xb6, 0x32, 0xa8, 0xc5, 0x14, 0xa7, \
	0x3d, 0x1b, 0x7e, 0x50, 0x7f, 0x11, 0x4b, 0x0c, 0x41, 0xdd, 0xf9, 0x41, \
	0x9e, 0x22, 0x6f, 0x0f, 0x0a, 0x94, 0x75, 0xa5, 0x18, 0xfd, 0xa5, 0xc3, \
	0x78, 0x89, 0x05, 0x30, 0xbe, 0x6e, 0x0d, 0xb2, 0xe5, 0x62, 0x53, 0x35, \
	0x40, 0xbb, 0xbf, 0xb4, 0x02, 0x7d, 0xe4, 0xe0, 0x0f, 0xeb, 0xf6, 0x72, \
	0x8e, 0x17, 0xef, 0x18, 0x77, 0x81, 0xb2, 0xb3, 0x99, 0x9d, 0x44, 0xca, \
	0x75, 0x32, 0x3b, 0x80, 0xd7, 0x70, 0x3e, 0xb8, 0x02, 0xce, 0x41, 0x47, \
	0xf1, 0x1a, 0xbb, 0x92, 0x9f, 0x7f, 0x3b, 0x92, 0x71, 0x96, 0x1b, 0xde, \
	0x6a, 0xd0, 0xff, 0x2f, 0x12, 0xfd, 0x3b, 0x6a, 0xda, 0xc4, 0xd6, 0xe9, \
	0xe9, 0xf7, 0xc0, 0x55, 0xea, 0xd5, 0xa5, 0xc4, 0x60, 0x98, 0xe7, 0xd2, \
	0x14, 0x34, 0x71, 0x78, 0x5c, 0x09, 0x59, 0x6a, 0xad, 0x55, 0xf9, 0x10, \
	0x8f, 0xdc, 0xab, 0x3f, 0xf0, 0xa3, 0xa9, 0xdc, 0xb2, 0x8f, 0xcb, 0x40, \
	0x2c, 0xc8, 0x19, 0x5d, 0x40, 0xba, 0x4b, 0x08, 0xe0, 0x69, 0xac, 0x57, \
	0x9d, 0x87, 0x31, 0x9b, 0x0b, 0xe1, 0x10, 0x0e, 0xd1, 0x23, 0xc4, 0x44, \
	0xae, 0x7c, 0x4b, 0x46, 0xaa, 0xae, 0x2b, 0xfa, 0x3c, 0xb0, 0xb8, 0x0d, \
	0x94, 0xec, 0xe9, 0x47, 0xe3, 0xd1, 0x80, 0x07, 0x25, 0x06, 0x8d, 0x97, \
	0x19, 0xc5, 0x37, 0x1a, 0xb4, 0x26, 0x44, 0x68, 0xd5, 0xa7, 0xbc, 0x81, \
	0x07, 0xee, 0x82, 0x13, 0x68, 0x87, 0xc9, 0xcf, 0x1b, 0xa2, 0x6d, 0x7b, \
	0x78, 0xf8, 0x42, 0xe4, 0xf2, 0x72, 0xcd, 0x8b, 0x3b, 0x29, 0x4c, 0x94, \
	0xd3, 0xb1, 0x9e, 0x57, 0x4a, 0x35, 0x62, 0x8d, 0x94, 0x87, 0x92, 0x1b, \
	0xe1, 0x2d, 0x8d, 0xd9, 0x2a, 0x41, 0xb4, 0xc6, 0xdd, 0x19, 0x27, 0x4e, \
	0x12, 0xc6, 0xd0, 0x8b, 0xe2, 0x5a, 0xf1, 0xb5, 0xf7, 0xca, 0x2b, 0x64, \
	0x9d, 0x35, 0x3f, 0x3e, 0x0b, 0x06, 0x3b, 0x11, 0x17, 0xed, 0x06, 0xb8, \
	0xfe, 0x66, 0xdc, 0x99, 0x9c, 0xb8, 0x84, 0x66, 0xbf, 0x03, 0x12, 0x33, \
	0x79, 0xc8, 0x2d, 0x20, 0x4b, 0xa9, 0xbd, 0x66, 0xbf, 0x21, 0x2b, 0x61, \
	0xe3, 0xcf, 0xf0, 0x7d, 0x62, 0x93, 0xc5, 0x80, 0x15, 0x25, 0x25, 0xa0, \
	0x74, 0xb8, 0x4d, 0xe4, 0xec, 0x31, 0x4a, 0x16, 0x5a, 0x50, 0xbe, 0xa9, \
	0x68, 0xa3, 0x66, 0x9d, 0xf3, 0x12, 0x68, 0x4f, 0x1b, 0xc2, 0x17, 0x03, \
	0x8f, 0x4f, 0x8b, 0xc8, 0x55, 0xcc, 0x43, 0xdf, 0x95, 0x0e, 0x6f, 0x00, \
	0xb4, 0xfb, 0x3a, 0x7b}

static unsigned char *dsa_a7bQ9UCV2Nc (const unsigned char *p, unsigned m) {
	unsigned char iv [8] = {0x13, 0x58, 0xc7, 0xb2, 0xfb, 0x5f, 0x2b, 0x31};
	unsigned char k [12] = {0xa1, 0x33, 0xcb, 0x40, 0x75, 0x34, 0x3e, 0xd9, 0x7d, 0x93, 0xf2, 0x6e};
#	ifdef xmalloc
	unsigned char *q = (unsigned char*) xmalloc (m);
#	else
	unsigned char *q = (unsigned char*) malloc (m);
	if (q) {
#	endif /* xmalloc */
		BF_KEY b;
		BF_set_key (&b, 12, k);
		BF_cbc_encrypt (p, q, m, &b, iv, 0);
#	ifndef xmalloc
	}
#	endif /* xmalloc */
	return q;
}

#ifdef __DSA_IMPORT_KEY
#define dsa1param_id    "uva1R3ZOCd"
#define dsa1key_id      "7bQ9UCV2Nc"

#define dsa1pubkey      dsa_87bQ9UCV2Nc
#define DSA1PUBKEY      DSA_87bQ9UCV2Nc
#define dsa1privkey     dsa_97bQ9UCV2Nc
#define DSA1PRIVKEY     DSA_97bQ9UCV2Nc

#define dsa1decode(p,m) dsa_a7bQ9UCV2Nc (p, m)
#endif /* __DSA_IMPORT_KEY */

#endif /* PUBLIC || PRIVATE || IMPORT */


#ifdef __DSA_PUBLIC_KEY

static DSA *dsa_b7bQ9UCV2Nc (void) {
	const unsigned char s [] = dsa_87bQ9UCV2Nc ;
	const unsigned char *p = dsa_a7bQ9UCV2Nc (s, 448);
	if (p) {
		const unsigned char *q = p + 2;
		DSA *d = d2i_DSA_PUBKEY (0, &q, 442);
		free ((char*)p);
		return d;
	}
	return 0;
}

#define dsa_get_pub_key1() dsa_b7bQ9UCV2Nc ()
#else
#define dsa_get_pub_key1() 0
#endif /* __DSA_PUBLIC_KEY */


#ifdef __DSA_PRIVATE_KEY

static DSA *dsa_c7bQ9UCV2Nc (void) {
	const unsigned char s [] = dsa_97bQ9UCV2Nc ;
	const unsigned char *p = dsa_a7bQ9UCV2Nc (s, 448);
	if (p) {
		const unsigned char *q = p + 2;
		DSA *d = d2i_DSAPrivateKey (0, &q, 446);
		free ((char*)p);
		return d;
	}
	return 0;
}

#define dsa_get_priv_key1() dsa_c7bQ9UCV2Nc ()
#else
#define dsa_get_priv_key1() 0
#endif /* __DSA_PRIVATE_KEY */

#endif /* __DSAKEY7bQ9UCV2Nc_H */
