/*
 * nvramd - active data base server and flash memory cache
 *
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, 5th Floor, Boston, MA 02110-1301 USA
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * generated: 2006-06-22 16:02:40
 * $Id: dsaparam.h 2740 2006-06-29 08:57:07Z jordan $
 */

#ifndef __DSAPARAM_H
#define __DSAPARAM_H

#include <openssl/dsa.h>
#include <openssl/bn.h>

static unsigned char dsa_0uva1R3ZOCd [] = {
	0xe7, 0x90, 0xd3, 0xa1, 0xca, 0xf5, 0x38, 0xe4, 0x59, 0x41, 0x94, 0x3f, 
	0x22, 0x7b, 0x36, 0xf9, 0x34, 0x87, 0xc2, 0x10, 0x07, 0xd1, 0x2b, 0x70, 
	0x37, 0x10, 0xb4, 0x49, 0xf9, 0xd6, 0x7c, 0x6e, 0x96, 0x93, 0x42, 0x6d, 
	0xcc, 0xe3, 0xeb, 0xaa, 0xeb, 0x43, 0xa4, 0x8c, 0x67, 0x94, 0x5d, 0x33, 
	0x22, 0x65, 0x8a, 0x43, 0xf6, 0x22, 0x8d, 0xb1, 0x84, 0x81, 0x8a, 0x6c, 
	0x35, 0x37, 0xc1, 0x43, 0x8e, 0x69, 0x33, 0x5a, 0xd3, 0xef, 0x9f, 0x52, 
	0xb1, 0x17, 0xda, 0xc5, 0x6b, 0xf4, 0x5c, 0xfa, 0x32, 0x8f, 0x06, 0x28, 
	0xc7, 0x16, 0x50, 0xb8, 0x35, 0x18, 0xf2, 0xed, 0x24, 0xce, 0x0d, 0xc7, 
	0x8c, 0xde, 0x1b, 0x61, 0x5b, 0xe1, 0x0f, 0x6f, 0x36, 0xb6, 0x20, 0xe8, 
	0x30, 0xf2, 0xba, 0x44, 0x67, 0x9e, 0x41, 0xb4, 0xf4, 0x3b, 0xee, 0xad, 
	0x7c, 0x8c, 0xf4, 0x66, 0x9b, 0xfd, 0xa6, 0xfd
};

static unsigned char dsa_1uva1R3ZOCd [] = {
	0xa4, 0x7f, 0x28, 0xaa, 0x28, 0x43, 0xa5, 0xdd, 0xc7, 0xc9, 0x2c, 0x9c, 
	0xc6, 0x07, 0x63, 0x82, 0xcb, 0x50, 0xa9, 0xf3
};

static unsigned char dsa_2uva1R3ZOCd [] = {
	0x2f, 0x43, 0xc4, 0xfc, 0xd7, 0xc2, 0xa7, 0x86, 0x9e, 0x97, 0x3c, 0x5f, 
	0x68, 0x00, 0xce, 0xcb, 0x36, 0x77, 0xdd, 0xe6, 0xd2, 0x1a, 0x5b, 0xf7, 
	0x7c, 0x2a, 0xfb, 0xde, 0x48, 0x6d, 0xb9, 0xe7, 0xaf, 0x47, 0x14, 0x52, 
	0x3f, 0xfd, 0x9a, 0x86, 0x29, 0xae, 0x6e, 0x6f, 0x0a, 0xe2, 0xe2, 0x4c, 
	0x8f, 0xff, 0x8a, 0x08, 0xa3, 0x96, 0x5a, 0xee, 0x92, 0xc0, 0xd6, 0xc3, 
	0x1e, 0x09, 0x84, 0x0f, 0x8b, 0x25, 0xce, 0xe3, 0x32, 0x34, 0x23, 0xf5, 
	0x3e, 0x57, 0xd5, 0x55, 0x3c, 0x33, 0x49, 0x24, 0x57, 0x01, 0xf8, 0x29, 
	0xf9, 0x8f, 0x3f, 0x84, 0x81, 0xb2, 0x38, 0xdf, 0x4c, 0x45, 0xad, 0x73, 
	0x6c, 0x3f, 0x3e, 0xe8, 0x28, 0xd6, 0x42, 0x8f, 0xc0, 0xe1, 0x33, 0x7d, 
	0x29, 0xbb, 0xc5, 0x77, 0x87, 0x5b, 0xd8, 0xbb, 0xf8, 0x50, 0x6f, 0x97, 
	0x37, 0x6c, 0xc0, 0xbf, 0x94, 0x9e, 0x85, 0x92
};

static DSA *dsa_3uva1R3ZOCd (void) {
	DSA *dsa;
	if ((dsa = DSA_new ()) == 0) return 0;
	if ((dsa->p = BN_bin2bn (dsa_0uva1R3ZOCd, sizeof (dsa_0uva1R3ZOCd), 0)) == 0) goto error;
	if ((dsa->q = BN_bin2bn (dsa_1uva1R3ZOCd, sizeof (dsa_1uva1R3ZOCd), 0)) == 0) goto error;
	if ((dsa->g = BN_bin2bn (dsa_2uva1R3ZOCd, sizeof (dsa_2uva1R3ZOCd), 0)) == 0) goto error;
	return dsa;
error:
	DSA_free (dsa);
	return 0;
}

#define get_dsa dsa_3uva1R3ZOCd

#endif /* __DSAPARAM_H */
