/*
 * nvramd - active data base server and flash memory cache
 *
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, 5th Floor, Boston, MA 02110-1301 USA
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * $Id: sysid.h 2841 2006-07-11 10:16:24Z jordan $
 */

#ifndef __NVRAMD_SYSID_H
#define __NVRAMD_SYSID_H

#ifndef __GNUC__
# define __attribute__(x) /* n/a */
# warning struct _sysid_in will not be properly packed!
#endif


typedef
struct _sysid {

    struct _time_date {
        uint8_t y [4] ;
        uint8_t m [2] ;
        uint8_t d [2] ;
        uint8_t H [2] ;
        uint8_t M [2] ;
        uint8_t S [2] ;
    } built ;

    struct _signature {
        uint8_t   key_id  [10] ;
        uint8_t sig_data [100] ; /* base 64, zero padded */
    } sign ;

} SYSID __attribute__ ((packed));


#endif /* __NVRAMD_SYSID_H */
