/*
 * nvramd - active data base server and flash memory cache
 *
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, 5th Floor, Boston, MA 02110-1301 USA
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * $Id: dsa1key.c 3447 2006-10-27 09:24:45Z henry $
 *
 * compile as:
 *  cc -DHAVE_CONFIG_H -I. helper/dsa1key.c -o dsa1key -lcrypt -lssl -lcrypto
 */

/*
 * Don't use any config.h or auto-generated config files, because they are
 * most probably just for the target environment.
 */
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdint.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <libgen.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <limits.h>
#include <stdio.h>

#define SYSLOG_NAMES
#include <syslog.h>

#include <openssl/dsa.h>
#include <openssl/bn.h>
#include <openssl/err.h>
#include <openssl/x509.h>
#include <openssl/blowfish.h>

/* ----------------------------------------------------------------------- *
 * not using -lnvram
 * ----------------------------------------------------------------------- */

#undef HAVE_CONFIG_H
#include "../libnvram/varstr.c"
#include "../libnvram/util.c"
#include "../libnvram/logger.c"
#include "../libnvram/base64.c"
#include "../libnvram/nvalloc.c"
#include "../libnvram/tvcalc.c"
#include "../libnvram/buffer.c"

/* ----------------------------------------------------------------------- *
 * need precompiled dsa params
 * ----------------------------------------------------------------------- */

#define __DSA_IMPORT_KEY
#include "../crypt/dsa1key.h"

/* ----------------------------------------------------------------------- *
 * Helpers
 * ----------------------------------------------------------------------- */

void usage (void) {
    fprintf (stderr, "Usage: %s [--private-key|-p]\n", progname);
    exit (2) ;
}

/* ----------------------------------------------------------------------- *
 * Main
 * ----------------------------------------------------------------------- */

int main (int argc, const char **argv) {
    int prv_key = 0 ;
    
    if ((progname = strrchr (argv [0], '/')) == 0)
        progname = (char*) argv [0] ;
    else
        ++ progname ;

    switch (argc) {
    case 1:
        break ;
    case 2:
        if (strcmp (argv [1], "--private-key") == 0 ||
            strcmp (argv [1], "-p") == 0) {
            prv_key = 1 ;
            break ;
        }
    default:
        usage ();
    }

    printf ("%s\n", prv_key ? DSA1PRIVKEY : DSA1PUBKEY) ;
    exit (0);

    /* keep the compiler quiet */
    dsa1decode (0,0);
}

/* ----------------------------------------------------------------------- *
 * End
 * ----------------------------------------------------------------------- */
