/*
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *   There is no permission to make any digital or printed copies of part or all
 *   of this work without the permission of D-Link.
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * $Id: admin.h 3155 2006-09-19 11:35:31Z henry $
 */

#ifndef __NVRAM_ADMIN_DEFAULTS_H
#define __NVRAM_ADMIN_DEFAULTS_H

#include "horst/common.h"

#define VBASE(x)  "sys_admin." x /* use macro to prevent typos */
#define VSCRIPT   VBASE ("setup")

/* Settings for Remote Management */  
_avpair (VBASE ("login"),  "admin")
_avpair (VBASE ("passwd"), "admin")
_wrlink (VBASE ("ip"),     VSCRIPT, "0.0.0.0")
_wrlink (VBASE ("port"),   VSCRIPT, "443") /* "https" also works */
_wrlink (VBASE ("sslok"),  VSCRIPT, AV_TRUE)

_vtrig  (VSCRIPT,   "sys/sys_admin.sh", "1")
    
_wrlink (VBASE ("hasRemoteHttpMgmt"), VSCRIPT, AV_FALSE)
_wrlink (VBASE ("httpIp"),            VSCRIPT, "0.0.0.0")
_wrlink (VBASE ("httpNetmask"),       VSCRIPT, "255.255.255.255")
    
/* not used, at the moment */
_avpair (VBASE ("hasRemoteTelnetMgmt"),  AV_FALSE)
_avpair (VBASE ("telnetIp"),	"192.168.1.1")
_avpair (VBASE ("telnetNetmask"), "255.255.255.0")

#undef VBASE
#undef VSCRIPT
#endif /* __NVRAM_ADMIN_DEFAULTS_H */
