/*
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *   There is no permission to make any digital or printed copies of part or all
 *   of this work without the permission of D-Link.
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * $Id: dsl.h 2836 2006-07-11 08:04:36Z jordan $
 */


#ifndef __NVRAM_DSL_DEFAULTS_H
#define __NVRAM_DSL_DEFAULTS_H

#define VBASE(x)  "wan_dsl." x /* use macro to prevent typos */
#define VSCRIPT   VBASE ("setup")

/* Configurable via Web? */
_avpair (VBASE ("configurable"), AV_TRUE)

/* DSL settings */
_wrlink (VBASE ("id.1"),                     VSCRIPT, "1")
_wrlink (VBASE ("username.1"),               VSCRIPT, "jemand")
_wrlink (VBASE ("password.1"),               VSCRIPT, "geheim")
_wrlink (VBASE ("vpi.1"),                    VSCRIPT, "1")
_wrlink (VBASE ("vci.1"),                    VSCRIPT, "32")
_wrlink (VBASE ("virtualCircuit.1"),         VSCRIPT, AV_DISABLED)
_wrlink (VBASE ("connectionType.ppp.1"),     VSCRIPT, "pppoeLlc")
_wrlink (VBASE ("connection.1"),             VSCRIPT, AV_KEEPALIVE)
_wrlink (VBASE ("mtu.1"),                    VSCRIPT, "1492")
_wrlink (VBASE ("mru.1"),                    VSCRIPT, "1492")
_wrlink (VBASE ("nat.1"),                    VSCRIPT, AV_ENABLED)
_wrlink (VBASE ("disconnectTime.1"),         VSCRIPT, "5")
_wrlink (VBASE ("forceNewConnection.1"),     VSCRIPT, AV_TRUE)
_wrlink (VBASE ("forceNewConnectionTime.1"), VSCRIPT, "3")
_wrlink (VBASE ("defaultRoute.1"),           VSCRIPT, AV_ENABLED)

_avpair (VBASE ("list"),                  "1")
_avpair (VBASE ("totalElements"),         "1")

/* templates */
_wrltmpl (VBASE ("username."),               VSCRIPT)
_wrltmpl (VBASE ("password."),               VSCRIPT)
_wrltmpl (VBASE ("vpi."),                    VSCRIPT)
_wrltmpl (VBASE ("vci."),                    VSCRIPT)
_wrltmpl (VBASE ("virtualCircuit."),         VSCRIPT)
_wrltmpl (VBASE ("connectionType."),         VSCRIPT)
_wrltmpl (VBASE ("connection."),             VSCRIPT)
_wrltmpl (VBASE ("mtu."),                    VSCRIPT)
_wrltmpl (VBASE ("mru."),                    VSCRIPT)
_wrltmpl (VBASE ("nat."),                    VSCRIPT)
_wrltmpl (VBASE ("disconnectTime."),         VSCRIPT)
_wrltmpl (VBASE ("forceNewConnection."),     VSCRIPT)
_wrltmpl (VBASE ("forceNewConnectionTime."), VSCRIPT)
_wrltmpl (VBASE ("defaultRoute."),           VSCRIPT)

/* will not be changed by the gui */
_avpair (VBASE ("modulation"),	      "multi")

_avolt  (VBASE ("carrier_state"), 	        "Not Connected")

_vtrig  (VSCRIPT, "wan/dsl-config.sh", AV_FALSE)

#undef VSCRIPT
#define VSCRIPT   VBASE ("new-ip")
// _wrltmpl (VBASE ("ip_address."), VSCRIPT)
_vltlnk  (VBASE ("ip_address.1"), VSCRIPT, "0.0.0.0")
_vltlnk  (VBASE ("ip_address.2"), VSCRIPT, "0.0.0.0")
_vltlnk  (VBASE ("ip_address.3"), VSCRIPT, "0.0.0.0")
_vltlnk  (VBASE ("ip_address.4"), VSCRIPT, "0.0.0.0")
_vltlnk  (VBASE ("ip_address.5"), VSCRIPT, "0.0.0.0")
_vltlnk  (VBASE ("ip_address.6"), VSCRIPT, "0.0.0.0")
_vltlnk  (VBASE ("ip_address.7"), VSCRIPT, "0.0.0.0")
_vltlnk  (VBASE ("ip_address.8"), VSCRIPT, "0.0.0.0")
_vtrig   (VSCRIPT, "wan/new-ip.sh", AV_FALSE)

#undef VBASE
#undef VSCRIPT
#endif /* __NVRAM_DSL_DEFAULTS_H */
