/*
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *   There is no permission to make any digital or printed copies of part or all
 *   of this work without the permission of D-Link.
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * $Id: neighbour.h 3331 2006-10-20 12:17:35Z susi $
 */


#ifndef __NVRAM_NEIGHBOUR_DEFAULTS_H
#define __NVRAM_NEIGHBOUR_DEFAULTS_H

#include "horst/common.h"

#define VBASE(x)  "net." x /* use macro to prevent typos */
#define VSCRIPT0  VBASE ("setup")
#define VSCRIPT1  VBASE ("debug")

/* not really changeable */
_avolt  (VBASE ("nvPort"),	str (NVCL_HTTP_CONFIG_PORT))

/* Network setting */
_wrlink (VBASE ("ipAddr"),	    VSCRIPT0,  BACKPACK_IP_ADDRESS)
_wrlink (VBASE ("netmask"),	    VSCRIPT0,  BACKPACK_NET_MASK)
_wrlink (VBASE ("bcast"),	    VSCRIPT0,  BACKPACK_BCAST_ADDRESS)
_wrlink (VBASE ("gateway"),	    VSCRIPT0, MAINBOARD_IP_ADDRESS)
_wrlink (VBASE ("dns"),		    VSCRIPT0, MAINBOARD_IP_ADDRESS)
_wrlink (VBASE ("dsl_board"),   VSCRIPT0, MAINBOARD_IP_ADDRESS)

 /* PVCs for services... 0-3: example "0 1 2 " */
_wrlink (VBASE ("voice-pvc"),	VSCRIPT0, "0")
_wrlink (VBASE ("ssh-pvc"),	VSCRIPT0, "")
_wrlink (VBASE ("vserver-pvc"),	VSCRIPT0, "0")
_wrlink (VBASE ("ofilter-pvc"),	VSCRIPT0, "0")

_avpair (VBASE ("cm.htServer"), MAINBOARD_IP_ADDRESS)
_avpair (VBASE ("cm.htPort"),   MAINBOARD_HTTP_PORT)
_avpair (VBASE ("cm.htLogin"),  MAINBOARD_HTTP_LOGIN)
_avpair (VBASE ("cm.htPasswd"), MAINBOARD_HTTP_PASSWORD)

_vtrig  (VSCRIPT0, "lan/neighbour-config.sh", "1")

_wrlink (VBASE ("blocked_ports.bpack"),	VSCRIPT1, "21,23,888")
_wrlink (VBASE ("blocked_ports.dsl"),	VSCRIPT1, "21,22,23,8080")

_wrlink (VBASE ("debugIp"),	VSCRIPT1, DEBUGGER_IP_ADDRESS)
_wrlink (VBASE ("debugEnable"),	VSCRIPT1, AV_FALSE)
_vtrig  (VSCRIPT1, "lan/debug-config.sh", "1")

#undef VBASE
#undef VSCRIPT0
#undef VSCRIPT1
#endif /* __NVRAM_NEIGHBOUR_DEFAULTS_H */
