/*
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *   There is no permission to make any digital or printed copies of part or all
 *   of this work without the permission of D-Link.
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * $Id: phone.h 3790 2007-03-05 14:22:15Z hholtschneider $
 */


#ifndef __NVRAM_PHONE_DEFAULTS_H
#define __NVRAM_PHONE_DEFAULTS_H

#define VSCRIPT   "asterisk.config_trigger"

    /* phone dial plan */
#   define VBASE(x)  "phone_dials." x /* use macro to prevent typos */
    _wrlink (VBASE ("standardaccount"), VSCRIPT, "1")
    _wrlink (VBASE ("sipfailover"),     VSCRIPT, "1")
#   undef VBASE

    /* phone accounts settings */
#   define VBASE(x)  "phone_accounts." x /* use macro to prevent typos */

    _avpair (VBASE ("configurable"),  AV_TRUE)

    _wrlink (VBASE ("totalElements"), VSCRIPT, "1")
    _wrlink (VBASE ("list"), 	      VSCRIPT, "1")
    _wrlink (VBASE ("max_calls"),     VSCRIPT, "40")

    /* default configuration */
    _wrlink (VBASE ("id.1"),	      VSCRIPT, "1")
    _wrlink (VBASE ("name.1"),	      VSCRIPT, "analoger Telefonanschluss")
    _wrlink (VBASE ("number.1"),      VSCRIPT, "unbekannt")
    _wrlink (VBASE ("type.1"),        VSCRIPT, "analog")
    _wrlink (VBASE ("block_id.1"),    VSCRIPT, AV_FALSE)
    _wrlink (VBASE ("block_pre.1"),   VSCRIPT, "*31#")
    
    _wrlink (VBASE ("timeslot_0.1"),  VSCRIPT, "1 2")
    _wrlink (VBASE ("timeslot_10.1"), VSCRIPT, "1 2")
    _wrlink (VBASE ("timeslot_30.1"), VSCRIPT, "1 2")
    _wrlink (VBASE ("timeslot_45.1"), VSCRIPT, "1 2")
    _wrlink (VBASE ("timeslot_60.1"), VSCRIPT, "1 2")
#   undef VBASE
    
    /* phone devices settings */
#   define VBASE(x)  "phone_devices." x /* use macro to prevent typos */
    _wrlink (VBASE ("totalElements"), VSCRIPT, "2")
    _wrlink (VBASE ("list"),          VSCRIPT, "1 2")

    /* default configuration */
    _wrlink (VBASE ("id.1"),     	VSCRIPT, "1")
    _wrlink (VBASE ("name.1"),   	VSCRIPT, "analoges Telefon an Tel1")
    _wrlink (VBASE ("number.1"), 	VSCRIPT, "21")
    _wrlink (VBASE ("type.1"),   	VSCRIPT, "analog")
    _wrlink (VBASE ("icon.1"),   	VSCRIPT, "phone-blue")
    _wrlink (VBASE ("stdaccount.1"),   	VSCRIPT, "-1")

    
    _wrlink (VBASE ("id.2"),     	VSCRIPT, "2")
    _wrlink (VBASE ("name.2"),   	VSCRIPT, "analoges Telefon an Tel2")
    _wrlink (VBASE ("number.2"), 	VSCRIPT, "22")
    _wrlink (VBASE ("type.2"),   	VSCRIPT, "analog")
    _wrlink (VBASE ("icon.2"),   	VSCRIPT, "phone-green")
    _wrlink (VBASE ("stdaccount.2"),   	VSCRIPT, "-1")

    /* phone test */
    _vtrig (VBASE ("test"), "phone/phone_test.sh", "notest")
#   undef VBASE
	
    /* quick dial settings */
#   define VBASE(x)  "phone_quickdials." x /* use macro to prevent typos */
    _wrlink (VBASE ("totalElements"), VSCRIPT, "0")
#   undef VBASE

#   define VBASE(x)  "phone_dials_config." x /* use macro to prevent typos */
    _wrlink (VBASE ("totalElements"), VSCRIPT, "0")
#   undef VBASE

    /* phone cdr */
#   define VBASE(x)  "phone_cdr." x /* use macro to prevent typos */
    _vtrig (VBASE ("reset"), "phone/phone_cdr_reset.sh", AV_FALSE)
#   undef VBASE
    
    /* phone auto dial */
#   define VBASE(x)  "phone_autodial." x /* use macro to prevent typos */
    _wrlink (VBASE ("number"), VSCRIPT, "")
#   undef VBASE
		
    /* prefixes for feature codes */
#   define VBASE(x)  "phone_prefix." x /* use macro to prevent typos */
    _wrlink (VBASE ("devices"), 	VSCRIPT, "*")
    _wrlink (VBASE ("accounts"), 	VSCRIPT, "*")
    _wrlink (VBASE ("parking"), 	VSCRIPT, "*")
    _wrlink (VBASE ("dnd"), 		VSCRIPT, "*")
    _wrlink (VBASE ("quickdial"), 	VSCRIPT, "**")
    _wrlink (VBASE ("debug"), 		VSCRIPT, "*")
    _wrlink (VBASE ("autodial"), 	VSCRIPT, "*")
#   undef VBASE


    /* reconfigure */
    _vbtrig (VSCRIPT, "phone/phone_config", "0")
    
    _wrltmpl ("phone_dials", VSCRIPT)
    _wrltmpl ("phone_accounts", VSCRIPT)
    _wrltmpl ("phone_devices", VSCRIPT)
    _wrltmpl ("phone_quickdials", VSCRIPT)
    _wrltmpl ("phone_dials_config", VSCRIPT)
    _wrltmpl ("phone_cdr", VSCRIPT)
    _wrltmpl ("phone_autodial", VSCRIPT)
    _wrltmpl ("phone_sip_proxy", VSCRIPT)
    /* phone_status must not be a trigger */

#undef VSCRIPT



/* tapi settings */
#	define VSCRIPT   "tapi.config_trigger"
#   define VBASE(x)  "phone_tapi." x /* use macro to prevent typos */

    _wrlink (VBASE ("isAct"),    VSCRIPT, "false")
    _wrlink (VBASE ("index"),    VSCRIPT, "1")
    _wrlink (VBASE ("username"), VSCRIPT, "admin")
    _wrlink (VBASE ("passwd"),   VSCRIPT, "admin")

	_vbtrig (VSCRIPT, "phone/phone_tapi", "0")

#   undef VBASE
#	undef VSCRIPT


#endif /* __NVRAM_PHONE_DEFAULTS_H */
