/*
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *   There is no permission to make any digital or printed copies of part or all
 *   of this work without the permission of D-Link.
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * $Id: samba.h 3703 2006-12-05 10:13:59Z roman $
 */


#ifndef __NVRAM_SAMBA_DEFAULTS_H
#define __NVRAM_SAMBA_DEFAULTS_H


/* samba config settings */
#define VBASE(x)  "lan_samba_conf." x /* use macro to prevent typos */
#define VSCRIPT   "samba.config_trigger"
    _avpair (VBASE ("guest"), "nobody")
    _wrlink (VBASE("workgroup"), VSCRIPT, "workgroup")
    _wrlink (VBASE("hasShare") , VSCRIPT, AV_FALSE)
    
    _wrlink (VBASE("shares.totalElements"), VSCRIPT, "0")
    _wrltmpl(VBASE("shares.name") , VSCRIPT)
    _wrltmpl(VBASE("shares.user") , VSCRIPT)
    _wrltmpl(VBASE("shares.mntpoint")   , VSCRIPT)
    _wrltmpl(VBASE("shares.userlabel")  , VSCRIPT)
    _wrltmpl(VBASE("shares.isreadonly") , VSCRIPT)
    _wrltmpl(VBASE("shares.isactive")   , VSCRIPT)
    _wrltmpl(VBASE("shares.isphyactive"), VSCRIPT)
    _vbtrig (VSCRIPT, "lan/lan_config", "1")
#undef VSCRIPT
#undef VBASE

#define VBASE(x)  "lan_usb_storage.dev." x /* use macro to prevent typos */
#define VSCRIPT	  "smbumount.config_trigger"
	_wrltmpl (VBASE ("umount"), VSCRIPT)
	_vtrig (VSCRIPT, "lan/lan_umount.sh", "1")
#undef VSCRIPT
#undef VBASE

#define VBASE(x)  "lan_samba_user." x /* use macro to prevent typos */
#define VSCRIPT   "smbusr.config_trigger"	
    _avpair (VBASE ("denied_user_list"), "root asterisk web lp snmp ssh")
    _avpair (VBASE ("list"), "")
    _wrltmpl (VBASE ("name"),  VSCRIPT)
    _wrltmpl (VBASE ("password"), VSCRIPT)
    _vtrig  (VSCRIPT, "lan/smbusr-config.sh", "1")
#undef VSCRIPT
#undef VBASE

#define VBASE(x)  "hotplug_clean_up." x
    _avolt  (VBASE ("samba"),  AV_FALSE)
#undef VBASE

#define VSCRIPT	  "traffic_policy.config_trigger"
	_wrltmpl ("phone_active_channel", VSCRIPT)
    	_vtrig  (VSCRIPT, "lan/lan_traffic_policy.sh", "1")
#undef VSCRIPT

#endif /* __NVRAM_SAMBA_DEFAULTS_H */
