/*
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *   There is no permission to make any digital or printed copies of part or all
 *   of this work without the permission of D-Link.
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * $Id: vserver.h 2650 2006-06-22 18:03:34Z jordan $
 */


#ifndef __NVRAM_VSERVER_DEFAULTS_H
#define __NVRAM_VSERVER_DEFAULTS_H

#define VBASE(x)  "wan_virtual_rule." x /* use macro to prevent typos */
#define VSCRIPT   VBASE ("setup")

#define FIXRULESET(id,name,proto,port) \
	_avpair (VBASE ("id."        str (id)), str    (id)) \
	_avpair (VBASE ("rulename."  str (id)), str  (name)) \
	_avpair (VBASE ("protocol."  str (id)), str (proto)) \
	_avpair (VBASE ("startport." str (id)), str  (port)) \
	_avpair (VBASE ("endport."   str (id)), str  (port)) \
	_avpair (VBASE ("portmap."   str (id)), str  (port)) \
	_avpair (VBASE ("type."      str (id)), "fix")

    /* Port-Forwarding / Virtual Server */
    _avpair ("wan_virtual_apply.totalElements",  "0")
    
    FIXRULESET (1,    FTP, tcp,  21)
    FIXRULESET (2,   HTTP, tcp,  80)
    FIXRULESET (3,  HTTPS, tcp, 443)
    FIXRULESET (4,    SSH, tcp,  22)
    FIXRULESET (5,   SMTP, tcp,  25)
    FIXRULESET (6,   POP3, tcp, 110)
    FIXRULESET (7, Telnet, tcp,  23)

    _avpair (VBASE ("totalElements"),      "7")
    _avpair (VBASE ("totalFixedElements"), "7")
    _avpair (VBASE ("list"),   "1 2 3 4 5 6 7")

    _wrltmpl(VBASE ("ip."), VSCRIPT)
    _vtrig  (VSCRIPT, "wan/virtual-config.sh", "1")

#undef FIXRULESET
#undef VBASE
#undef VSCRIPT
#endif /* __NVRAM_VSERVER_DEFAULTS_H */
