/*
 * nvramd - active data base server and flash memory cache
 *
 * Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, 5th Floor, Boston, MA 02110-1301 USA
 *
 * Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-Isenburg, Germany
 *
 * $Id: settings.h 3496 2006-10-31 19:08:13Z jordan $
 */

#ifndef __NVRAMD_SETTINGS_H
#define __NVRAMD_SETTINGS_H

/* nvramd.c (main) - 0x0000400 */
#define MAIN_LOG_IDLE_LOOPING     0x0000100 /* log selector flag */
#define MAIN_LOG_INTERRUPT        0x0000200
#define MAIN_IDLE_TIMEOUT               130 /* secs timeout for idle loop */
#define MAIN_LOG_DEFAULTS      (MAIN_LOG_INTERRUPT |\
                                COMM_LOG_DEFLOAD   )

/* comhandler.c */
#define COMM_LOG_DEFLOAD          0x0000800
#define COMM_DEFAULT_LOAD_MODE  (import_flags_ok   |\
                                 import_value_ok   |\
                                 import_trigger_ok )
#define COMM_DEF_LIST_INX_FLAGS "!template_prefix,function_ref"

/* http-server.c */
#define HTTP_CONFIG_PORT        NVCL_HTTP_CONFIG_PORT
#define HTTP_CONFIG_SLOTS                 5 /* listener backlog */
#define HTTP_KEEP_ALIVE         (265 * 3600) /* default: on year seconds */
#define HTTP_MIN_REQBUF                2000
#define HTTP_MAX_REQBUF                5000
#define HTTP_LOG_DEFLOAD          0x0001000
#define HTTP_LOG_CLOSE            0x0002000
#define HTTP_REQUEST_LOG          0x0004000
#define HTTP_REPLY_LOG            0x0008000
// #define HTTP_AUTH_LOG        0x0010000 /* unused */

/* nvram.c */
#define NVCL_MAX_VALUE_SIZE    (NVCL_IOBUF_SIZE - 100)
#define NVCL_REPLY_TMO                10000 /* ms */

/* list.c */
#define LIST_LOG_SYMLINK          0x0020000
#define LIST_LOG_TRIGGER          0x0040000
#define LIST_LOG_TIME2DIE         0x0080000
#define LIST_LOG_AUTOSTORE        0x0100000
#define LIST_LOG_SAVE             0x0200000
#define LIST_LOG_EXEC             0x0400000
#define LIST_LOG_UNAUTH_ACCESS    0x0800000
#define LIST_LOG_FLAG_PARSE_ERROR 0x1000000
#define LIST_LAZY_TRIGGER_WAKE_UP       700 /* ms */
#define LIST_LAZY_NVRAM_COMMIT          600 /* ms */
#define LIST_TRIGGER_LIFE_TIME        10000 /* ms */

/* dsafunctions.c */
#define DSAFUNC_SIGN_SLOTS               10
#define DSAFUNC_SIGN_VARPFX       "dsasign."
#define DSAFUNC_SIGN_RVARLEN              6 /* random part */
#define DSAFUNC_SIGN_LIFETIME         30000 /* ms */

#define DSAFUNC_VFY_SLOTS                 5
#define DSAFUNC_VFY_VARPFX         "dsavfy."
#define DSAFUNC_VFY_RVARLEN              20 /* makes up the challenge */
#define DSAFUNC_VFY_LIFETIME          30000 /* ms */
#define DSAFUNC_VFY_ISOK                "ok"
#define DSAFUNC_VFY_ISFAIL            "fail"

#define DSAFUNC_KEY_SLOTS                 3
#define DSAFUNC_KEY_VARPFX         "dsakey."
#define DSAFUNC_KEY_RVARLEN              20 /* makes up the challenge */
#define DSAFUNC_KEY_LIFETIME          30000 /* ms */

#endif /* __NVRAMD_SETTINGS_H */
