/*
 * Copyright (C) 2003-2005 Maxina GmbH - Henry Margies
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 */

#include <stdio.h>
#include <stdlib.h>


int print_help()
{
	return -1;
}

int main(int nargs, char** argv) 
{
	char name[1024];
	char value[4048];
	int i;
	int export;

	if (nargs < 2) {
		return print_help();
	}

	if (!strcmp(argv[1], "export"))
		export=1;
	else
		export=0;

	while( (i=fscanf(stdin, "%[^=]\n=%[^\n]\n", &name, &value)) > 0) {

		if (i==1) {
			fgetc(stdin);
			continue;
		}
		
		char* p = name;
		while((p=strchr(p, '.')) != NULL)
			*p='_';
		
		p = name;
		while((p=strchr(p, '-')) != NULL)
			*p='_';
		
		if (export)
			printf("export %s=%s\n", name, value);

		setenv(name, value, 1);
	}

	if (export)
		return 0;

	execv(argv[1], argv+1);
	printf("Starting %s %s %s\n", argv[1], argv[1], argv[2]);
	printf("Failed\n");

	return 0;
	
}
