/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/


#ifndef __RCMD_COMMHANDLER_H
#define __RCMD_COMMHANDLER_H

#include "ctrl.h"
#include "shell.h"
#include "filter.h"

/* communication through the control socket */
typedef struct _comm {
#   ifdef __COMHANDLER_PRIVATE
    time_t    started ;
    unsigned  timeout ;
    CTRL        *ctrl ;
    SHELL      *shell ;
    FILTER      *freg ;
#   else
    char          any ;
#   endif
} COMM;


extern COMM *comm_init   (SHELL*,FILTER*);
extern COMM *comm_update (COMM*,CTRL*);

/* unix domain socket commands */
extern void comm_close   (COMM*);
extern void comm_file    (void*,int,const char**);
extern void comm_string  (void*,int,const char**);
extern void comm_status  (void*,int,const char**);
extern void comm_reopen  (void*,int,const char**);
extern void comm_ping    (void*,int,const char**);
extern void comm_flush   (void*,int,const char**);
extern void comm_kpalve  (void*,int,const char**);
extern void comm_tmpl    (void*,int,const char**);
extern void comm_atpl    (void*,int,const char**);
extern void comm_stop    (void*,int,const char**);
extern void comm_redo    (void*,int,const char**);
extern void comm_start   (void*,int,const char**);
extern void comm_replace (void*,int,const char**);
extern void comm_del     (void*,int,const char**);
extern void comm_run     (void*,int,const char**);
extern void comm_list    (void*,int,const char**);
extern void comm_iodump  (void*,int,const char**);

#endif /* __RCMD_COMMHANDLER_H */
