/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany                                                     *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/


#ifndef __VIRTUAL_CONFIG_DEFAULTS_H
#define __VIRTUAL_CONFIG_DEFAULTS_H


/*** virtual-config.sh ***/

{ "virtual-rules", {
    0, /* dynamically set up */
        CM_CLI_ERROR,
        CM_CLI_AGAIN,
        "!^[^>].*OK!",
        "/.*//s" }
},


#define VRULE_U_SHOW_CATRULE_PFX "fdb:settings/categoryU/ruleU${0:-1}/"
#define VRULE_U_SHOW_DATA_PFX    VRULE_U_SHOW_CATRULE_PFX "protocolport"

// /* syntax: virtual-hosts-show <pvc> */
// { "virtual-hosts-show", {
//     CM_CLI_SHOW
// 
//         ("landhcps${0:-0}:status/hostlist\n"
//          "fdb:settings/service/ping/state\n"),
// 
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*fdb:settings/service/ping/state=[0-9]!",
//         "/[0-9]\\s+[^=\\s]*=([[:alnum:]]+)\\s+([0-9.]+)/$1:$2\\n/xg" }
// },

    

// /* syntax: virtual-host-delete <pvc> <pc/alias> */
// { "virtual-host-delete", {
//     CM_CLI_SHOW
// 
//         ("landhcps${0:-0}:command/del=${1:-pc99}\n"
//          "fdb:settings/service/ping/state\n"),
// 
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*fdb:settings/service/ping/state=[0-9]!",
//         "/.*//s" }
// },



// /* syntax: virtual-rules-show <pvc> <ip> */
// { "virtual-rules-show", {
//     CM_CLI_SHOW
// 
//         ("connection${0:-0}:fwan:settings/${1:-0.0.0.0}/rulelist\n"
//          "fdb:settings/service/ping/state\n"),
//         
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*fdb:settings/service/ping/state=[0-9]!",
//         "/[0-9]\\s+[^=\\s]*rulelist=rule([A-Z])([0-9]+)/$1:$2\\n/xg" }
// },

    

// /* syntax: virtual-category-proto */
// { "virtual-category-proto", {
//     0, /* dynamically set up */
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         0,
//         "!"
//             "[0-9]\\s+[^=\\s]+"
//             "/rule([A-Z])([0-9]+)/[[:alnum:]/]+"
//             "=(protocolport)?([[:alnum:]]+)"
//         "!"
//             "$1:$2:$4\\n"
//         "!xg" }
// },



// /* syntax: virtual-category-show <cat> */
// { "virtual-category-show", {
//     CM_CLI_SHOW
// 
//         ("fdb:settings/category${0:-S}/rulelist\n"
//          "fdb:settings/service/ping/state\n"),
// 
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*fdb:settings/service/ping/state=[0-9]!",
//         "/[0-9]\\s+[^=\\s]*rulelist=rule[A-Z]([0-9]+)/$1\\n/xg" }
// },



// /* syntax: virtual-rule-u-setup <num> <proto> <start> <end> <map> <desc> */
// { "virtual-rule-u-setup", {
//     CM_CLI_SHOW
// 
//         (VRULE_U_SHOW_DATA_PFX "1/protocol=${1:-TCP,UDP}\n"
//          VRULE_U_SHOW_DATA_PFX "1/portstart=${2:-1}\n"
//          VRULE_U_SHOW_DATA_PFX "1/portend=${3:-1}\n"
//          VRULE_U_SHOW_DATA_PFX "1/portmap=${4:-1}\n"
//          VRULE_U_SHOW_CATRULE_PFX "description=${5:-no-description}\n"
//          "logic:command/save\n"
//          "fdb:settings/service/ping/state\n"),
//         
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*fdb:settings/service/ping/state=[0-9]!",
//         "/.*//s" }
// },
    


// /* syntax: virtual-newid-show <pvc> */
// { "virtual-newid-show", {
//     CM_CLI_SHOW
// 
//         ("landhcps${0:-0}:settings/add\n"
//          "landhcps${0:-0}:settings/newid\n"),
//         
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*/newid=[[:alnum:]]!",
//         "/[0-9]\\s+[^=\\s]*newid=([[:alnum:]]+)/$1\\n/xg" }
// },



// /* syntax: virtual-id-setup <pvc> <rule-id> <ip> */
// { "virtual-id-setup", {
//     CM_CLI_SHOW
// 
//         ("landhcps${0:-0}:settings/${1:-pc0}/ip=${2:-0.0.0.0}\n"
//          "logic:command/save\n"
//          "fdb:settings/service/ping/state\n"),
//         
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*fdb:settings/service/ping/state=[0-9]!",
//         "/.*//s" }
// },

    

// /* syntax: virtual-newrule-u-show */
// { "virtual-newrule-u-show", {
//     CM_CLI_SHOW
// 
//         ("fdb:settings/categoryU/newrule\n"),
// 
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*/newrule=[[:alnum:]]!",
//         "/[0-9]\\s+[^=\\s]*newrule=([[:alnum:]]+)/$1\\n/xg" }
// },



// /* syntax: virtual-newruleset-u-show <rule-num> */
// { "virtual-newruleset-u-show", {
//     CM_CLI_SHOW
// 
//         ("fdb:settings/categoryU/ruleU${0:-1}/newprotocolport\n"),
//         
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*/newprotocolport=[[:alnum:]]!",
//         "![0-9]\\s+[^=\\s]*=protocolport([0-9]+)!$1\\n!xg" }
// },



// /* syntax: virtual-ruleset-setup <pvc> <ip> <cat> <rule-num> */
// { "virtual-ruleset-setup", {
//     CM_CLI_SHOW
// 
//         ("connection${0:-0}:fwan:command/"
//          "${1:-0.0.0.0}/rule${2:-S}${3:-1}=add\n"
//          "logic:command/save\n"
//          "fdb:settings/service/ping/state\n"),
//                 
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*fdb:settings/service/ping/state=[0-9]!",
//         "/.*//s" }
// },



// /* syntax: virtual-ruleset-ip-delete <pvc> <ip> <rule-cat> <rule-num> */
// { "virtual-ruleset-ip-delete", {
//     CM_CLI_SHOW
// 
//         ("connection${0:-0}:fwan:command/${1:-0.0.0.0}"
//          "/"                        "rule${2:-U}${3:-1}=delete\n"
//          "logic:command/save\n"
//          "fdb:settings/service/ping/state\n"),
//         
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*fdb:settings/service/ping/state=[0-9]!",
//         "/.*//s" }
// },



// /* syntax: virtual-ruleset-u-delete <rule-num> */
// { "virtual-ruleset-u-delete", {
//     CM_CLI_SHOW
// 
//         ("fdb:command/categoryU/ruleU${0:-1}=delete\n"
//          "logic:command/save\n"
//          "fdb:settings/service/ping/state\n"),
//         
//         CM_CLI_ERROR,
//         CM_CLI_AGAIN,
//         "!^[^>].*fdb:settings/service/ping/state=[0-9]!",
//         "/.*//s" }
// },
  

#undef VRULE_U_SHOW_CATRULE_PFX
#undef VRULE_U_SHOW_DATA_PFX
    
#endif /* __VIRTUAL_CONFIG_DEFAULTS_H */
