/*
 * nvtools lib - flash data base support tools
 *
 * Copyright (C) 2003-2006 Maxina GmbH - Jordan Hrycaj <jordan@maxina.de>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, 5th Floor, Boston, MA 02110-1301 USA
 *
 * Ackn: Sources reused from SHAT - Source Hardware Address Translator
 *       Jordan Hrycaj <jordan@mjh.teddy-net.com>
 *
 * $Id: prefix.h 3128 2006-09-01 07:17:15Z jordan $
 */

#ifndef __SHAT_PREFIX_H
#define __SHAT_PREFIX_H

typedef
struct _plst
#ifdef __NVRAM_PREFIX_PRIVATE
{
    HLST          *h ;
    unsigned use8bit ;
    size_t   pfx_len ;
}
#endif
PLST ;

extern PLST *create_plst (unsigned use8bit) ;
extern void   flush_plst (PLST*) ;
extern void destroy_plst (PLST*) ;

/* find the list entry with the longest key that prefixes the
   the argument key */
extern void **find_plst   (PLST*, const char*, size_t);

/* lookup this entry, create a missing one */
extern void **update_plst (PLST*, const char*, size_t);

extern void   remove_plst (PLST*, const char*, size_t);

#endif /* __SHAT_PREFIX_H */
