/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/


#ifndef __RCMD_SETTINGS_H
#define __RCMD_SETTINGS_H

/* rcmdd.c (main) */
#define MAIN_LOG_IDLE_LOOPING  0x000100 /* log selector flag */
#define MAIN_IDLE_TIMEOUT            30 /* secs timeout for idle loop */
#define MAIN_FILE_CMD               "by"
#define MAIN_CLI_CMD                "do"
#define MAIN_RECONN            "restart"
#define MAIN_PING              "contest"
#define MAIN_FLUSH               "flush"
#define MAIN_KPALVE         "keep-alive"
#define MAIN_TEMPL            "template"
#define MAIN_ATEMPL          "+template"
#define MAIN_STOP                 "stop"
#define MAIN_REDO                 "redo"
#define MAIN_FIND               "enable"
#define MAIN_REPLACE           "replace"
#define MAIN_DELETE             "delete"
#define MAIN_RUN                   "run"
#define MAIN_FLIST         "filter-list"
#define MAIN_IODUMP             "iodump"

#define COMM_LOG_DEFLOAD       (MAIN_LOG_IDLE_LOOPING  |\
                                SHELL_LOG_PINGPONG     |\
                                SHELL_LOG_SESSION      |\
                                SHELL_LOG_OPEN_LOG     |\
                                SHELL_LOG_RCSCRIPT_LOG )

#define COMM_LOG_MORE          (COMM_LOG_DEFLOAD       |\
                                SHELL_LOG_TIME2DIE     |\
                                SHELL_LOG_STRIP_REPLY  |\
                                SHELL_LOG_REPLY_DUMP   |\
                                SHELL_LOG_REPLY_STATUS )


/* comhandler.c */
#define COMM_LOG_RERUN         0x000200
#define COMM_LIST_FILE_DEFAULT   "/tmp/rcmd-filter.out"
#define COMM_IODUMP_FILE_DEFAULT "/tmp/rcmd-iodump.out"
#define COMM_WAIT_EREQ_DEFAULT     1500 /* ms */
#define COMM_WAIT_REPLY_DEFAULT    1500 /* ms */
#define COMM_WAIT_RUN_DEFAULT      4500 /* ms */
#define COMM_WAIT_RERUN_MAX       30000 /* ms, will be rounded to secs */
#define COMM_WAIT_RERUN_DELAY       300 /* ms */
#define COMM_WAIT_REREAD_DEFAULT    100 /* ms */

/* ptycall.c */
#define PTY_DUMP_EXECVP        0x001000 /* comment in for hiding */

/* rcmdc.c */
#define RCMD_CTRL_IOBUF_SIZE      2000
#define RCMD_CTRL_REQ_PATH     "/var/run/rcmd/server"
#define RCMD_MAX_VALUE_SIZE    (RCMD_CTRL_IOBUF_SIZE - 100)
#define RCMD_RECV_TIMEOUT        30000 /* ms, will be rounded to secs */
#define RCMD_LONGRECV_TIMEOUT   600000 /* ms, will be rounded to secs */

/* shell.c */
#define SHELL_DIALOGUE_PHRASES "Password:", "(y/n)"
#define SHELL_MAX_FILE_SIZE    (23 * 42 * 11) /* about 10K */
#define SHELL_MAX_RCFILE_SIZE  (23 * 42 * 33) /* about 30K */
#define SHELL_WAIT_HELLO_CONNECT  35000 /* ms */
#define SHELL_WAIT_AFTER_CONNECT    700 /* ms */
#define SHELL_WAIT_AFTER_KILL       700 /* ms */
#define SHELL_WAIT_AFTER_CLOSE      500 /* ms */
#define SHELL_WAIT_SEND_JAM       30000 /* ms */
#define SHELL_WAIT_REPEAT_ECHO_REQ 3000 /* ms, will be rounded to secs */
#define SHELL_WAIT_REDO_ECHO_REQ    700 /* ms */
#define SHELL_INTERNAL_SEND_BLOCK  2048
#define SHELL_INTERNAL_RECV_BLOCK  4096
#define SHELL_INTERNAL_RCV_BUF_SIZE (4 * RCMD_CTRL_IOBUF_SIZE)
#define SHELL_RCLOCAL_TTD         60000 /* ms */
#define SHELL_STRIP_PROMPT         "# "
#define SHELL_DEFAULT_POOL          "."
#define SHELL_SSH_PTY_OPTION       "-t" /* allocate pseudo tty */
#define SHELL_SSH_USER_OPTION      "-l"
#define SHELL_SSH_IDFILE_OPTION    "-i"
#define SHELL_SSH_PORT_OPTION      "-p"
#define SHELL_ECHO_REQUEST_CMD   "echo"
#define SHELL_ECHO_REQUEST_BLOCK_LEN  8 /* number of characters */
#define SHELL_ECHO_REQUEST_BLOCKS     2 /* space delimited */
#define SHELL_KEEP_ALIVE_DEFAULT      1
#define SHELL_LOG_TIME2DIE     0x002000
#define SHELL_LOG_STRIP_REPLY  0x004000
#define SHELL_LOG_REPLY_DUMP   0x008000
#define SHELL_LOG_REPLY_STATUS 0x010000
#define SHELL_LOG_SESSION      0x020000
#define SHELL_LOG_PINGPONG     0x040000
#define SHELL_LOG_OPEN_LOG     0x080000
#define SHELL_LOG_RCSCRIPT_LOG 0x100000

/* filter.c */
#define FILTER_SUBMATCH_DIM    20
#define FILTER_LOG_COUNTERS    0x200000
#define FILTER_LOG_REPLACE     0x400000

#endif /* __RCMD_SETTINGS_H */
