/***************************************************************************
 *   Copyright (C) 2005 by Henry Margies                                   *
 *   henry.margies@gmx.de                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#define CONFIG_EMPTY   0
#define CONFIG_BOOL    1
#define CONFIG_INT     2
#define CONFIG_STRING  3
#define CONFIG_SCRIPT  4
#define CONFIG_IP      5
#define CONFIG_ESA     6
#define CONFIG_NETPORT 7


#define NO_ERROR		0
#define ERROR_NOT_ENOUGH	5
#define ERROR_INVALID_LENGTH	6
#define ERROR_EOF		7
#define ERROR_INVALID_TYPE	8
#define ERROR_UNKNOWN_TYPE	9

#define STRING_SIZE		128
#define SCRIPT_SIZE		512
#define MAX_SIZE ((STRING_SIZE > SCRIPT_SIZE) ? STRING_SIZE : SCRIPT_SIZE)

static int config_value_size[] = { 	0,
				sizeof(int),
				sizeof(int),
				STRING_SIZE,
				SCRIPT_SIZE,
				4,
				8,
				STRING_SIZE };
				

typedef struct {
	unsigned char type;
	unsigned char name_length;
	unsigned char sense;
	unsigned char dependency_length;
} __attribute__((__packed__)) header_t;


int open_mtd_by_name(const char* name, int flags);
int use_tmp_file(int fd, int file_length, int magic);


int mtd_get_int(int fd, int* i);
int mtd_get_bool(int fd, int* b);
int mtd_get_string(int fd, char* dest, int size);
int mtd_get_ip(int fd, unsigned char* ip);
int mtd_get_mac(int fd, unsigned char* mac);


