/***************************************************************************
 *   Copyright (C) 2005 by Henry Margies <h.margies@maxina.de>		   *
 *   			   Sven Kolberg  <s.kolberg@maxina.de>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*
 * ioctl cmds
 */
#define HBX_DSP_IOC_MAGIC 'd'

/* select codec */
#define HBX_DSP_SET_CODEC	_IO(HBX_DSP_IOC_MAGIC, 0x01)

/* configure number of samples in each write */
#define HBX_DSP_SET_SAMPLES	_IO(HBX_DSP_IOC_MAGIC, 0x02)


/**
 * Codecs to use with SET_CODEC
 *
 * usage:
 *  ioctl(fd,HBX_DSP_SET_CODEC, SRC_CODEC(CODEC_LIN) | DST_CODEC(CODEC_GSM));
 */
#define CODEC_LIN		0x0
#define CODEC_GSM		0x1
#define ECHOC_FMT_ALAW		0x2

#define SRC_CODEC(x)		(x & 0xf)
#define DST_CODEC(x)		(x<<3)

#ifdef __KERNEL__
void hbx_dsp_request_ec(int* channel);
void hbx_dsp_release_ec(int* channel);
void hbx_dsp_put_ec(int channel, unsigned char* tx, unsigned char* rx);
void hbx_dsp_get_ec(int channel, unsigned char* tx, unsigned char* rx);
#endif
