/*
 * (C) Copyright 2006
 * Sven Kolberg, Maxina GmbH & Co KG, s.kolberg@maxina.de
 * Henry Margies, Maxina GmbH & Co KG, h.margies@maxina.de
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __HEADER_SPORT_PROTOCOL_H__
#define __HEADER_SPORT_PROTOCOL_H__

/* States of IXP Side (client) */
#define STATE_INIT_COM			0x0
#define STATE_CONNECTED			0x1
#define STATE_FW_UPLOAD			0x2
#define STATE_FW_VERIFY			0x3
#define STATE_FW_COMPLETE		0x4
#define STATE_FW_EXECUTE		0x5

/* The states of the Statemachine, DSP Side (Server) */
#define SPORT_SM_S_IDLE                 0x01
#define SPORT_SM_S_RECEIVE_START        0x02
#define SPORT_SM_S_RECEIVE_CONT         0x03
#define SPORT_SM_S_LOAD_IDLE            0x04

/* Messages send from client to server  */
#define FW_IDLE_QUERY			0x11
#define FW_START			0x12
#define FW_CONT				0x13
#define FW_STOP				0x14
#define FW_LOAD_IDLE			0x15
#define FW_EXEC				0x16

/* Messages send from server to client */
#define FW_IDLE_ACK			0x17
#define FW_START_ACK			0x18
#define FW_CONT_ACK			0x19
#define FW_CRC_OK			0x1a
#define FW_LOAD_IDLE_ACK		0x1b
#define FW_EXEC_ACK			0x1c

#define FW_IDLE_ERROR			0x1d
#define FW_CONT_ERROR			0x1d
#define FW_CRC_ERROR			0x1f
#define FW_START_ERROR			0x20

#define ERROR				0x99

#define LCT_START		0x0d
#define LCT_CONTINUE            0x12
#define LCT_IDLE                0xe0


#define CODEC_CHANNEL_ENABLE 		(1<<6)
#define CODEC_DESTINATION_FORMAT(x)     ((x>>3) & 0x7)
#define CODEC_SOURCE_FORMAT(x)          (x & 0x7)

#define CMGMT_READ      	7
#define CMGMT_WRITE     	8
#define CMGMT_STATUS    	9

#define CMGMT_READ_ACK  	7
#define CMGMT_WRITE_ACK 	8
#define CMGMT_STATUS_ACK 	9
#define CMGMT_UNKNOWN_CMD 	0xf




#endif /* __HEADER_SPORT_PROTOCOL_H__ */


