/***************************************************************************
 *   Copyright (C) 2005 by Henry Margies <h.margies@maxina.de>		   *
 *   			   Sven Kolberg  <s.kolberg@maxina.de>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#define DEVICE_ATTR_UINT(name)						\
static ssize_t hbx_dsp_sysfs_show_##name(struct device *dev, 		\
				struct device_attribute *attr,		\
				char *buf)				\
{									\
	struct hbx_dsp_config* cfg = dev->driver_data;			\
        return snprintf(buf, PAGE_SIZE, "%u\n", cfg->name);		\
}									\
static DEVICE_ATTR(name, S_IRUGO, hbx_dsp_sysfs_show_##name, NULL);

#define DEVICE_ATTR_STRING(name)					\
static ssize_t hbx_dsp_sysfs_show_##name(struct device *dev, 		\
				struct device_attribute *attr,		\
				char *buf)				\
{									\
	struct hbx_dsp_config* cfg = dev->driver_data;			\
        return snprintf(buf, PAGE_SIZE, "%s\n", cfg->name);		\
}									\
static DEVICE_ATTR(name, S_IRUGO, hbx_dsp_sysfs_show_##name, NULL);

DEVICE_ATTR_UINT(initialized);
DEVICE_ATTR_UINT(state);
DEVICE_ATTR_UINT(dsp_version);
DEVICE_ATTR_UINT(fw_version);
DEVICE_ATTR_UINT(pc);
DEVICE_ATTR_UINT(rtt);
DEVICE_ATTR_UINT(err);
DEVICE_ATTR_UINT(tx);
DEVICE_ATTR_UINT(rx);
DEVICE_ATTR_UINT(cmd_ack_err);
DEVICE_ATTR_UINT(c1);
DEVICE_ATTR_UINT(c2);

DEVICE_ATTR_STRING(history);


/**
 *
 */
static void hbx_dsp_sysfs_load(struct device* dev)
{
	device_create_file(dev, &dev_attr_initialized);
	device_create_file(dev, &dev_attr_state);
	device_create_file(dev, &dev_attr_history);
	device_create_file(dev, &dev_attr_rtt);
	device_create_file(dev, &dev_attr_pc);
	device_create_file(dev, &dev_attr_dsp_version);
	device_create_file(dev, &dev_attr_fw_version);
	device_create_file(dev, &dev_attr_err);
	device_create_file(dev, &dev_attr_rx);
	device_create_file(dev, &dev_attr_tx);
	device_create_file(dev, &dev_attr_cmd_ack_err);
	device_create_file(dev, &dev_attr_c1);
	device_create_file(dev, &dev_attr_c2);

}

/**
 *
 */
static void hbx_dsp_sysfs_unload(struct device* dev)
{
	device_remove_file(dev, &dev_attr_initialized);
	device_remove_file(dev, &dev_attr_state);
	device_remove_file(dev, &dev_attr_history);
	device_remove_file(dev, &dev_attr_dsp_version);
	device_remove_file(dev, &dev_attr_fw_version);
	device_remove_file(dev, &dev_attr_rtt);
	device_remove_file(dev, &dev_attr_pc);
	device_remove_file(dev, &dev_attr_err);
	device_remove_file(dev, &dev_attr_rx);
	device_remove_file(dev, &dev_attr_tx);
	device_remove_file(dev, &dev_attr_cmd_ack_err);
	device_remove_file(dev, &dev_attr_c1);
	device_remove_file(dev, &dev_attr_c2);
}

