/*
 * Copyright (C) 2006 Maxina GmbH - Jordan Hrycaj
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 * Author: Jordan Hrycaj <jordan@mjh.teddy.net.com>
 *
 * $Id: logger.h 3108 2006-08-15 13:52:57Z jordan $
 */

#ifndef __SHAT_LOGGER_H
#define __SHAT_LOGGER_H

#ifdef HAVE_STDARG_H
# include <stdarg.h>
#endif
#ifdef HAVE_SYSLOG_H
# include <syslog.h>
#endif

extern void         vlogger  (int level, const char*, va_list);
extern void          logger  (int level, const char*, ...);
extern unsigned syslog_init  (char*, int timestamp);
extern void          rndata  (char*, size_t) ;

extern int logger_errno ;          /* errno when logger() fails */

#endif /* __SHAT_LOGGER_H */
