/*
 * Copyright (C) 2003-2005 Maxina GmbH - Jordan Hrycaj
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 * Author: Jordan Hrycaj <jordan@mjh.teddy.net.com>
 *
 * $Id: settings.h 1802 2006-03-15 17:52:27Z jordan $
 */

#ifndef __STUNC_SETTINGS_H
#define __STUNC_SETTINGS_H

/* stuncd.c (main) */
#define MAIN_LOG_IDLE_LOOPING  0x000100 /* log selector flag */
#define MAIN_IDLE_TIMEOUT            30 /* secs timeout for idle loop */
#define MAIN_CTRL_IOBUF_SIZE       2000
#ifndef USE_LOCAL_REQUEST_FILE
# define MAIN_CTRL_REQ_PATH "/var/run/stunc/server"
#else
# define MAIN_CTRL_REQ_PATH "stunc-server"
#endif

/* comhandler.c */
#define STUN_RESPONSE_TIMEOUT        20
#define SIP_PORT                   5060

/* rfc3489.c */
#define R3489_NVRAM_SVCLIST    "stun_service.list"
#define R3489_NVRAM_PREFIX     "stun_service."
#define R3489_NVRAM_QUERY      ".query"
#define R3489_NVRAM_STATUS     ".status"
#define R3489_NVRAM_MAPPED     ".mapped"
#define R3489_SEND_LOG         0x001000 /* log selector flag */
#define R3489_RESPONSE_LOG     0x002000
#define R3489_AUTOMATIC_LOG    0x004000
#define R3489_TRANSITION_LOG   0x008000

/* device.c */
#define DEFAULT_STUNBOUND     "eth0"
#define STUN_DEFAULT_IP       "192.168.0.241"

/* stun.c */
#define STUN_PORT                  3478
#define STUN_NEWSESSION_LOG    0x010000 /* log selector flag */
#define STUN_MSG_PARSER_LOG    0x020000
#define STUN_TIMEOUT_LOG       0x040000

#endif /* __STUNC_SETTINGS_H */
