#!/bin/sh

set -e


if [ "$1" = "" ]; then
	echo
	echo "Wrong syntax!"
	echo "$0 horst-image-x.x.x.x.x.x.tar.gz"
	echo
	exit 1
fi

if [ ! -r "$1" ]; then
	echo
	echo "File ($1) does not exist."
	echo
	exit 1
fi

file="$1"
name="`basename $file`"
vers="`echo $name | sed -e 's/^horst-image-//' -e 's/\.tar\.gz$//'`"
dir="horst-update-$vers"
zip="$dir.zip"

if [ -d "$dir" ]; then
	echo
	echo "Directoy already there ($dir)"
	echo
	exit 2
fi

if [ -r "$zip" ]; then
	echo
	echo "File already there ($zip)"
	echo
	exit 2
fi

mkdir $dir

tar xfz $file -C $dir
cp 	horst-update/Logo.gif		\
	horst-update/config.txt		\
	horst-update/dlink-header.gif 	\
	horst-update/horst-update.exe 	\
	horst-update/libeay32.dll	\
	horst-update/ssleay32.dll	\
	$dir/

zip -r "$zip" "$dir"
rm -fr $dir
echo "$zip created"
