#/**************************************************************************
#*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
#*                                                                         *
#*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
#*   Isenburg, Germany							  *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#*                                                                         *
#***************************************************************************/

AC_DEFUN([AC_ENABLE_HTTP_GET],[
  AC_ARG_ENABLE([http-get], [AC_HELP_STRING([--enable-http-get],
    [Using experimental http get (html pages will parsed for variables and values)])],
    [case "$enableval" in
     yes) enable_http_get=yes ;;
       *) enable_http_get=no ;;
     esac], [case "$enableval" in *) enable_http_get=no ; esac])
])


AC_DEFUN([AC_DISABLE_COMPAT_MODE],[
  AC_ARG_ENABLE([compat-mode], [AC_HELP_STRING([--disable-compat-mode],
    [Do not provide for compatibilty command line options like "--post-instance" or "-p -ssid"])],
    [case "$enableval" in
      no) disable_compat_mode=yes ;;
       *) disable_compat_mode=no ;;
     esac], [case "$enableval" in *) disable_compat_mode=no ; esac])
])
 
 
AC_DEFUN([AC_CHECK_HTTP_GET],[
  if test y"$enable_http_get" = yyes
  then
     check_http_get=ok
     AC_MSG_CHECKING([whether http GET can be supported])
     for name in get-regex-filter get-wpost-module \
        get-login get-wlan get-addssid get-delssid 
     do
        test -f $name.c -a -f $name.h && continue
        check_http_get=$name
        break
     done
     if test y"$check_http_get" = yok
     then
         AC_MSG_RESULT([yes])
         AC_DEFINE([HTTP_GET_OK], [],
                   [sources are ready for experimental http get])
     else
         AC_MSG_RESULT([$check_http_get module is missing])
     fi
  else
     check_http_get=notavail
  fi
  AM_CONDITIONAL([HTTP_GET_OK], [test y"$check_http_get" = yok])
])


AC_DEFUN([AC_MSG_HTTP_GET],[
  if test y"$check_http_get" = yok
  then
     AC_MSG_NOTICE([Http GET features will be supported])
  else
     AC_MSG_NOTICE([Experimental http GET features will not be supported])
  fi
])


AC_DEFUN([AC_MSG_COMPAT_MODE],[
  if test y"$disable_compat_mode" = yyes
  then
     AC_MSG_NOTICE([Compatibility options have been disabled])
     AC_DEFINE([DISABLE_COMPAT_MODE], [],
               [Binary will not support compatibility options])
  else
     AC_MSG_NOTICE([Binary will support compatibility options])
  fi
])

m4_include([libnvtools/acinclude.m4])
m4_include([libnvram/acinclude.m4])

