/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#ifndef __WPOST_PARAMETERS_H
#define __WPOST_PARAMETERS_H

#include "buffer.h"

typedef
struct _param_map {
    struct _param_alpha {
        const char *var ;
        const char *(*map)(IOBUF*, const char*);
    } alpha ;
    struct _param_nvram {
        const char *var ;
    } nvram ;
} PARAM_MAP ;

#ifndef __WPOST_PARAMETERS_PRIVATE
#define _D(a,b,c) _map_define_ (a, _0)
#define _E(a,b,c) _map_define_ (a, _1)
#define _F(a,b,c) _map_define_ (a, _2)

#include "map-common.h"
#include "map-wlan.h"

#undef _D
#undef _E
#undef _F
#endif

extern PARAM_MAP ap_sttings_wep_auth_type ;

#endif /* __WPOST_PARAMETERS_H */
