/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#ifndef __WPOST_PARSET_H
#define __WPOST_PARSET_H

#include "nvram-lib.h"
#include "http.h"

#ifdef __WPOST_PARSET_PRIVATE
typedef struct _pardata {
    struct {
        const char *module   ;
#       ifdef HTTP_GET_OK /* experimental */
        const char *get_uri  ;
#       endif
        const char *post_uri ;
    } lookup ;
    struct {
        unsigned    (*xtra) (HTDIAL*, const char*);
        unsigned    (*send) (HTDIAL*, const char*);
        const char *(*help) (unsigned,unsigned);
#       ifdef HTTP_GET_OK /* experimental */
        const char *(*getp) (HTDIAL*, const char*);
#       endif
    } post ;
} PARDATA ;
#endif


typedef struct _parset {
#   ifdef __WPOST_PARSET_PRIVATE
    const PARDATA *param ;
    HTDIAL         *http ;
#   ifdef HTTP_GET_OK /* experimental */
    const char  *get_uri ;
#   endif
#   else
    char             any ;
#   endif
} PARSET ;
   

extern void        parset_list      (void(*)(const char*,unsigned));

extern PARSET     *parset_open      (const char*,HTDIAL*);
extern void        parset_close     (PARSET*);

extern const char *parset_posturi   (PARSET*);
extern unsigned    parset_header    (PARSET*);
extern const char *parset_help      (PARSET*, unsigned);
extern unsigned    parset_post_xtra (PARSET*, const char*);
extern unsigned    parset_post_body (PARSET*, const char*);

#ifdef HTTP_GET_OK /* experimental */
extern const char *parset_geturi    (PARSET*);
extern const char *parset_filter    (PARSET*, const char*);
#endif

#endif /* __WPOST_PARSET_H */
