/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#ifndef __WPOST_SET_WPOST_MODULE_H
#define __WPOST_SET_WPOST_MODULE_H

#include "nvram-lib.h"
#include "http.h"
#include "parsets.h"

typedef
enum _htmeth {
    proto_none = 0,
    proto_http,
    proto_https
} HTMETH ;


typedef
struct _module_uri {
    struct {const char *uri; } normalised, raw ;
} MODULE_URI ;

typedef
struct _nvdata {
    NVCL *nv ;
    ip4addr_t   nvserver ;
    unsigned      nvport ;
    unsigned       nvtmo ;
    const char *hostname ;
    const char *port ;
} NVDATA ;

typedef
struct _module {
    const char *name ;
    const char *inst ;
    HTMETH meth ;
    ip4addr_t addr ;
    unsigned port ;
    const char *host ;
    HTDIAL *http ;
    PARSET *set ;
    MODULE_URI post ;
#   ifdef HTTP_GET_OK
    MODULE_URI get ;
#   endif
    NVDATA v ;
} MODULE ;

extern void        wpost_need_nvram    (NVDATA*);
extern const char *wpost_normalise_uri (MODULE_URI*,MODULE*,const char*);
extern unsigned    wpost_http_request  (HTDIAL*,MODULE_URI*,const char*);
extern int         wpost_http_response (HTDIAL*,MODULE_URI*,const char*);
extern int         wpost_module_set    (MODULE*,MODULE_URI*,int);

#endif /* __WPOST_SET_WPOST_MODULE_H */
