/**************************************************************************
*   Copyright (C) 2006 - D-Link (Europe) Ltd., London, UK                 *
*                                                                         *
*   Author: Jordan Hrycaj <jordan@maxina.de> - Maxina GmbH, Neu-          *
*   Isenburg, Germany							  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                         *
***************************************************************************/



#ifndef __WPOST_SETTINGS_H
#define __WPOST_SETTINGS_H

/* wpost.c (main) */
#define MAIN_XPOST_FAIL_REPEAT          2
#define MAIN_WAIT_AFTER_XFAIL         700 /* ms */

/* http.c */
#define HTTP_LOG_SEND_DUMP     0x00000200
#define HTTP_LOG_RECV_DUMP     0x00000400
#define HTTP_READ_BLOCK         (1024 * 4)
#define HTTP_READ_WAIT_FIRST        10000 /* ms */
#define HTTP_READ_WAIT_MORE             5 /* ms */
#define HTTP_READ_MAX_ZERO              2 /* zero reads before eof */

/* parsets.c */
#define PARSET_HELP_FF                 15 /* format length */

/* get-regex-filter.c */
#define FILTER_LOG_COMP_ERROR  0x00001000
#define FILTER_LOG_APPLY       0x00002000
#define FILTER_LOG_MATCHES     0x00004000
#define FILTER_LOG_NO_MATCHES  0x00008000
#define FILTER_PRINT_ALL       0x00010000

/* set-wpost-module.c */
#define WPOST_NVDEF_TIMEOUT            10 /* ms, #undef for default */
#define WPOST_NVDEF_HOSTNAME  "net.cm.htServer"
#define WPOST_NVDEF_PORT      "net.cm.htPort"
#define WPOST_LOG_HTTP_PCONN   0x00100000
#define WPOST_LOG_HTTP_REQU    0x00200000
#define WPOST_LOG_HTTP_REQURPT 0x00400000
#define WPOST_LOG_HTTP_REPLY   0x00800000
#define WPOST_LOG_HTTP_RDATA   0x01000000
#define WPOST_LOG_POST_URL     0x02000000

/* get-wpost-module.c */
#define WPOST_MAX_GET_RETRIES  35
#define WPOST_MIN_RETRY_DELAY  200 /* ms */
#define WPOST_INC_RETRY_DELAY  150 /* ms */
#define WPOST_MAX_RETRY_DELAY 1200 /* ms */
#define WPOST_LOG_HTTP_GCONN   0x04000000
#define WPOST_LOG_LOGIN_URL    0x08000000
#define WPOST_LOG_GET_URL      0x10000000

#endif /* __WPOST_SETTINGS_H */
